/* x86/linux lburg spec. Derived from x86.md by
Marcos Ramirez <marcos@inf.utfsm.cl>
Horst von Brand <vonbrand@sleipnir.valparaiso.cl>
Jacob Navia <jacob@jacob.remcomp.fr>
*/
enum { EAX=0, ECX=1, EDX=2, EBX=3, ESI=6, EDI=7 };
#include "c.h"
#define NODEPTR_TYPE Node
#define OP_LABEL(p) ((p)->op)
#define LEFT_CHILD(p) ((p)->kids[0])
#define RIGHT_CHILD(p) ((p)->kids[1])
#define STATE_LABEL(p) ((p)->x.state)
extern int ckstack(Node, int);
extern int memop(Node);
extern int sametree(Node, Node);
static Symbol charreg[32], shortreg[32], intreg[32];
static Symbol fltreg[32];

static Symbol charregw, shortregw, intregw, fltregw;

static int cseg;

static Symbol quo, rem;

extern char *stabprefix;
extern void stabblock(int, int, Symbol*);
extern void stabend(Coordinate *, Symbol, Coordinate **, Symbol *, Symbol *);
extern void stabfend(Symbol, int);
extern void stabinit(char *, int, char *[]);
extern void stabline(Coordinate *);
extern void stabsym(Symbol);
extern void stabtype(Symbol);

static int pflag = 0;
static char rcsid[] = "$Id: x86linux.md,v 1.1 2002/08/28 23:12:48 drh Exp $";

#define hasargs(p) (p->syms[0] && p->syms[0]->u.c.v.i > 0 ? 0 : LBURG_MAX)
/*
generated at Sun May  4 16:20:36 2008
by $Id: lburg.c,v 2.10 2002/03/08 18:45:21 drh Exp $
*/
static void _kids(NODEPTR_TYPE, int, NODEPTR_TYPE[]);
static void _label(NODEPTR_TYPE);
static int _rule(void*, int);

#define _stmt_NT 1
#define _reg_NT 2
#define _freg_NT 3
#define _cnst_NT 4
#define _con_NT 5
#define _acon_NT 6
#define _baseaddr_NT 7
#define _base_NT 8
#define _index_NT 9
#define _con1_NT 10
#define _con2_NT 11
#define _con3_NT 12
#define _con0_NT 13
#define _addr_NT 14
#define _mem1_NT 15
#define _mem2_NT 16
#define _mem4_NT 17
#define _rc_NT 18
#define _mr_NT 19
#define _mr1_NT 20
#define _mr2_NT 21
#define _mrc_NT 22
#define _rc5_NT 23
#define _mrca_NT 24
#define _memf_NT 25
#define _flt_NT 26
#define _flt2_NT 27
#define _addrj_NT 28
#define _cmpf_NT 29
#define _burm0_NT 30
#define _burm1_NT 31
#define _burm2_NT 32
#define _burm3_NT 33
#define _burm4_NT 34
#define _burm5_NT 35
#define _burm6_NT 36
#define _burm7_NT 37
#define _burm8_NT 38
#define _burm9_NT 39
#define _burm10_NT 40
#define _burm11_NT 41
#define _burm12_NT 42
#define _burm13_NT 43
#define _burm14_NT 44
#define _burm15_NT 45
#define _burm16_NT 46
#define _burm17_NT 47
#define _burm18_NT 48
#define _burm19_NT 49
#define _burm20_NT 50
#define _burm21_NT 51
#define _burm22_NT 52
#define _burm23_NT 53
#define _burm24_NT 54
#define _burm25_NT 55
#define _burm26_NT 56
#define _burm27_NT 57
#define _burm28_NT 58
#define _burm29_NT 59
#define _burm30_NT 60
#define _burm31_NT 61
#define _burm32_NT 62
#define _burm33_NT 63
#define _burm34_NT 64
#define _burm35_NT 65
#define _burm36_NT 66
#define _burm37_NT 67
#define _burm38_NT 68
#define _burm39_NT 69
#define _burm40_NT 70
#define _burm41_NT 71
#define _burm42_NT 72

static char *_ntname[] = {
	0,
	"stmt",
	"reg",
	"freg",
	"cnst",
	"con",
	"acon",
	"baseaddr",
	"base",
	"index",
	"con1",
	"con2",
	"con3",
	"con0",
	"addr",
	"mem1",
	"mem2",
	"mem4",
	"rc",
	"mr",
	"mr1",
	"mr2",
	"mrc",
	"rc5",
	"mrca",
	"memf",
	"flt",
	"flt2",
	"addrj",
	"cmpf",
	"burm0",
	"burm1",
	"burm2",
	"burm3",
	"burm4",
	"burm5",
	"burm6",
	"burm7",
	"burm8",
	"burm9",
	"burm10",
	"burm11",
	"burm12",
	"burm13",
	"burm14",
	"burm15",
	"burm16",
	"burm17",
	"burm18",
	"burm19",
	"burm20",
	"burm21",
	"burm22",
	"burm23",
	"burm24",
	"burm25",
	"burm26",
	"burm27",
	"burm28",
	"burm29",
	"burm30",
	"burm31",
	"burm32",
	"burm33",
	"burm34",
	"burm35",
	"burm36",
	"burm37",
	"burm38",
	"burm39",
	"burm40",
	"burm41",
	"burm42",
	0
};

struct _state {
	short cost[73];
	struct {
		unsigned int _stmt:7;
		unsigned int _reg:7;
		unsigned int _freg:6;
		unsigned int _cnst:4;
		unsigned int _con:1;
		unsigned int _acon:2;
		unsigned int _baseaddr:1;
		unsigned int _base:3;
		unsigned int _index:3;
		unsigned int _con1:2;
		unsigned int _con2:2;
		unsigned int _con3:2;
		unsigned int _con0:2;
		unsigned int _addr:4;
		unsigned int _mem1:2;
		unsigned int _mem2:2;
		unsigned int _mem4:2;
		unsigned int _rc:2;
		unsigned int _mr:2;
		unsigned int _mr1:2;
		unsigned int _mr2:2;
		unsigned int _mrc:3;
		unsigned int _rc5:2;
		unsigned int _mrca:3;
		unsigned int _memf:3;
		unsigned int _flt:2;
		unsigned int _flt2:2;
		unsigned int _addrj:2;
		unsigned int _cmpf:3;
		unsigned int _burm0:1;
		unsigned int _burm1:1;
		unsigned int _burm2:1;
		unsigned int _burm3:1;
		unsigned int _burm4:1;
		unsigned int _burm5:1;
		unsigned int _burm6:1;
		unsigned int _burm7:1;
		unsigned int _burm8:1;
		unsigned int _burm9:1;
		unsigned int _burm10:1;
		unsigned int _burm11:1;
		unsigned int _burm12:1;
		unsigned int _burm13:1;
		unsigned int _burm14:1;
		unsigned int _burm15:1;
		unsigned int _burm16:1;
		unsigned int _burm17:1;
		unsigned int _burm18:1;
		unsigned int _burm19:1;
		unsigned int _burm20:1;
		unsigned int _burm21:1;
		unsigned int _burm22:1;
		unsigned int _burm23:1;
		unsigned int _burm24:1;
		unsigned int _burm25:1;
		unsigned int _burm26:1;
		unsigned int _burm27:1;
		unsigned int _burm28:1;
		unsigned int _burm29:1;
		unsigned int _burm30:1;
		unsigned int _burm31:1;
		unsigned int _burm32:1;
		unsigned int _burm33:1;
		unsigned int _burm34:1;
		unsigned int _burm35:1;
		unsigned int _burm36:1;
		unsigned int _burm37:1;
		unsigned int _burm38:1;
		unsigned int _burm39:1;
		unsigned int _burm40:1;
		unsigned int _burm41:1;
		unsigned int _burm42:1;
	} rule;
	int id;
};

static short _nts_0[] = { _burm0_NT, 0 };
static short _nts_1[] = { _burm0_NT, _reg_NT, 0 };
static short _nts_2[] = { 0 };
static short _nts_3[] = { _cnst_NT, 0 };
static short _nts_4[] = { _reg_NT, 0 };
static short _nts_5[] = { _freg_NT, 0 };
static short _nts_6[] = { _reg_NT, _acon_NT, 0 };
static short _nts_7[] = { _reg_NT, _con1_NT, 0 };
static short _nts_8[] = { _reg_NT, _con2_NT, 0 };
static short _nts_9[] = { _reg_NT, _con3_NT, 0 };
static short _nts_10[] = { _base_NT, 0 };
static short _nts_11[] = { _baseaddr_NT, 0 };
static short _nts_12[] = { _index_NT, _baseaddr_NT, 0 };
static short _nts_13[] = { _reg_NT, _baseaddr_NT, 0 };
static short _nts_14[] = { _index_NT, _reg_NT, 0 };
static short _nts_15[] = { _index_NT, 0 };
static short _nts_16[] = { _addr_NT, 0 };
static short _nts_17[] = { _con_NT, 0 };
static short _nts_18[] = { _mem4_NT, 0 };
static short _nts_19[] = { _mem1_NT, 0 };
static short _nts_20[] = { _mem2_NT, 0 };
static short _nts_21[] = { _rc_NT, 0 };
static short _nts_22[] = { _mr_NT, 0 };
static short _nts_23[] = { _mr1_NT, 0 };
static short _nts_24[] = { _mr2_NT, 0 };
static short _nts_25[] = { _reg_NT, _mrc_NT, 0 };
static short _nts_26[] = { _addr_NT, _burm1_NT, 0 };
static short _nts_27[] = { _addr_NT, _burm2_NT, 0 };
static short _nts_28[] = { _addr_NT, _burm3_NT, 0 };
static short _nts_29[] = { _addr_NT, _burm4_NT, 0 };
static short _nts_30[] = { _addr_NT, _burm5_NT, 0 };
static short _nts_31[] = { _addr_NT, _burm6_NT, 0 };
static short _nts_32[] = { _addr_NT, _burm7_NT, 0 };
static short _nts_33[] = { _addr_NT, _burm8_NT, 0 };
static short _nts_34[] = { _addr_NT, _burm9_NT, 0 };
static short _nts_35[] = { _addr_NT, _burm10_NT, 0 };
static short _nts_36[] = { _addr_NT, _burm11_NT, 0 };
static short _nts_37[] = { _addr_NT, _burm12_NT, 0 };
static short _nts_38[] = { _addr_NT, _burm13_NT, 0 };
static short _nts_39[] = { _addr_NT, _burm14_NT, 0 };
static short _nts_40[] = { _addr_NT, _burm15_NT, 0 };
static short _nts_41[] = { _addr_NT, _burm16_NT, 0 };
static short _nts_42[] = { _addr_NT, _burm17_NT, 0 };
static short _nts_43[] = { _addr_NT, _burm18_NT, 0 };
static short _nts_44[] = { _addr_NT, _burm19_NT, 0 };
static short _nts_45[] = { _reg_NT, _rc5_NT, 0 };
static short _nts_46[] = { _addr_NT, _burm20_NT, 0 };
static short _nts_47[] = { _addr_NT, _burm21_NT, 0 };
static short _nts_48[] = { _addr_NT, _burm22_NT, 0 };
static short _nts_49[] = { _addr_NT, _burm23_NT, 0 };
static short _nts_50[] = { _con_NT, _mr_NT, 0 };
static short _nts_51[] = { _reg_NT, _mr_NT, 0 };
static short _nts_52[] = { _reg_NT, _reg_NT, 0 };
static short _nts_53[] = { _burm24_NT, 0 };
static short _nts_54[] = { _burm25_NT, 0 };
static short _nts_55[] = { _burm26_NT, 0 };
static short _nts_56[] = { _burm27_NT, 0 };
static short _nts_57[] = { _addr_NT, _rc_NT, 0 };
static short _nts_58[] = { _mrca_NT, 0 };
static short _nts_59[] = { _reg_NT, _burm28_NT, 0 };
static short _nts_60[] = { _burm28_NT, 0 };
static short _nts_61[] = { _burm29_NT, 0 };
static short _nts_62[] = { _burm30_NT, 0 };
static short _nts_63[] = { _memf_NT, 0 };
static short _nts_64[] = { _addr_NT, _freg_NT, 0 };
static short _nts_65[] = { _addr_NT, _burm31_NT, 0 };
static short _nts_66[] = { _freg_NT, _flt_NT, 0 };
static short _nts_67[] = { _freg_NT, _flt2_NT, 0 };
static short _nts_68[] = { _burm32_NT, 0 };
static short _nts_69[] = { _addrj_NT, 0 };
static short _nts_70[] = { _mem4_NT, _rc_NT, 0 };
static short _nts_71[] = { _burm33_NT, _con0_NT, 0 };
static short _nts_72[] = { _burm34_NT, _con0_NT, 0 };
static short _nts_73[] = { _burm35_NT, _con0_NT, 0 };
static short _nts_74[] = { _burm36_NT, _con0_NT, 0 };
static short _nts_75[] = { _cmpf_NT, _freg_NT, 0 };
static short _nts_76[] = { _freg_NT, _burm37_NT, 0 };
static short _nts_77[] = { _burm37_NT, _freg_NT, 0 };
static short _nts_78[] = { _freg_NT, _burm38_NT, 0 };
static short _nts_79[] = { _burm38_NT, _freg_NT, 0 };
static short _nts_80[] = { _freg_NT, _burm39_NT, 0 };
static short _nts_81[] = { _mem4_NT, _con1_NT, 0 };
static short _nts_82[] = { _mem4_NT, _rc5_NT, 0 };
static short _nts_83[] = { _mr_NT, _con_NT, 0 };
static short _nts_84[] = { _burm40_NT, _con_NT, 0 };
static short _nts_85[] = { _burm41_NT, _con_NT, 0 };
static short _nts_86[] = { _burm42_NT, _con_NT, 0 };
static short _nts_87[] = { _burm40_NT, 0 };

static short *_nts[] = {
	0,	/* 0 */
	_nts_0,	/* 1 */
	_nts_0,	/* 2 */
	_nts_0,	/* 3 */
	_nts_0,	/* 4 */
	_nts_0,	/* 5 */
	_nts_0,	/* 6 */
	_nts_0,	/* 7 */
	_nts_0,	/* 8 */
	_nts_0,	/* 9 */
	_nts_0,	/* 10 */
	_nts_0,	/* 11 */
	_nts_0,	/* 12 */
	_nts_1,	/* 13 */
	_nts_1,	/* 14 */
	_nts_1,	/* 15 */
	_nts_1,	/* 16 */
	_nts_1,	/* 17 */
	_nts_1,	/* 18 */
	_nts_1,	/* 19 */
	_nts_1,	/* 20 */
	_nts_1,	/* 21 */
	_nts_1,	/* 22 */
	_nts_1,	/* 23 */
	_nts_1,	/* 24 */
	_nts_2,	/* 25 */
	_nts_2,	/* 26 */
	_nts_2,	/* 27 */
	_nts_2,	/* 28 */
	_nts_2,	/* 29 */
	_nts_2,	/* 30 */
	_nts_2,	/* 31 */
	_nts_2,	/* 32 */
	_nts_2,	/* 33 */
	_nts_2,	/* 34 */
	_nts_3,	/* 35 */
	_nts_4,	/* 36 */
	_nts_5,	/* 37 */
	_nts_2,	/* 38 */
	_nts_2,	/* 39 */
	_nts_3,	/* 40 */
	_nts_2,	/* 41 */
	_nts_4,	/* 42 */
	_nts_6,	/* 43 */
	_nts_6,	/* 44 */
	_nts_6,	/* 45 */
	_nts_2,	/* 46 */
	_nts_2,	/* 47 */
	_nts_4,	/* 48 */
	_nts_7,	/* 49 */
	_nts_8,	/* 50 */
	_nts_9,	/* 51 */
	_nts_7,	/* 52 */
	_nts_8,	/* 53 */
	_nts_9,	/* 54 */
	_nts_2,	/* 55 */
	_nts_2,	/* 56 */
	_nts_2,	/* 57 */
	_nts_2,	/* 58 */
	_nts_2,	/* 59 */
	_nts_2,	/* 60 */
	_nts_2,	/* 61 */
	_nts_2,	/* 62 */
	_nts_10,	/* 63 */
	_nts_11,	/* 64 */
	_nts_12,	/* 65 */
	_nts_12,	/* 66 */
	_nts_12,	/* 67 */
	_nts_13,	/* 68 */
	_nts_13,	/* 69 */
	_nts_13,	/* 70 */
	_nts_14,	/* 71 */
	_nts_14,	/* 72 */
	_nts_14,	/* 73 */
	_nts_15,	/* 74 */
	_nts_16,	/* 75 */
	_nts_16,	/* 76 */
	_nts_16,	/* 77 */
	_nts_16,	/* 78 */
	_nts_16,	/* 79 */
	_nts_16,	/* 80 */
	_nts_16,	/* 81 */
	_nts_4,	/* 82 */
	_nts_17,	/* 83 */
	_nts_4,	/* 84 */
	_nts_18,	/* 85 */
	_nts_4,	/* 86 */
	_nts_19,	/* 87 */
	_nts_4,	/* 88 */
	_nts_20,	/* 89 */
	_nts_18,	/* 90 */
	_nts_19,	/* 91 */
	_nts_20,	/* 92 */
	_nts_21,	/* 93 */
	_nts_16,	/* 94 */
	_nts_22,	/* 95 */
	_nts_23,	/* 96 */
	_nts_24,	/* 97 */
	_nts_17,	/* 98 */
	_nts_4,	/* 99 */
	_nts_4,	/* 100 */
	_nts_4,	/* 101 */
	_nts_4,	/* 102 */
	_nts_4,	/* 103 */
	_nts_4,	/* 104 */
	_nts_4,	/* 105 */
	_nts_25,	/* 106 */
	_nts_25,	/* 107 */
	_nts_25,	/* 108 */
	_nts_25,	/* 109 */
	_nts_25,	/* 110 */
	_nts_25,	/* 111 */
	_nts_25,	/* 112 */
	_nts_25,	/* 113 */
	_nts_25,	/* 114 */
	_nts_25,	/* 115 */
	_nts_25,	/* 116 */
	_nts_25,	/* 117 */
	_nts_26,	/* 118 */
	_nts_27,	/* 119 */
	_nts_28,	/* 120 */
	_nts_29,	/* 121 */
	_nts_30,	/* 122 */
	_nts_31,	/* 123 */
	_nts_32,	/* 124 */
	_nts_33,	/* 125 */
	_nts_34,	/* 126 */
	_nts_35,	/* 127 */
	_nts_36,	/* 128 */
	_nts_37,	/* 129 */
	_nts_38,	/* 130 */
	_nts_39,	/* 131 */
	_nts_40,	/* 132 */
	_nts_41,	/* 133 */
	_nts_4,	/* 134 */
	_nts_4,	/* 135 */
	_nts_4,	/* 136 */
	_nts_42,	/* 137 */
	_nts_43,	/* 138 */
	_nts_44,	/* 139 */
	_nts_45,	/* 140 */
	_nts_45,	/* 141 */
	_nts_45,	/* 142 */
	_nts_45,	/* 143 */
	_nts_46,	/* 144 */
	_nts_47,	/* 145 */
	_nts_48,	/* 146 */
	_nts_49,	/* 147 */
	_nts_2,	/* 148 */
	_nts_4,	/* 149 */
	_nts_25,	/* 150 */
	_nts_50,	/* 151 */
	_nts_51,	/* 152 */
	_nts_52,	/* 153 */
	_nts_52,	/* 154 */
	_nts_52,	/* 155 */
	_nts_52,	/* 156 */
	_nts_4,	/* 157 */
	_nts_4,	/* 158 */
	_nts_53,	/* 159 */
	_nts_54,	/* 160 */
	_nts_55,	/* 161 */
	_nts_56,	/* 162 */
	_nts_4,	/* 163 */
	_nts_4,	/* 164 */
	_nts_4,	/* 165 */
	_nts_4,	/* 166 */
	_nts_4,	/* 167 */
	_nts_4,	/* 168 */
	_nts_4,	/* 169 */
	_nts_4,	/* 170 */
	_nts_18,	/* 171 */
	_nts_21,	/* 172 */
	_nts_2,	/* 173 */
	_nts_2,	/* 174 */
	_nts_57,	/* 175 */
	_nts_57,	/* 176 */
	_nts_57,	/* 177 */
	_nts_57,	/* 178 */
	_nts_57,	/* 179 */
	_nts_57,	/* 180 */
	_nts_57,	/* 181 */
	_nts_58,	/* 182 */
	_nts_58,	/* 183 */
	_nts_58,	/* 184 */
	_nts_59,	/* 185 */
	_nts_60,	/* 186 */
	_nts_16,	/* 187 */
	_nts_16,	/* 188 */
	_nts_61,	/* 189 */
	_nts_62,	/* 190 */
	_nts_63,	/* 191 */
	_nts_64,	/* 192 */
	_nts_64,	/* 193 */
	_nts_65,	/* 194 */
	_nts_5,	/* 195 */
	_nts_5,	/* 196 */
	_nts_5,	/* 197 */
	_nts_5,	/* 198 */
	_nts_63,	/* 199 */
	_nts_5,	/* 200 */
	_nts_63,	/* 201 */
	_nts_5,	/* 202 */
	_nts_66,	/* 203 */
	_nts_66,	/* 204 */
	_nts_67,	/* 205 */
	_nts_67,	/* 206 */
	_nts_66,	/* 207 */
	_nts_66,	/* 208 */
	_nts_67,	/* 209 */
	_nts_67,	/* 210 */
	_nts_5,	/* 211 */
	_nts_5,	/* 212 */
	_nts_5,	/* 213 */
	_nts_68,	/* 214 */
	_nts_4,	/* 215 */
	_nts_68,	/* 216 */
	_nts_4,	/* 217 */
	_nts_2,	/* 218 */
	_nts_4,	/* 219 */
	_nts_18,	/* 220 */
	_nts_2,	/* 221 */
	_nts_69,	/* 222 */
	_nts_70,	/* 223 */
	_nts_70,	/* 224 */
	_nts_70,	/* 225 */
	_nts_70,	/* 226 */
	_nts_70,	/* 227 */
	_nts_70,	/* 228 */
	_nts_70,	/* 229 */
	_nts_70,	/* 230 */
	_nts_70,	/* 231 */
	_nts_70,	/* 232 */
	_nts_25,	/* 233 */
	_nts_25,	/* 234 */
	_nts_25,	/* 235 */
	_nts_25,	/* 236 */
	_nts_25,	/* 237 */
	_nts_25,	/* 238 */
	_nts_25,	/* 239 */
	_nts_25,	/* 240 */
	_nts_25,	/* 241 */
	_nts_25,	/* 242 */
	_nts_25,	/* 243 */
	_nts_25,	/* 244 */
	_nts_71,	/* 245 */
	_nts_71,	/* 246 */
	_nts_72,	/* 247 */
	_nts_72,	/* 248 */
	_nts_73,	/* 249 */
	_nts_73,	/* 250 */
	_nts_74,	/* 251 */
	_nts_16,	/* 252 */
	_nts_16,	/* 253 */
	_nts_61,	/* 254 */
	_nts_5,	/* 255 */
	_nts_75,	/* 256 */
	_nts_75,	/* 257 */
	_nts_75,	/* 258 */
	_nts_75,	/* 259 */
	_nts_75,	/* 260 */
	_nts_75,	/* 261 */
	_nts_75,	/* 262 */
	_nts_75,	/* 263 */
	_nts_75,	/* 264 */
	_nts_75,	/* 265 */
	_nts_75,	/* 266 */
	_nts_75,	/* 267 */
	_nts_76,	/* 268 */
	_nts_77,	/* 269 */
	_nts_78,	/* 270 */
	_nts_79,	/* 271 */
	_nts_76,	/* 272 */
	_nts_78,	/* 273 */
	_nts_76,	/* 274 */
	_nts_77,	/* 275 */
	_nts_78,	/* 276 */
	_nts_79,	/* 277 */
	_nts_76,	/* 278 */
	_nts_78,	/* 279 */
	_nts_80,	/* 280 */
	_nts_80,	/* 281 */
	_nts_80,	/* 282 */
	_nts_80,	/* 283 */
	_nts_63,	/* 284 */
	_nts_69,	/* 285 */
	_nts_69,	/* 286 */
	_nts_69,	/* 287 */
	_nts_69,	/* 288 */
	_nts_69,	/* 289 */
	_nts_69,	/* 290 */
	_nts_69,	/* 291 */
	_nts_69,	/* 292 */
	_nts_69,	/* 293 */
	_nts_69,	/* 294 */
	_nts_69,	/* 295 */
	_nts_69,	/* 296 */
	_nts_69,	/* 297 */
	_nts_69,	/* 298 */
	_nts_69,	/* 299 */
	_nts_69,	/* 300 */
	_nts_4,	/* 301 */
	_nts_4,	/* 302 */
	_nts_4,	/* 303 */
	_nts_5,	/* 304 */
	_nts_5,	/* 305 */
	_nts_2,	/* 306 */
	_nts_81,	/* 307 */
	_nts_81,	/* 308 */
	_nts_81,	/* 309 */
	_nts_81,	/* 310 */
	_nts_81,	/* 311 */
	_nts_81,	/* 312 */
	_nts_70,	/* 313 */
	_nts_70,	/* 314 */
	_nts_70,	/* 315 */
	_nts_70,	/* 316 */
	_nts_70,	/* 317 */
	_nts_70,	/* 318 */
	_nts_70,	/* 319 */
	_nts_70,	/* 320 */
	_nts_70,	/* 321 */
	_nts_70,	/* 322 */
	_nts_18,	/* 323 */
	_nts_18,	/* 324 */
	_nts_18,	/* 325 */
	_nts_82,	/* 326 */
	_nts_82,	/* 327 */
	_nts_82,	/* 328 */
	_nts_82,	/* 329 */
	_nts_16,	/* 330 */
	_nts_16,	/* 331 */
	_nts_16,	/* 332 */
	_nts_16,	/* 333 */
	_nts_4,	/* 334 */
	_nts_16,	/* 335 */
	_nts_16,	/* 336 */
	_nts_5,	/* 337 */
	_nts_16,	/* 338 */
	_nts_83,	/* 339 */
	_nts_84,	/* 340 */
	_nts_85,	/* 341 */
	_nts_86,	/* 342 */
	_nts_68,	/* 343 */
	_nts_87,	/* 344 */
	_nts_61,	/* 345 */
	_nts_54,	/* 346 */
	_nts_54,	/* 347 */
	_nts_53,	/* 348 */
};

static char *_templates[] = {
/* 0 */	0,
/* 1 */	"# read register\n",	/* reg: INDIRI1(burm0) */
/* 2 */	"# read register\n",	/* reg: INDIRU1(burm0) */
/* 3 */	"# read register\n",	/* reg: INDIRI2(burm0) */
/* 4 */	"# read register\n",	/* reg: INDIRU2(burm0) */
/* 5 */	"# read register\n",	/* reg: INDIRI4(burm0) */
/* 6 */	"# read register\n",	/* reg: INDIRP4(burm0) */
/* 7 */	"# read register\n",	/* reg: INDIRU4(burm0) */
/* 8 */	"# read register\n",	/* reg: INDIRI8(burm0) */
/* 9 */	"# read register\n",	/* reg: INDIRP8(burm0) */
/* 10 */	"# read register\n",	/* reg: INDIRU8(burm0) */
/* 11 */	"# read register\n",	/* freg: INDIRF4(burm0) */
/* 12 */	"# read register\n",	/* freg: INDIRF8(burm0) */
/* 13 */	"# write register\n",	/* stmt: ASGNI1(burm0,reg) */
/* 14 */	"# write register\n",	/* stmt: ASGNU1(burm0,reg) */
/* 15 */	"# write register\n",	/* stmt: ASGNI2(burm0,reg) */
/* 16 */	"# write register\n",	/* stmt: ASGNU2(burm0,reg) */
/* 17 */	"# write register\n",	/* stmt: ASGNF4(burm0,reg) */
/* 18 */	"# write register\n",	/* stmt: ASGNI4(burm0,reg) */
/* 19 */	"# write register\n",	/* stmt: ASGNP4(burm0,reg) */
/* 20 */	"# write register\n",	/* stmt: ASGNU4(burm0,reg) */
/* 21 */	"# write register\n",	/* stmt: ASGNF8(burm0,reg) */
/* 22 */	"# write register\n",	/* stmt: ASGNI8(burm0,reg) */
/* 23 */	"# write register\n",	/* stmt: ASGNP8(burm0,reg) */
/* 24 */	"# write register\n",	/* stmt: ASGNU8(burm0,reg) */
/* 25 */	"%a",	/* cnst: CNSTI1 */
/* 26 */	"%a",	/* cnst: CNSTU1 */
/* 27 */	"%a",	/* cnst: CNSTI2 */
/* 28 */	"%a",	/* cnst: CNSTU2 */
/* 29 */	"%a",	/* cnst: CNSTI4 */
/* 30 */	"%a",	/* cnst: CNSTU4 */
/* 31 */	"%a",	/* cnst: CNSTP4 */
/* 32 */	"%a",	/* cnst: CNSTI8 */
/* 33 */	"%a",	/* cnst: CNSTU8 */
/* 34 */	"%a",	/* cnst: CNSTP8 */
/* 35 */	"$%0",	/* con: cnst */
/* 36 */	"",	/* stmt: reg */
/* 37 */	"",	/* stmt: freg */
/* 38 */	"%a",	/* acon: ADDRGP4 */
/* 39 */	"%a",	/* acon: ADDRGP8 */
/* 40 */	"%0",	/* acon: cnst */
/* 41 */	"%a",	/* baseaddr: ADDRGP4 */
/* 42 */	"(%0)",	/* base: reg */
/* 43 */	"%1(%0)",	/* base: ADDI4(reg,acon) */
/* 44 */	"%1(%0)",	/* base: ADDP4(reg,acon) */
/* 45 */	"%1(%0)",	/* base: ADDU4(reg,acon) */
/* 46 */	"%a(%%ebp)",	/* base: ADDRFP4 */
/* 47 */	"%a(%%ebp)",	/* base: ADDRLP4 */
/* 48 */	"%0",	/* index: reg */
/* 49 */	"%0,2",	/* index: LSHI4(reg,con1) */
/* 50 */	"%0,4",	/* index: LSHI4(reg,con2) */
/* 51 */	"%0,8",	/* index: LSHI4(reg,con3) */
/* 52 */	"%0,2",	/* index: LSHU4(reg,con1) */
/* 53 */	"%0,4",	/* index: LSHU4(reg,con2) */
/* 54 */	"%0,8",	/* index: LSHU4(reg,con3) */
/* 55 */	"1",	/* con0: CNSTI4 */
/* 56 */	"1",	/* con0: CNSTU4 */
/* 57 */	"1",	/* con1: CNSTI4 */
/* 58 */	"1",	/* con1: CNSTU4 */
/* 59 */	"2",	/* con2: CNSTI4 */
/* 60 */	"2",	/* con2: CNSTU4 */
/* 61 */	"3",	/* con3: CNSTI4 */
/* 62 */	"3",	/* con3: CNSTU4 */
/* 63 */	"%0",	/* addr: base */
/* 64 */	"%0",	/* addr: baseaddr */
/* 65 */	"%1(,%0)",	/* addr: ADDI4(index,baseaddr) */
/* 66 */	"%1(,%0)",	/* addr: ADDP4(index,baseaddr) */
/* 67 */	"%1(,%0)",	/* addr: ADDU4(index,baseaddr) */
/* 68 */	"%1(%0)",	/* addr: ADDI4(reg,baseaddr) */
/* 69 */	"%1(%0)",	/* addr: ADDP4(reg,baseaddr) */
/* 70 */	"%1(%0)",	/* addr: ADDU4(reg,baseaddr) */
/* 71 */	"(%1,%0)",	/* addr: ADDI4(index,reg) */
/* 72 */	"(%1,%0)",	/* addr: ADDP4(index,reg) */
/* 73 */	"(%1,%0)",	/* addr: ADDU4(index,reg) */
/* 74 */	"(,%0)",	/* addr: index */
/* 75 */	"%0",	/* mem1: INDIRI1(addr) */
/* 76 */	"%0",	/* mem1: INDIRU1(addr) */
/* 77 */	"%0",	/* mem2: INDIRI2(addr) */
/* 78 */	"%0",	/* mem2: INDIRU2(addr) */
/* 79 */	"%0",	/* mem4: INDIRI4(addr) */
/* 80 */	"%0",	/* mem4: INDIRU4(addr) */
/* 81 */	"%0",	/* mem4: INDIRP4(addr) */
/* 82 */	"%0",	/* rc: reg */
/* 83 */	"%0",	/* rc: con */
/* 84 */	"%0",	/* mr: reg */
/* 85 */	"%0",	/* mr: mem4 */
/* 86 */	"%0",	/* mr1: reg */
/* 87 */	"%0",	/* mr1: mem1 */
/* 88 */	"%0",	/* mr2: reg */
/* 89 */	"%0",	/* mr2: mem2 */
/* 90 */	"%0",	/* mrc: mem4 */
/* 91 */	"%0",	/* mrc: mem1 */
/* 92 */	"%0",	/* mrc: mem2 */
/* 93 */	"%0",	/* mrc: rc */
/* 94 */	"leal %0,%c\n",	/* reg: addr */
/* 95 */	"movl %0,%c\n",	/* reg: mr */
/* 96 */	"movb %0,%c\n",	/* reg: mr1 */
/* 97 */	"movw %0,%c\n",	/* reg: mr2 */
/* 98 */	"mov %0,%c\n",	/* reg: con */
/* 99 */	"# move\n",	/* reg: LOADI1(reg) */
/* 100 */	"# move\n",	/* reg: LOADI2(reg) */
/* 101 */	"# move\n",	/* reg: LOADI4(reg) */
/* 102 */	"# move\n",	/* reg: LOADU1(reg) */
/* 103 */	"# move\n",	/* reg: LOADU2(reg) */
/* 104 */	"# move\n",	/* reg: LOADU4(reg) */
/* 105 */	"# move\n",	/* reg: LOADP4(reg) */
/* 106 */	"?movl %0,%c\naddl %1,%c\n",	/* reg: ADDI4(reg,mrc) */
/* 107 */	"?movl %0,%c\naddl %1,%c\n",	/* reg: ADDP4(reg,mrc) */
/* 108 */	"?movl %0,%c\naddl %1,%c\n",	/* reg: ADDU4(reg,mrc) */
/* 109 */	"?movl %0,%c\nsubl %1,%c\n",	/* reg: SUBI4(reg,mrc) */
/* 110 */	"?movl %0,%c\nsubl %1,%c\n",	/* reg: SUBP4(reg,mrc) */
/* 111 */	"?movl %0,%c\nsubl %1,%c\n",	/* reg: SUBU4(reg,mrc) */
/* 112 */	"?movl %0,%c\nandl %1,%c\n",	/* reg: BANDI4(reg,mrc) */
/* 113 */	"?movl %0,%c\norl %1,%c\n",	/* reg: BORI4(reg,mrc) */
/* 114 */	"?movl %0,%c\nxorl %1,%c\n",	/* reg: BXORI4(reg,mrc) */
/* 115 */	"?movl %0,%c\nandl %1,%c\n",	/* reg: BANDU4(reg,mrc) */
/* 116 */	"?movl %0,%c\norl %1,%c\n",	/* reg: BORU4(reg,mrc) */
/* 117 */	"?movl %0,%c\nxorl %1,%c\n",	/* reg: BXORU4(reg,mrc) */
/* 118 */	"incl %1\n",	/* stmt: ASGNI4(addr,burm1) */
/* 119 */	"incl %1\n",	/* stmt: ASGNI4(addr,burm2) */
/* 120 */	"incl %1\n",	/* stmt: ASGNP4(addr,burm3) */
/* 121 */	"decl %1\n",	/* stmt: ASGNI4(addr,burm4) */
/* 122 */	"decl %1\n",	/* stmt: ASGNI4(addr,burm5) */
/* 123 */	"decl %1\n",	/* stmt: ASGNP4(addr,burm6) */
/* 124 */	"addl %1\n",	/* stmt: ASGNI4(addr,burm7) */
/* 125 */	"subl %1\n",	/* stmt: ASGNI4(addr,burm8) */
/* 126 */	"addl %1\n",	/* stmt: ASGNU4(addr,burm9) */
/* 127 */	"subl %1\n",	/* stmt: ASGNU4(addr,burm10) */
/* 128 */	"andl %1\n",	/* stmt: ASGNI4(addr,burm11) */
/* 129 */	"orl %1\n",	/* stmt: ASGNI4(addr,burm12) */
/* 130 */	"xorl %1\n",	/* stmt: ASGNI4(addr,burm13) */
/* 131 */	"andl %1\n",	/* stmt: ASGNU4(addr,burm14) */
/* 132 */	"orl %1\n",	/* stmt: ASGNU4(addr,burm15) */
/* 133 */	"xorl %1\n",	/* stmt: ASGNU4(addr,burm16) */
/* 134 */	"?movl %0,%c\nnotl %c\n",	/* reg: BCOMI4(reg) */
/* 135 */	"?movl %0,%c\nnotl %c\n",	/* reg: BCOMU4(reg) */
/* 136 */	"?movl %0,%c\nnegl %c\n",	/* reg: NEGI4(reg) */
/* 137 */	"notl %1\n",	/* stmt: ASGNI4(addr,burm17) */
/* 138 */	"notl %1\n",	/* stmt: ASGNU4(addr,burm18) */
/* 139 */	"negl %1\n",	/* stmt: ASGNI4(addr,burm19) */
/* 140 */	"?movl %0,%c\nsall %1,%c\n",	/* reg: LSHI4(reg,rc5) */
/* 141 */	"?movl %0,%c\nshll %1,%c\n",	/* reg: LSHU4(reg,rc5) */
/* 142 */	"?movl %0,%c\nsarl %1,%c\n",	/* reg: RSHI4(reg,rc5) */
/* 143 */	"?movl %0,%c\nshrl %1,%c\n",	/* reg: RSHU4(reg,rc5) */
/* 144 */	"sall %1\n",	/* stmt: ASGNI4(addr,burm20) */
/* 145 */	"shll %1\n",	/* stmt: ASGNI4(addr,burm21) */
/* 146 */	"sarl %1\n",	/* stmt: ASGNI4(addr,burm22) */
/* 147 */	"shrl %1\n",	/* stmt: ASGNI4(addr,burm23) */
/* 148 */	"$%a",	/* rc5: CNSTI4 */
/* 149 */	"%%cl",	/* rc5: reg */
/* 150 */	"?movl %0,%c\nimull %1,%c\n",	/* reg: MULI4(reg,mrc) */
/* 151 */	"imul %0,%1,%c\n",	/* reg: MULI4(con,mr) */
/* 152 */	"mull %1\n",	/* reg: MULU4(reg,mr) */
/* 153 */	"xorl %%edx,%%edx\ndivl %1\n",	/* reg: DIVU4(reg,reg) */
/* 154 */	"xorl %%edx,%%edx\ndivl %1\n",	/* reg: MODU4(reg,reg) */
/* 155 */	"cdq\nidivl %1\n",	/* reg: DIVI4(reg,reg) */
/* 156 */	"cdq\nidivl %1\n",	/* reg: MODI4(reg,reg) */
/* 157 */	"movl %0,%c\n",	/* reg: CVPU4(reg) */
/* 158 */	"movl %0,%c\n",	/* reg: CVUP4(reg) */
/* 159 */	"movsbl %0,%c\n",	/* reg: CVII4(burm24) */
/* 160 */	"movswl %0,%c\n",	/* reg: CVII4(burm25) */
/* 161 */	"movzbl %0,%c\n",	/* reg: CVUU4(burm26) */
/* 162 */	"movzwl %0,%c\n",	/* reg: CVUU4(burm27) */
/* 163 */	"# extend\n",	/* reg: CVII4(reg) */
/* 164 */	"# extend\n",	/* reg: CVIU4(reg) */
/* 165 */	"# extend\n",	/* reg: CVUI4(reg) */
/* 166 */	"# extend\n",	/* reg: CVUU4(reg) */
/* 167 */	"# truncate\n",	/* reg: CVII1(reg) */
/* 168 */	"# truncate\n",	/* reg: CVII2(reg) */
/* 169 */	"# truncate\n",	/* reg: CVUU1(reg) */
/* 170 */	"# truncate\n",	/* reg: CVUU2(reg) */
/* 171 */	"%0",	/* mrca: mem4 */
/* 172 */	"%0",	/* mrca: rc */
/* 173 */	"$%a",	/* mrca: ADDRGP4 */
/* 174 */	"$%a",	/* mrca: ADDRGP8 */
/* 175 */	"movb %1,%0\n",	/* stmt: ASGNI1(addr,rc) */
/* 176 */	"movw %1,%0\n",	/* stmt: ASGNI2(addr,rc) */
/* 177 */	"movl %1,%0\n",	/* stmt: ASGNI4(addr,rc) */
/* 178 */	"movb %1,%0\n",	/* stmt: ASGNU1(addr,rc) */
/* 179 */	"movw %1,%0\n",	/* stmt: ASGNU2(addr,rc) */
/* 180 */	"movl %1,%0\n",	/* stmt: ASGNU4(addr,rc) */
/* 181 */	"movl %1,%0\n",	/* stmt: ASGNP4(addr,rc) */
/* 182 */	"pushl %0\n",	/* stmt: ARGI4(mrca) */
/* 183 */	"pushl %0\n",	/* stmt: ARGU4(mrca) */
/* 184 */	"pushl %0\n",	/* stmt: ARGP4(mrca) */
/* 185 */	"movl $%a,%%ecx\nrep\nmovsb\n",	/* stmt: ASGNB(reg,burm28) */
/* 186 */	"# ARGB\n",	/* stmt: ARGB(burm28) */
/* 187 */	"l %0",	/* memf: INDIRF8(addr) */
/* 188 */	"s %0",	/* memf: INDIRF4(addr) */
/* 189 */	"s %0",	/* memf: CVFF8(burm29) */
/* 190 */	"l %0",	/* memf: CVFF4(burm30) */
/* 191 */	"fld%0\n",	/* freg: memf */
/* 192 */	"fstpl %0\n",	/* stmt: ASGNF8(addr,freg) */
/* 193 */	"fstps %0\n",	/* stmt: ASGNF4(addr,freg) */
/* 194 */	"fstps %0\n",	/* stmt: ASGNF4(addr,burm31) */
/* 195 */	"subl $8,%%esp\nfstpl (%%esp)\n",	/* stmt: ARGF8(freg) */
/* 196 */	"subl $4,%%esp\nfstps (%%esp)\n",	/* stmt: ARGF4(freg) */
/* 197 */	"fchs\n",	/* freg: NEGF8(freg) */
/* 198 */	"fchs\n",	/* freg: NEGF4(freg) */
/* 199 */	"%0",	/* flt: memf */
/* 200 */	"p %%st,%%st(1)",	/* flt: freg */
/* 201 */	"%0",	/* flt2: memf */
/* 202 */	"rp %%st,%%st(1)",	/* flt2: freg */
/* 203 */	"fadd%1\n",	/* freg: ADDF4(freg,flt) */
/* 204 */	"fadd%1\n",	/* freg: ADDF8(freg,flt) */
/* 205 */	"fdiv%1\n",	/* freg: DIVF4(freg,flt2) */
/* 206 */	"fdiv%1\n",	/* freg: DIVF8(freg,flt2) */
/* 207 */	"fmul%1\n",	/* freg: MULF4(freg,flt) */
/* 208 */	"fmul%1\n",	/* freg: MULF8(freg,flt) */
/* 209 */	"fsub%1\n",	/* freg: SUBF4(freg,flt2) */
/* 210 */	"fsub%1\n",	/* freg: SUBF8(freg,flt2) */
/* 211 */	"# CVFF8\n",	/* freg: CVFF8(freg) */
/* 212 */	"sub $4,%%esp\nfstps (%%esp)\nflds (%%esp)\naddl $4,%%esp\n",	/* freg: CVFF4(freg) */
/* 213 */	"subl $8,%%esp\nfnstcw 4(%%esp)\nmovl 4(%%esp),%%edx\nmovb $12,%%dh\nmovl %%edx,0(%%esp)\nfldcw 0(%%esp)\nfistpl 0(%%esp)\npopl %c\nfldcw 0(%%esp)\naddl $4,%%esp\n",	/* reg: CVFI4(freg) */
/* 214 */	"fildl %0\n",	/* freg: CVIF8(burm32) */
/* 215 */	"pushl %0\nfildl (%%esp)\naddl $4,%%esp\n",	/* freg: CVIF8(reg) */
/* 216 */	"fildl %0\n",	/* freg: CVIF4(burm32) */
/* 217 */	"pushl %0\nfildl (%%esp)\naddl $4,%%esp\n",	/* freg: CVIF4(reg) */
/* 218 */	"%a",	/* addrj: ADDRGP4 */
/* 219 */	"*%0",	/* addrj: reg */
/* 220 */	"*%0",	/* addrj: mem4 */
/* 221 */	"%a:\n",	/* stmt: LABELV */
/* 222 */	"jmp %0\n",	/* stmt: JUMPV(addrj) */
/* 223 */	"cmpl %1,%0\nje %a\n",	/* stmt: EQI4(mem4,rc) */
/* 224 */	"cmpl %1,%0\njge %a\n",	/* stmt: GEI4(mem4,rc) */
/* 225 */	"cmpl %1,%0\njg %a\n",	/* stmt: GTI4(mem4,rc) */
/* 226 */	"cmpl %1,%0\njle %a\n",	/* stmt: LEI4(mem4,rc) */
/* 227 */	"cmpl %1,%0\njl %a\n",	/* stmt: LTI4(mem4,rc) */
/* 228 */	"cmpl %1,%0\njne %a\n",	/* stmt: NEI4(mem4,rc) */
/* 229 */	"cmpl %1,%0\njae %a\n",	/* stmt: GEU4(mem4,rc) */
/* 230 */	"cmpl %1,%0\nja  %a\n",	/* stmt: GTU4(mem4,rc) */
/* 231 */	"cmpl %1,%0\njbe %a\n",	/* stmt: LEU4(mem4,rc) */
/* 232 */	"cmpl %1,%0\njb  %a\n",	/* stmt: LTU4(mem4,rc) */
/* 233 */	"cmpl %1,%0\nje %a\n",	/* stmt: EQI4(reg,mrc) */
/* 234 */	"cmpl %1,%0\njge %a\n",	/* stmt: GEI4(reg,mrc) */
/* 235 */	"cmpl %1,%0\njg %a\n",	/* stmt: GTI4(reg,mrc) */
/* 236 */	"cmpl %1,%0\njle %a\n",	/* stmt: LEI4(reg,mrc) */
/* 237 */	"cmpl %1,%0\njl %a\n",	/* stmt: LTI4(reg,mrc) */
/* 238 */	"cmpl %1,%0\njne %a\n",	/* stmt: NEI4(reg,mrc) */
/* 239 */	"cmpl %1,%0\nje %a\n",	/* stmt: EQU4(reg,mrc) */
/* 240 */	"cmpl %1,%0\njae %a\n",	/* stmt: GEU4(reg,mrc) */
/* 241 */	"cmpl %1,%0\nja %a\n",	/* stmt: GTU4(reg,mrc) */
/* 242 */	"cmpl %1,%0\njbe %a\n",	/* stmt: LEU4(reg,mrc) */
/* 243 */	"cmpl %1,%0\njb %a\n",	/* stmt: LTU4(reg,mrc) */
/* 244 */	"cmpl %1,%0\njne %a\n",	/* stmt: NEU4(reg,mrc) */
/* 245 */	"testl %0\nje %a\n",	/* stmt: EQI4(burm33,con0) */
/* 246 */	"testl %0\njne %a\n",	/* stmt: NEI4(burm33,con0) */
/* 247 */	"testw %0\nje %a\n",	/* stmt: EQI4(burm34,con0) */
/* 248 */	"testw %0\njne %a\n",	/* stmt: NEI4(burm34,con0) */
/* 249 */	"testw %0\nje %a\n",	/* stmt: EQI4(burm35,con0) */
/* 250 */	"testw %0\njne %a\n",	/* stmt: NEI4(burm35,con0) */
/* 251 */	"testb %0\nje %a\n",	/* stmt: EQI4(burm36,con0) */
/* 252 */	"l %0",	/* cmpf: INDIRF8(addr) */
/* 253 */	"s %0",	/* cmpf: INDIRF4(addr) */
/* 254 */	"s %0",	/* cmpf: CVFF8(burm29) */
/* 255 */	"p",	/* cmpf: freg */
/* 256 */	"fcomp%0\nfstsw %%ax\nsahf\njp 1f\nje %a\n1:\n",	/* stmt: EQF8(cmpf,freg) */
/* 257 */	"fcomp%0\nfstsw %%ax\nsahf\njp %a\njbe %a\n",	/* stmt: GEF8(cmpf,freg) */
/* 258 */	"fcomp%0\nfstsw %%ax\nsahf\njp %a\njb %a\n",	/* stmt: GTF8(cmpf,freg) */
/* 259 */	"fcomp%0\nfstsw %%ax\nsahf\njp %a\njae %a\n",	/* stmt: LEF8(cmpf,freg) */
/* 260 */	"fcomp%0\nfstsw %%ax\nsahf\njp %a\nja %a\n",	/* stmt: LTF8(cmpf,freg) */
/* 261 */	"fcomp%0\nfstsw %%ax\nsahf\njp %a\njne %a\n",	/* stmt: NEF8(cmpf,freg) */
/* 262 */	"fcomp%0\nfstsw %%ax\nsahf\njp 1f\nje %a\n1:\n",	/* stmt: EQF4(cmpf,freg) */
/* 263 */	"fcomp%0\nfstsw %%ax\nsahf\njp %a\njbe %a\n",	/* stmt: GEF4(cmpf,freg) */
/* 264 */	"fcomp%0\nfstsw %%ax\nsahf\njp %a\njb %a\n",	/* stmt: GTF4(cmpf,freg) */
/* 265 */	"fcomp%0\nfstsw %%ax\nsahf\njp %a\njae %a\n",	/* stmt: LEF4(cmpf,freg) */
/* 266 */	"fcomp%0\nfstsw %%ax\nsahf\njp %a\nja %a\n",	/* stmt: LTF4(cmpf,freg) */
/* 267 */	"fcomp%0\nfstsw %%ax\nsahf\njp %a\njne %a\n",	/* stmt: NEF4(cmpf,freg) */
/* 268 */	"fidivl %1\n",	/* freg: DIVF8(freg,burm37) */
/* 269 */	"fidivrl %0\n",	/* freg: DIVF8(burm37,freg) */
/* 270 */	"fidivs %1\n",	/* freg: DIVF8(freg,burm38) */
/* 271 */	"fidivrs %0\n",	/* freg: DIVF8(burm38,freg) */
/* 272 */	"fimull %1\n",	/* freg: MULF8(freg,burm37) */
/* 273 */	"fimuls %1\n",	/* freg: MULF8(freg,burm38) */
/* 274 */	"fisubl %1\n",	/* freg: SUBF8(freg,burm37) */
/* 275 */	"fisubrl %0\n",	/* freg: SUBF8(burm37,freg) */
/* 276 */	"fisubs %1\n",	/* freg: SUBF8(freg,burm38) */
/* 277 */	"fisubrs %0\n",	/* freg: SUBF8(burm38,freg) */
/* 278 */	"fiaddl %1\n",	/* freg: ADDF8(freg,burm37) */
/* 279 */	"fiadds %1\n",	/* freg: ADDF8(freg,burm38) */
/* 280 */	"fdivs %1\n",	/* freg: ADDF8(freg,burm39) */
/* 281 */	"fsubs %1\n",	/* freg: SUBF8(freg,burm39) */
/* 282 */	"fmuls %1\n",	/* freg: MULF8(freg,burm39) */
/* 283 */	"fdivs %1\n",	/* freg: DIVF8(freg,burm39) */
/* 284 */	"fld%0\n",	/* freg: LOADF8(memf) */
/* 285 */	"call %0\naddl $%a,%%esp\n",	/* reg: CALLI4(addrj) */
/* 286 */	"call %0\naddl $%a,%%esp\n",	/* reg: CALLU4(addrj) */
/* 287 */	"call %0\naddl $%a,%%esp\n",	/* reg: CALLP4(addrj) */
/* 288 */	"call %0\n",	/* reg: CALLI4(addrj) */
/* 289 */	"call %0\n",	/* reg: CALLU4(addrj) */
/* 290 */	"call %0\n",	/* reg: CALLP4(addrj) */
/* 291 */	"call %0\naddl $%a,%%esp\n",	/* stmt: CALLV(addrj) */
/* 292 */	"call %0\n",	/* stmt: CALLV(addrj) */
/* 293 */	"call %0\naddl $%a,%%esp\n",	/* freg: CALLF4(addrj) */
/* 294 */	"call %0\n",	/* freg: CALLF4(addrj) */
/* 295 */	"call %0\naddl $%a,%%esp\nfstp %%st(0)\n",	/* stmt: CALLF4(addrj) */
/* 296 */	"call %0\nfstp %%st(0)\n",	/* stmt: CALLF4(addrj) */
/* 297 */	"call %0\naddl $%a,%%esp\n",	/* freg: CALLF8(addrj) */
/* 298 */	"call %0\n",	/* freg: CALLF8(addrj) */
/* 299 */	"call %0\naddl $%a,%%esp\nfstp %%st(0)\n",	/* stmt: CALLF8(addrj) */
/* 300 */	"call %0\nfstp %%st(0)\n",	/* stmt: CALLF8(addrj) */
/* 301 */	"# ret\n",	/* stmt: RETI4(reg) */
/* 302 */	"# ret\n",	/* stmt: RETU4(reg) */
/* 303 */	"# ret\n",	/* stmt: RETP4(reg) */
/* 304 */	"# ret\n",	/* stmt: RETF4(freg) */
/* 305 */	"# ret\n",	/* stmt: RETF8(freg) */
/* 306 */	"",	/* burm0: VREGP */
/* 307 */	"%0",	/* burm1: ADDI4(mem4,con1) */
/* 308 */	"%0",	/* burm2: ADDU4(mem4,con1) */
/* 309 */	"%0",	/* burm3: ADDP4(mem4,con1) */
/* 310 */	"%0",	/* burm4: SUBI4(mem4,con1) */
/* 311 */	"%0",	/* burm5: SUBU4(mem4,con1) */
/* 312 */	"%0",	/* burm6: SUBP4(mem4,con1) */
/* 313 */	"%1,%0",	/* burm7: ADDI4(mem4,rc) */
/* 314 */	"%1,%0",	/* burm8: SUBI4(mem4,rc) */
/* 315 */	"%1,%0",	/* burm9: ADDU4(mem4,rc) */
/* 316 */	"%1,%0",	/* burm10: SUBU4(mem4,rc) */
/* 317 */	"%1,%0",	/* burm11: BANDI4(mem4,rc) */
/* 318 */	"%1,%0",	/* burm12: BORI4(mem4,rc) */
/* 319 */	"%1,%0",	/* burm13: BXORI4(mem4,rc) */
/* 320 */	"%1,%0",	/* burm14: BANDU4(mem4,rc) */
/* 321 */	"%1,%0",	/* burm15: BORU4(mem4,rc) */
/* 322 */	"%1,%0",	/* burm16: BXORU4(mem4,rc) */
/* 323 */	"%0",	/* burm17: BCOMI4(mem4) */
/* 324 */	"%0",	/* burm18: BCOMU4(mem4) */
/* 325 */	"%0",	/* burm19: NEGI4(mem4) */
/* 326 */	"%1,%0",	/* burm20: LSHI4(mem4,rc5) */
/* 327 */	"%1,%0",	/* burm21: LSHU4(mem4,rc5) */
/* 328 */	"%1,%0",	/* burm22: RSHI4(mem4,rc5) */
/* 329 */	"%1,%0",	/* burm23: RSHU4(mem4,rc5) */
/* 330 */	"%0",	/* burm24: INDIRI1(addr) */
/* 331 */	"%0",	/* burm25: INDIRI2(addr) */
/* 332 */	"%0",	/* burm26: INDIRU1(addr) */
/* 333 */	"%0",	/* burm27: INDIRU2(addr) */
/* 334 */	"",	/* burm28: INDIRB(reg) */
/* 335 */	"%0",	/* burm29: INDIRF4(addr) */
/* 336 */	"%0",	/* burm30: INDIRF8(addr) */
/* 337 */	"",	/* burm31: CVFF4(freg) */
/* 338 */	"%0",	/* burm32: INDIRI4(addr) */
/* 339 */	"%1,%0",	/* burm33: BANDU4(mr,con) */
/* 340 */	"%1,%0",	/* burm34: BANDU4(burm40,con) */
/* 341 */	"%1,%0",	/* burm35: BANDU4(burm41,con) */
/* 342 */	"%1,%0",	/* burm36: BANDU4(burm42,con) */
/* 343 */	"%0",	/* burm37: CVIF8(burm32) */
/* 344 */	"%0",	/* burm38: CVIF8(burm40) */
/* 345 */	"%0",	/* burm39: CVFF8(burm29) */
/* 346 */	"%0",	/* burm40: CVII2(burm25) */
/* 347 */	"%0",	/* burm41: CVIU2(burm25) */
/* 348 */	"%0",	/* burm42: CVII1(burm24) */
};

static char _isinstruction[] = {
/* 0 */	0,
/* 1 */	1,	/* # read register\n */
/* 2 */	1,	/* # read register\n */
/* 3 */	1,	/* # read register\n */
/* 4 */	1,	/* # read register\n */
/* 5 */	1,	/* # read register\n */
/* 6 */	1,	/* # read register\n */
/* 7 */	1,	/* # read register\n */
/* 8 */	1,	/* # read register\n */
/* 9 */	1,	/* # read register\n */
/* 10 */	1,	/* # read register\n */
/* 11 */	1,	/* # read register\n */
/* 12 */	1,	/* # read register\n */
/* 13 */	1,	/* # write register\n */
/* 14 */	1,	/* # write register\n */
/* 15 */	1,	/* # write register\n */
/* 16 */	1,	/* # write register\n */
/* 17 */	1,	/* # write register\n */
/* 18 */	1,	/* # write register\n */
/* 19 */	1,	/* # write register\n */
/* 20 */	1,	/* # write register\n */
/* 21 */	1,	/* # write register\n */
/* 22 */	1,	/* # write register\n */
/* 23 */	1,	/* # write register\n */
/* 24 */	1,	/* # write register\n */
/* 25 */	0,	/* %a */
/* 26 */	0,	/* %a */
/* 27 */	0,	/* %a */
/* 28 */	0,	/* %a */
/* 29 */	0,	/* %a */
/* 30 */	0,	/* %a */
/* 31 */	0,	/* %a */
/* 32 */	0,	/* %a */
/* 33 */	0,	/* %a */
/* 34 */	0,	/* %a */
/* 35 */	0,	/* $%0 */
/* 36 */	0,	/*  */
/* 37 */	0,	/*  */
/* 38 */	0,	/* %a */
/* 39 */	0,	/* %a */
/* 40 */	0,	/* %0 */
/* 41 */	0,	/* %a */
/* 42 */	0,	/* (%0) */
/* 43 */	0,	/* %1(%0) */
/* 44 */	0,	/* %1(%0) */
/* 45 */	0,	/* %1(%0) */
/* 46 */	0,	/* %a(%%ebp) */
/* 47 */	0,	/* %a(%%ebp) */
/* 48 */	0,	/* %0 */
/* 49 */	0,	/* %0,2 */
/* 50 */	0,	/* %0,4 */
/* 51 */	0,	/* %0,8 */
/* 52 */	0,	/* %0,2 */
/* 53 */	0,	/* %0,4 */
/* 54 */	0,	/* %0,8 */
/* 55 */	0,	/* 1 */
/* 56 */	0,	/* 1 */
/* 57 */	0,	/* 1 */
/* 58 */	0,	/* 1 */
/* 59 */	0,	/* 2 */
/* 60 */	0,	/* 2 */
/* 61 */	0,	/* 3 */
/* 62 */	0,	/* 3 */
/* 63 */	0,	/* %0 */
/* 64 */	0,	/* %0 */
/* 65 */	0,	/* %1(,%0) */
/* 66 */	0,	/* %1(,%0) */
/* 67 */	0,	/* %1(,%0) */
/* 68 */	0,	/* %1(%0) */
/* 69 */	0,	/* %1(%0) */
/* 70 */	0,	/* %1(%0) */
/* 71 */	0,	/* (%1,%0) */
/* 72 */	0,	/* (%1,%0) */
/* 73 */	0,	/* (%1,%0) */
/* 74 */	0,	/* (,%0) */
/* 75 */	0,	/* %0 */
/* 76 */	0,	/* %0 */
/* 77 */	0,	/* %0 */
/* 78 */	0,	/* %0 */
/* 79 */	0,	/* %0 */
/* 80 */	0,	/* %0 */
/* 81 */	0,	/* %0 */
/* 82 */	0,	/* %0 */
/* 83 */	0,	/* %0 */
/* 84 */	0,	/* %0 */
/* 85 */	0,	/* %0 */
/* 86 */	0,	/* %0 */
/* 87 */	0,	/* %0 */
/* 88 */	0,	/* %0 */
/* 89 */	0,	/* %0 */
/* 90 */	0,	/* %0 */
/* 91 */	0,	/* %0 */
/* 92 */	0,	/* %0 */
/* 93 */	0,	/* %0 */
/* 94 */	1,	/* leal %0,%c\n */
/* 95 */	1,	/* movl %0,%c\n */
/* 96 */	1,	/* movb %0,%c\n */
/* 97 */	1,	/* movw %0,%c\n */
/* 98 */	1,	/* mov %0,%c\n */
/* 99 */	1,	/* # move\n */
/* 100 */	1,	/* # move\n */
/* 101 */	1,	/* # move\n */
/* 102 */	1,	/* # move\n */
/* 103 */	1,	/* # move\n */
/* 104 */	1,	/* # move\n */
/* 105 */	1,	/* # move\n */
/* 106 */	1,	/* ?movl %0,%c\naddl %1,%c\n */
/* 107 */	1,	/* ?movl %0,%c\naddl %1,%c\n */
/* 108 */	1,	/* ?movl %0,%c\naddl %1,%c\n */
/* 109 */	1,	/* ?movl %0,%c\nsubl %1,%c\n */
/* 110 */	1,	/* ?movl %0,%c\nsubl %1,%c\n */
/* 111 */	1,	/* ?movl %0,%c\nsubl %1,%c\n */
/* 112 */	1,	/* ?movl %0,%c\nandl %1,%c\n */
/* 113 */	1,	/* ?movl %0,%c\norl %1,%c\n */
/* 114 */	1,	/* ?movl %0,%c\nxorl %1,%c\n */
/* 115 */	1,	/* ?movl %0,%c\nandl %1,%c\n */
/* 116 */	1,	/* ?movl %0,%c\norl %1,%c\n */
/* 117 */	1,	/* ?movl %0,%c\nxorl %1,%c\n */
/* 118 */	1,	/* incl %1\n */
/* 119 */	1,	/* incl %1\n */
/* 120 */	1,	/* incl %1\n */
/* 121 */	1,	/* decl %1\n */
/* 122 */	1,	/* decl %1\n */
/* 123 */	1,	/* decl %1\n */
/* 124 */	1,	/* addl %1\n */
/* 125 */	1,	/* subl %1\n */
/* 126 */	1,	/* addl %1\n */
/* 127 */	1,	/* subl %1\n */
/* 128 */	1,	/* andl %1\n */
/* 129 */	1,	/* orl %1\n */
/* 130 */	1,	/* xorl %1\n */
/* 131 */	1,	/* andl %1\n */
/* 132 */	1,	/* orl %1\n */
/* 133 */	1,	/* xorl %1\n */
/* 134 */	1,	/* ?movl %0,%c\nnotl %c\n */
/* 135 */	1,	/* ?movl %0,%c\nnotl %c\n */
/* 136 */	1,	/* ?movl %0,%c\nnegl %c\n */
/* 137 */	1,	/* notl %1\n */
/* 138 */	1,	/* notl %1\n */
/* 139 */	1,	/* negl %1\n */
/* 140 */	1,	/* ?movl %0,%c\nsall %1,%c\n */
/* 141 */	1,	/* ?movl %0,%c\nshll %1,%c\n */
/* 142 */	1,	/* ?movl %0,%c\nsarl %1,%c\n */
/* 143 */	1,	/* ?movl %0,%c\nshrl %1,%c\n */
/* 144 */	1,	/* sall %1\n */
/* 145 */	1,	/* shll %1\n */
/* 146 */	1,	/* sarl %1\n */
/* 147 */	1,	/* shrl %1\n */
/* 148 */	0,	/* $%a */
/* 149 */	0,	/* %%cl */
/* 150 */	1,	/* ?movl %0,%c\nimull %1,%c\n */
/* 151 */	1,	/* imul %0,%1,%c\n */
/* 152 */	1,	/* mull %1\n */
/* 153 */	1,	/* xorl %%edx,%%edx\ndivl %1\n */
/* 154 */	1,	/* xorl %%edx,%%edx\ndivl %1\n */
/* 155 */	1,	/* cdq\nidivl %1\n */
/* 156 */	1,	/* cdq\nidivl %1\n */
/* 157 */	1,	/* movl %0,%c\n */
/* 158 */	1,	/* movl %0,%c\n */
/* 159 */	1,	/* movsbl %0,%c\n */
/* 160 */	1,	/* movswl %0,%c\n */
/* 161 */	1,	/* movzbl %0,%c\n */
/* 162 */	1,	/* movzwl %0,%c\n */
/* 163 */	1,	/* # extend\n */
/* 164 */	1,	/* # extend\n */
/* 165 */	1,	/* # extend\n */
/* 166 */	1,	/* # extend\n */
/* 167 */	1,	/* # truncate\n */
/* 168 */	1,	/* # truncate\n */
/* 169 */	1,	/* # truncate\n */
/* 170 */	1,	/* # truncate\n */
/* 171 */	0,	/* %0 */
/* 172 */	0,	/* %0 */
/* 173 */	0,	/* $%a */
/* 174 */	0,	/* $%a */
/* 175 */	1,	/* movb %1,%0\n */
/* 176 */	1,	/* movw %1,%0\n */
/* 177 */	1,	/* movl %1,%0\n */
/* 178 */	1,	/* movb %1,%0\n */
/* 179 */	1,	/* movw %1,%0\n */
/* 180 */	1,	/* movl %1,%0\n */
/* 181 */	1,	/* movl %1,%0\n */
/* 182 */	1,	/* pushl %0\n */
/* 183 */	1,	/* pushl %0\n */
/* 184 */	1,	/* pushl %0\n */
/* 185 */	1,	/* movl $%a,%%ecx\nrep\nmovsb\n */
/* 186 */	1,	/* # ARGB\n */
/* 187 */	0,	/* l %0 */
/* 188 */	0,	/* s %0 */
/* 189 */	0,	/* s %0 */
/* 190 */	0,	/* l %0 */
/* 191 */	1,	/* fld%0\n */
/* 192 */	1,	/* fstpl %0\n */
/* 193 */	1,	/* fstps %0\n */
/* 194 */	1,	/* fstps %0\n */
/* 195 */	1,	/* subl $8,%%esp\nfstpl (%%esp)\n */
/* 196 */	1,	/* subl $4,%%esp\nfstps (%%esp)\n */
/* 197 */	1,	/* fchs\n */
/* 198 */	1,	/* fchs\n */
/* 199 */	0,	/* %0 */
/* 200 */	0,	/* p %%st,%%st(1) */
/* 201 */	0,	/* %0 */
/* 202 */	0,	/* rp %%st,%%st(1) */
/* 203 */	1,	/* fadd%1\n */
/* 204 */	1,	/* fadd%1\n */
/* 205 */	1,	/* fdiv%1\n */
/* 206 */	1,	/* fdiv%1\n */
/* 207 */	1,	/* fmul%1\n */
/* 208 */	1,	/* fmul%1\n */
/* 209 */	1,	/* fsub%1\n */
/* 210 */	1,	/* fsub%1\n */
/* 211 */	1,	/* # CVFF8\n */
/* 212 */	1,	/* sub $4,%%esp\nfstps (%%esp)\nflds (%%esp)\naddl $4,%%esp\n */
/* 213 */	1,	/* subl $8,%%esp\nfnstcw 4(%%esp)\nmovl 4(%%esp),%%edx\nmovb $12,%%dh\nmovl %%edx,0(%%esp)\nfldcw 0(%%esp)\nfistpl 0(%%esp)\npopl %c\nfldcw 0(%%esp)\naddl $4,%%esp\n */
/* 214 */	1,	/* fildl %0\n */
/* 215 */	1,	/* pushl %0\nfildl (%%esp)\naddl $4,%%esp\n */
/* 216 */	1,	/* fildl %0\n */
/* 217 */	1,	/* pushl %0\nfildl (%%esp)\naddl $4,%%esp\n */
/* 218 */	0,	/* %a */
/* 219 */	0,	/* *%0 */
/* 220 */	0,	/* *%0 */
/* 221 */	1,	/* %a:\n */
/* 222 */	1,	/* jmp %0\n */
/* 223 */	1,	/* cmpl %1,%0\nje %a\n */
/* 224 */	1,	/* cmpl %1,%0\njge %a\n */
/* 225 */	1,	/* cmpl %1,%0\njg %a\n */
/* 226 */	1,	/* cmpl %1,%0\njle %a\n */
/* 227 */	1,	/* cmpl %1,%0\njl %a\n */
/* 228 */	1,	/* cmpl %1,%0\njne %a\n */
/* 229 */	1,	/* cmpl %1,%0\njae %a\n */
/* 230 */	1,	/* cmpl %1,%0\nja  %a\n */
/* 231 */	1,	/* cmpl %1,%0\njbe %a\n */
/* 232 */	1,	/* cmpl %1,%0\njb  %a\n */
/* 233 */	1,	/* cmpl %1,%0\nje %a\n */
/* 234 */	1,	/* cmpl %1,%0\njge %a\n */
/* 235 */	1,	/* cmpl %1,%0\njg %a\n */
/* 236 */	1,	/* cmpl %1,%0\njle %a\n */
/* 237 */	1,	/* cmpl %1,%0\njl %a\n */
/* 238 */	1,	/* cmpl %1,%0\njne %a\n */
/* 239 */	1,	/* cmpl %1,%0\nje %a\n */
/* 240 */	1,	/* cmpl %1,%0\njae %a\n */
/* 241 */	1,	/* cmpl %1,%0\nja %a\n */
/* 242 */	1,	/* cmpl %1,%0\njbe %a\n */
/* 243 */	1,	/* cmpl %1,%0\njb %a\n */
/* 244 */	1,	/* cmpl %1,%0\njne %a\n */
/* 245 */	1,	/* testl %0\nje %a\n */
/* 246 */	1,	/* testl %0\njne %a\n */
/* 247 */	1,	/* testw %0\nje %a\n */
/* 248 */	1,	/* testw %0\njne %a\n */
/* 249 */	1,	/* testw %0\nje %a\n */
/* 250 */	1,	/* testw %0\njne %a\n */
/* 251 */	1,	/* testb %0\nje %a\n */
/* 252 */	0,	/* l %0 */
/* 253 */	0,	/* s %0 */
/* 254 */	0,	/* s %0 */
/* 255 */	0,	/* p */
/* 256 */	1,	/* fcomp%0\nfstsw %%ax\nsahf\njp 1f\nje %a\n1:\n */
/* 257 */	1,	/* fcomp%0\nfstsw %%ax\nsahf\njp %a\njbe %a\n */
/* 258 */	1,	/* fcomp%0\nfstsw %%ax\nsahf\njp %a\njb %a\n */
/* 259 */	1,	/* fcomp%0\nfstsw %%ax\nsahf\njp %a\njae %a\n */
/* 260 */	1,	/* fcomp%0\nfstsw %%ax\nsahf\njp %a\nja %a\n */
/* 261 */	1,	/* fcomp%0\nfstsw %%ax\nsahf\njp %a\njne %a\n */
/* 262 */	1,	/* fcomp%0\nfstsw %%ax\nsahf\njp 1f\nje %a\n1:\n */
/* 263 */	1,	/* fcomp%0\nfstsw %%ax\nsahf\njp %a\njbe %a\n */
/* 264 */	1,	/* fcomp%0\nfstsw %%ax\nsahf\njp %a\njb %a\n */
/* 265 */	1,	/* fcomp%0\nfstsw %%ax\nsahf\njp %a\njae %a\n */
/* 266 */	1,	/* fcomp%0\nfstsw %%ax\nsahf\njp %a\nja %a\n */
/* 267 */	1,	/* fcomp%0\nfstsw %%ax\nsahf\njp %a\njne %a\n */
/* 268 */	1,	/* fidivl %1\n */
/* 269 */	1,	/* fidivrl %0\n */
/* 270 */	1,	/* fidivs %1\n */
/* 271 */	1,	/* fidivrs %0\n */
/* 272 */	1,	/* fimull %1\n */
/* 273 */	1,	/* fimuls %1\n */
/* 274 */	1,	/* fisubl %1\n */
/* 275 */	1,	/* fisubrl %0\n */
/* 276 */	1,	/* fisubs %1\n */
/* 277 */	1,	/* fisubrs %0\n */
/* 278 */	1,	/* fiaddl %1\n */
/* 279 */	1,	/* fiadds %1\n */
/* 280 */	1,	/* fdivs %1\n */
/* 281 */	1,	/* fsubs %1\n */
/* 282 */	1,	/* fmuls %1\n */
/* 283 */	1,	/* fdivs %1\n */
/* 284 */	1,	/* fld%0\n */
/* 285 */	1,	/* call %0\naddl $%a,%%esp\n */
/* 286 */	1,	/* call %0\naddl $%a,%%esp\n */
/* 287 */	1,	/* call %0\naddl $%a,%%esp\n */
/* 288 */	1,	/* call %0\n */
/* 289 */	1,	/* call %0\n */
/* 290 */	1,	/* call %0\n */
/* 291 */	1,	/* call %0\naddl $%a,%%esp\n */
/* 292 */	1,	/* call %0\n */
/* 293 */	1,	/* call %0\naddl $%a,%%esp\n */
/* 294 */	1,	/* call %0\n */
/* 295 */	1,	/* call %0\naddl $%a,%%esp\nfstp %%st(0)\n */
/* 296 */	1,	/* call %0\nfstp %%st(0)\n */
/* 297 */	1,	/* call %0\naddl $%a,%%esp\n */
/* 298 */	1,	/* call %0\n */
/* 299 */	1,	/* call %0\naddl $%a,%%esp\nfstp %%st(0)\n */
/* 300 */	1,	/* call %0\nfstp %%st(0)\n */
/* 301 */	1,	/* # ret\n */
/* 302 */	1,	/* # ret\n */
/* 303 */	1,	/* # ret\n */
/* 304 */	1,	/* # ret\n */
/* 305 */	1,	/* # ret\n */
/* 306 */	0,	/*  */
/* 307 */	0,	/* %0 */
/* 308 */	0,	/* %0 */
/* 309 */	0,	/* %0 */
/* 310 */	0,	/* %0 */
/* 311 */	0,	/* %0 */
/* 312 */	0,	/* %0 */
/* 313 */	0,	/* %1,%0 */
/* 314 */	0,	/* %1,%0 */
/* 315 */	0,	/* %1,%0 */
/* 316 */	0,	/* %1,%0 */
/* 317 */	0,	/* %1,%0 */
/* 318 */	0,	/* %1,%0 */
/* 319 */	0,	/* %1,%0 */
/* 320 */	0,	/* %1,%0 */
/* 321 */	0,	/* %1,%0 */
/* 322 */	0,	/* %1,%0 */
/* 323 */	0,	/* %0 */
/* 324 */	0,	/* %0 */
/* 325 */	0,	/* %0 */
/* 326 */	0,	/* %1,%0 */
/* 327 */	0,	/* %1,%0 */
/* 328 */	0,	/* %1,%0 */
/* 329 */	0,	/* %1,%0 */
/* 330 */	0,	/* %0 */
/* 331 */	0,	/* %0 */
/* 332 */	0,	/* %0 */
/* 333 */	0,	/* %0 */
/* 334 */	0,	/*  */
/* 335 */	0,	/* %0 */
/* 336 */	0,	/* %0 */
/* 337 */	0,	/*  */
/* 338 */	0,	/* %0 */
/* 339 */	0,	/* %1,%0 */
/* 340 */	0,	/* %1,%0 */
/* 341 */	0,	/* %1,%0 */
/* 342 */	0,	/* %1,%0 */
/* 343 */	0,	/* %0 */
/* 344 */	0,	/* %0 */
/* 345 */	0,	/* %0 */
/* 346 */	0,	/* %0 */
/* 347 */	0,	/* %0 */
/* 348 */	0,	/* %0 */
};

static char *_string[] = {
/* 0 */	0,
/* 1 */	"reg: INDIRI1(burm0)",
/* 2 */	"reg: INDIRU1(burm0)",
/* 3 */	"reg: INDIRI2(burm0)",
/* 4 */	"reg: INDIRU2(burm0)",
/* 5 */	"reg: INDIRI4(burm0)",
/* 6 */	"reg: INDIRP4(burm0)",
/* 7 */	"reg: INDIRU4(burm0)",
/* 8 */	"reg: INDIRI8(burm0)",
/* 9 */	"reg: INDIRP8(burm0)",
/* 10 */	"reg: INDIRU8(burm0)",
/* 11 */	"freg: INDIRF4(burm0)",
/* 12 */	"freg: INDIRF8(burm0)",
/* 13 */	"stmt: ASGNI1(burm0,reg)",
/* 14 */	"stmt: ASGNU1(burm0,reg)",
/* 15 */	"stmt: ASGNI2(burm0,reg)",
/* 16 */	"stmt: ASGNU2(burm0,reg)",
/* 17 */	"stmt: ASGNF4(burm0,reg)",
/* 18 */	"stmt: ASGNI4(burm0,reg)",
/* 19 */	"stmt: ASGNP4(burm0,reg)",
/* 20 */	"stmt: ASGNU4(burm0,reg)",
/* 21 */	"stmt: ASGNF8(burm0,reg)",
/* 22 */	"stmt: ASGNI8(burm0,reg)",
/* 23 */	"stmt: ASGNP8(burm0,reg)",
/* 24 */	"stmt: ASGNU8(burm0,reg)",
/* 25 */	"cnst: CNSTI1",
/* 26 */	"cnst: CNSTU1",
/* 27 */	"cnst: CNSTI2",
/* 28 */	"cnst: CNSTU2",
/* 29 */	"cnst: CNSTI4",
/* 30 */	"cnst: CNSTU4",
/* 31 */	"cnst: CNSTP4",
/* 32 */	"cnst: CNSTI8",
/* 33 */	"cnst: CNSTU8",
/* 34 */	"cnst: CNSTP8",
/* 35 */	"con: cnst",
/* 36 */	"stmt: reg",
/* 37 */	"stmt: freg",
/* 38 */	"acon: ADDRGP4",
/* 39 */	"acon: ADDRGP8",
/* 40 */	"acon: cnst",
/* 41 */	"baseaddr: ADDRGP4",
/* 42 */	"base: reg",
/* 43 */	"base: ADDI4(reg,acon)",
/* 44 */	"base: ADDP4(reg,acon)",
/* 45 */	"base: ADDU4(reg,acon)",
/* 46 */	"base: ADDRFP4",
/* 47 */	"base: ADDRLP4",
/* 48 */	"index: reg",
/* 49 */	"index: LSHI4(reg,con1)",
/* 50 */	"index: LSHI4(reg,con2)",
/* 51 */	"index: LSHI4(reg,con3)",
/* 52 */	"index: LSHU4(reg,con1)",
/* 53 */	"index: LSHU4(reg,con2)",
/* 54 */	"index: LSHU4(reg,con3)",
/* 55 */	"con0: CNSTI4",
/* 56 */	"con0: CNSTU4",
/* 57 */	"con1: CNSTI4",
/* 58 */	"con1: CNSTU4",
/* 59 */	"con2: CNSTI4",
/* 60 */	"con2: CNSTU4",
/* 61 */	"con3: CNSTI4",
/* 62 */	"con3: CNSTU4",
/* 63 */	"addr: base",
/* 64 */	"addr: baseaddr",
/* 65 */	"addr: ADDI4(index,baseaddr)",
/* 66 */	"addr: ADDP4(index,baseaddr)",
/* 67 */	"addr: ADDU4(index,baseaddr)",
/* 68 */	"addr: ADDI4(reg,baseaddr)",
/* 69 */	"addr: ADDP4(reg,baseaddr)",
/* 70 */	"addr: ADDU4(reg,baseaddr)",
/* 71 */	"addr: ADDI4(index,reg)",
/* 72 */	"addr: ADDP4(index,reg)",
/* 73 */	"addr: ADDU4(index,reg)",
/* 74 */	"addr: index",
/* 75 */	"mem1: INDIRI1(addr)",
/* 76 */	"mem1: INDIRU1(addr)",
/* 77 */	"mem2: INDIRI2(addr)",
/* 78 */	"mem2: INDIRU2(addr)",
/* 79 */	"mem4: INDIRI4(addr)",
/* 80 */	"mem4: INDIRU4(addr)",
/* 81 */	"mem4: INDIRP4(addr)",
/* 82 */	"rc: reg",
/* 83 */	"rc: con",
/* 84 */	"mr: reg",
/* 85 */	"mr: mem4",
/* 86 */	"mr1: reg",
/* 87 */	"mr1: mem1",
/* 88 */	"mr2: reg",
/* 89 */	"mr2: mem2",
/* 90 */	"mrc: mem4",
/* 91 */	"mrc: mem1",
/* 92 */	"mrc: mem2",
/* 93 */	"mrc: rc",
/* 94 */	"reg: addr",
/* 95 */	"reg: mr",
/* 96 */	"reg: mr1",
/* 97 */	"reg: mr2",
/* 98 */	"reg: con",
/* 99 */	"reg: LOADI1(reg)",
/* 100 */	"reg: LOADI2(reg)",
/* 101 */	"reg: LOADI4(reg)",
/* 102 */	"reg: LOADU1(reg)",
/* 103 */	"reg: LOADU2(reg)",
/* 104 */	"reg: LOADU4(reg)",
/* 105 */	"reg: LOADP4(reg)",
/* 106 */	"reg: ADDI4(reg,mrc)",
/* 107 */	"reg: ADDP4(reg,mrc)",
/* 108 */	"reg: ADDU4(reg,mrc)",
/* 109 */	"reg: SUBI4(reg,mrc)",
/* 110 */	"reg: SUBP4(reg,mrc)",
/* 111 */	"reg: SUBU4(reg,mrc)",
/* 112 */	"reg: BANDI4(reg,mrc)",
/* 113 */	"reg: BORI4(reg,mrc)",
/* 114 */	"reg: BXORI4(reg,mrc)",
/* 115 */	"reg: BANDU4(reg,mrc)",
/* 116 */	"reg: BORU4(reg,mrc)",
/* 117 */	"reg: BXORU4(reg,mrc)",
/* 118 */	"stmt: ASGNI4(addr,burm1)",
/* 119 */	"stmt: ASGNI4(addr,burm2)",
/* 120 */	"stmt: ASGNP4(addr,burm3)",
/* 121 */	"stmt: ASGNI4(addr,burm4)",
/* 122 */	"stmt: ASGNI4(addr,burm5)",
/* 123 */	"stmt: ASGNP4(addr,burm6)",
/* 124 */	"stmt: ASGNI4(addr,burm7)",
/* 125 */	"stmt: ASGNI4(addr,burm8)",
/* 126 */	"stmt: ASGNU4(addr,burm9)",
/* 127 */	"stmt: ASGNU4(addr,burm10)",
/* 128 */	"stmt: ASGNI4(addr,burm11)",
/* 129 */	"stmt: ASGNI4(addr,burm12)",
/* 130 */	"stmt: ASGNI4(addr,burm13)",
/* 131 */	"stmt: ASGNU4(addr,burm14)",
/* 132 */	"stmt: ASGNU4(addr,burm15)",
/* 133 */	"stmt: ASGNU4(addr,burm16)",
/* 134 */	"reg: BCOMI4(reg)",
/* 135 */	"reg: BCOMU4(reg)",
/* 136 */	"reg: NEGI4(reg)",
/* 137 */	"stmt: ASGNI4(addr,burm17)",
/* 138 */	"stmt: ASGNU4(addr,burm18)",
/* 139 */	"stmt: ASGNI4(addr,burm19)",
/* 140 */	"reg: LSHI4(reg,rc5)",
/* 141 */	"reg: LSHU4(reg,rc5)",
/* 142 */	"reg: RSHI4(reg,rc5)",
/* 143 */	"reg: RSHU4(reg,rc5)",
/* 144 */	"stmt: ASGNI4(addr,burm20)",
/* 145 */	"stmt: ASGNI4(addr,burm21)",
/* 146 */	"stmt: ASGNI4(addr,burm22)",
/* 147 */	"stmt: ASGNI4(addr,burm23)",
/* 148 */	"rc5: CNSTI4",
/* 149 */	"rc5: reg",
/* 150 */	"reg: MULI4(reg,mrc)",
/* 151 */	"reg: MULI4(con,mr)",
/* 152 */	"reg: MULU4(reg,mr)",
/* 153 */	"reg: DIVU4(reg,reg)",
/* 154 */	"reg: MODU4(reg,reg)",
/* 155 */	"reg: DIVI4(reg,reg)",
/* 156 */	"reg: MODI4(reg,reg)",
/* 157 */	"reg: CVPU4(reg)",
/* 158 */	"reg: CVUP4(reg)",
/* 159 */	"reg: CVII4(burm24)",
/* 160 */	"reg: CVII4(burm25)",
/* 161 */	"reg: CVUU4(burm26)",
/* 162 */	"reg: CVUU4(burm27)",
/* 163 */	"reg: CVII4(reg)",
/* 164 */	"reg: CVIU4(reg)",
/* 165 */	"reg: CVUI4(reg)",
/* 166 */	"reg: CVUU4(reg)",
/* 167 */	"reg: CVII1(reg)",
/* 168 */	"reg: CVII2(reg)",
/* 169 */	"reg: CVUU1(reg)",
/* 170 */	"reg: CVUU2(reg)",
/* 171 */	"mrca: mem4",
/* 172 */	"mrca: rc",
/* 173 */	"mrca: ADDRGP4",
/* 174 */	"mrca: ADDRGP8",
/* 175 */	"stmt: ASGNI1(addr,rc)",
/* 176 */	"stmt: ASGNI2(addr,rc)",
/* 177 */	"stmt: ASGNI4(addr,rc)",
/* 178 */	"stmt: ASGNU1(addr,rc)",
/* 179 */	"stmt: ASGNU2(addr,rc)",
/* 180 */	"stmt: ASGNU4(addr,rc)",
/* 181 */	"stmt: ASGNP4(addr,rc)",
/* 182 */	"stmt: ARGI4(mrca)",
/* 183 */	"stmt: ARGU4(mrca)",
/* 184 */	"stmt: ARGP4(mrca)",
/* 185 */	"stmt: ASGNB(reg,burm28)",
/* 186 */	"stmt: ARGB(burm28)",
/* 187 */	"memf: INDIRF8(addr)",
/* 188 */	"memf: INDIRF4(addr)",
/* 189 */	"memf: CVFF8(burm29)",
/* 190 */	"memf: CVFF4(burm30)",
/* 191 */	"freg: memf",
/* 192 */	"stmt: ASGNF8(addr,freg)",
/* 193 */	"stmt: ASGNF4(addr,freg)",
/* 194 */	"stmt: ASGNF4(addr,burm31)",
/* 195 */	"stmt: ARGF8(freg)",
/* 196 */	"stmt: ARGF4(freg)",
/* 197 */	"freg: NEGF8(freg)",
/* 198 */	"freg: NEGF4(freg)",
/* 199 */	"flt: memf",
/* 200 */	"flt: freg",
/* 201 */	"flt2: memf",
/* 202 */	"flt2: freg",
/* 203 */	"freg: ADDF4(freg,flt)",
/* 204 */	"freg: ADDF8(freg,flt)",
/* 205 */	"freg: DIVF4(freg,flt2)",
/* 206 */	"freg: DIVF8(freg,flt2)",
/* 207 */	"freg: MULF4(freg,flt)",
/* 208 */	"freg: MULF8(freg,flt)",
/* 209 */	"freg: SUBF4(freg,flt2)",
/* 210 */	"freg: SUBF8(freg,flt2)",
/* 211 */	"freg: CVFF8(freg)",
/* 212 */	"freg: CVFF4(freg)",
/* 213 */	"reg: CVFI4(freg)",
/* 214 */	"freg: CVIF8(burm32)",
/* 215 */	"freg: CVIF8(reg)",
/* 216 */	"freg: CVIF4(burm32)",
/* 217 */	"freg: CVIF4(reg)",
/* 218 */	"addrj: ADDRGP4",
/* 219 */	"addrj: reg",
/* 220 */	"addrj: mem4",
/* 221 */	"stmt: LABELV",
/* 222 */	"stmt: JUMPV(addrj)",
/* 223 */	"stmt: EQI4(mem4,rc)",
/* 224 */	"stmt: GEI4(mem4,rc)",
/* 225 */	"stmt: GTI4(mem4,rc)",
/* 226 */	"stmt: LEI4(mem4,rc)",
/* 227 */	"stmt: LTI4(mem4,rc)",
/* 228 */	"stmt: NEI4(mem4,rc)",
/* 229 */	"stmt: GEU4(mem4,rc)",
/* 230 */	"stmt: GTU4(mem4,rc)",
/* 231 */	"stmt: LEU4(mem4,rc)",
/* 232 */	"stmt: LTU4(mem4,rc)",
/* 233 */	"stmt: EQI4(reg,mrc)",
/* 234 */	"stmt: GEI4(reg,mrc)",
/* 235 */	"stmt: GTI4(reg,mrc)",
/* 236 */	"stmt: LEI4(reg,mrc)",
/* 237 */	"stmt: LTI4(reg,mrc)",
/* 238 */	"stmt: NEI4(reg,mrc)",
/* 239 */	"stmt: EQU4(reg,mrc)",
/* 240 */	"stmt: GEU4(reg,mrc)",
/* 241 */	"stmt: GTU4(reg,mrc)",
/* 242 */	"stmt: LEU4(reg,mrc)",
/* 243 */	"stmt: LTU4(reg,mrc)",
/* 244 */	"stmt: NEU4(reg,mrc)",
/* 245 */	"stmt: EQI4(burm33,con0)",
/* 246 */	"stmt: NEI4(burm33,con0)",
/* 247 */	"stmt: EQI4(burm34,con0)",
/* 248 */	"stmt: NEI4(burm34,con0)",
/* 249 */	"stmt: EQI4(burm35,con0)",
/* 250 */	"stmt: NEI4(burm35,con0)",
/* 251 */	"stmt: EQI4(burm36,con0)",
/* 252 */	"cmpf: INDIRF8(addr)",
/* 253 */	"cmpf: INDIRF4(addr)",
/* 254 */	"cmpf: CVFF8(burm29)",
/* 255 */	"cmpf: freg",
/* 256 */	"stmt: EQF8(cmpf,freg)",
/* 257 */	"stmt: GEF8(cmpf,freg)",
/* 258 */	"stmt: GTF8(cmpf,freg)",
/* 259 */	"stmt: LEF8(cmpf,freg)",
/* 260 */	"stmt: LTF8(cmpf,freg)",
/* 261 */	"stmt: NEF8(cmpf,freg)",
/* 262 */	"stmt: EQF4(cmpf,freg)",
/* 263 */	"stmt: GEF4(cmpf,freg)",
/* 264 */	"stmt: GTF4(cmpf,freg)",
/* 265 */	"stmt: LEF4(cmpf,freg)",
/* 266 */	"stmt: LTF4(cmpf,freg)",
/* 267 */	"stmt: NEF4(cmpf,freg)",
/* 268 */	"freg: DIVF8(freg,burm37)",
/* 269 */	"freg: DIVF8(burm37,freg)",
/* 270 */	"freg: DIVF8(freg,burm38)",
/* 271 */	"freg: DIVF8(burm38,freg)",
/* 272 */	"freg: MULF8(freg,burm37)",
/* 273 */	"freg: MULF8(freg,burm38)",
/* 274 */	"freg: SUBF8(freg,burm37)",
/* 275 */	"freg: SUBF8(burm37,freg)",
/* 276 */	"freg: SUBF8(freg,burm38)",
/* 277 */	"freg: SUBF8(burm38,freg)",
/* 278 */	"freg: ADDF8(freg,burm37)",
/* 279 */	"freg: ADDF8(freg,burm38)",
/* 280 */	"freg: ADDF8(freg,burm39)",
/* 281 */	"freg: SUBF8(freg,burm39)",
/* 282 */	"freg: MULF8(freg,burm39)",
/* 283 */	"freg: DIVF8(freg,burm39)",
/* 284 */	"freg: LOADF8(memf)",
/* 285 */	"reg: CALLI4(addrj)",
/* 286 */	"reg: CALLU4(addrj)",
/* 287 */	"reg: CALLP4(addrj)",
/* 288 */	"reg: CALLI4(addrj)",
/* 289 */	"reg: CALLU4(addrj)",
/* 290 */	"reg: CALLP4(addrj)",
/* 291 */	"stmt: CALLV(addrj)",
/* 292 */	"stmt: CALLV(addrj)",
/* 293 */	"freg: CALLF4(addrj)",
/* 294 */	"freg: CALLF4(addrj)",
/* 295 */	"stmt: CALLF4(addrj)",
/* 296 */	"stmt: CALLF4(addrj)",
/* 297 */	"freg: CALLF8(addrj)",
/* 298 */	"freg: CALLF8(addrj)",
/* 299 */	"stmt: CALLF8(addrj)",
/* 300 */	"stmt: CALLF8(addrj)",
/* 301 */	"stmt: RETI4(reg)",
/* 302 */	"stmt: RETU4(reg)",
/* 303 */	"stmt: RETP4(reg)",
/* 304 */	"stmt: RETF4(freg)",
/* 305 */	"stmt: RETF8(freg)",
/* 306 */	"burm0: VREGP",
/* 307 */	"burm1: ADDI4(mem4,con1)",
/* 308 */	"burm2: ADDU4(mem4,con1)",
/* 309 */	"burm3: ADDP4(mem4,con1)",
/* 310 */	"burm4: SUBI4(mem4,con1)",
/* 311 */	"burm5: SUBU4(mem4,con1)",
/* 312 */	"burm6: SUBP4(mem4,con1)",
/* 313 */	"burm7: ADDI4(mem4,rc)",
/* 314 */	"burm8: SUBI4(mem4,rc)",
/* 315 */	"burm9: ADDU4(mem4,rc)",
/* 316 */	"burm10: SUBU4(mem4,rc)",
/* 317 */	"burm11: BANDI4(mem4,rc)",
/* 318 */	"burm12: BORI4(mem4,rc)",
/* 319 */	"burm13: BXORI4(mem4,rc)",
/* 320 */	"burm14: BANDU4(mem4,rc)",
/* 321 */	"burm15: BORU4(mem4,rc)",
/* 322 */	"burm16: BXORU4(mem4,rc)",
/* 323 */	"burm17: BCOMI4(mem4)",
/* 324 */	"burm18: BCOMU4(mem4)",
/* 325 */	"burm19: NEGI4(mem4)",
/* 326 */	"burm20: LSHI4(mem4,rc5)",
/* 327 */	"burm21: LSHU4(mem4,rc5)",
/* 328 */	"burm22: RSHI4(mem4,rc5)",
/* 329 */	"burm23: RSHU4(mem4,rc5)",
/* 330 */	"burm24: INDIRI1(addr)",
/* 331 */	"burm25: INDIRI2(addr)",
/* 332 */	"burm26: INDIRU1(addr)",
/* 333 */	"burm27: INDIRU2(addr)",
/* 334 */	"burm28: INDIRB(reg)",
/* 335 */	"burm29: INDIRF4(addr)",
/* 336 */	"burm30: INDIRF8(addr)",
/* 337 */	"burm31: CVFF4(freg)",
/* 338 */	"burm32: INDIRI4(addr)",
/* 339 */	"burm33: BANDU4(mr,con)",
/* 340 */	"burm34: BANDU4(burm40,con)",
/* 341 */	"burm35: BANDU4(burm41,con)",
/* 342 */	"burm36: BANDU4(burm42,con)",
/* 343 */	"burm37: CVIF8(burm32)",
/* 344 */	"burm38: CVIF8(burm40)",
/* 345 */	"burm39: CVFF8(burm29)",
/* 346 */	"burm40: CVII2(burm25)",
/* 347 */	"burm41: CVIU2(burm25)",
/* 348 */	"burm42: CVII1(burm24)",
};

static short _decode_stmt[] = {
	0,
	13,
	14,
	15,
	16,
	17,
	18,
	19,
	20,
	21,
	22,
	23,
	24,
	36,
	37,
	118,
	119,
	120,
	121,
	122,
	123,
	124,
	125,
	126,
	127,
	128,
	129,
	130,
	131,
	132,
	133,
	137,
	138,
	139,
	144,
	145,
	146,
	147,
	175,
	176,
	177,
	178,
	179,
	180,
	181,
	182,
	183,
	184,
	185,
	186,
	192,
	193,
	194,
	195,
	196,
	221,
	222,
	223,
	224,
	225,
	226,
	227,
	228,
	229,
	230,
	231,
	232,
	233,
	234,
	235,
	236,
	237,
	238,
	239,
	240,
	241,
	242,
	243,
	244,
	245,
	246,
	247,
	248,
	249,
	250,
	251,
	256,
	257,
	258,
	259,
	260,
	261,
	262,
	263,
	264,
	265,
	266,
	267,
	291,
	292,
	295,
	296,
	299,
	300,
	301,
	302,
	303,
	304,
	305,
};

static short _decode_reg[] = {
	0,
	1,
	2,
	3,
	4,
	5,
	6,
	7,
	8,
	9,
	10,
	94,
	95,
	96,
	97,
	98,
	99,
	100,
	101,
	102,
	103,
	104,
	105,
	106,
	107,
	108,
	109,
	110,
	111,
	112,
	113,
	114,
	115,
	116,
	117,
	134,
	135,
	136,
	140,
	141,
	142,
	143,
	150,
	151,
	152,
	153,
	154,
	155,
	156,
	157,
	158,
	159,
	160,
	161,
	162,
	163,
	164,
	165,
	166,
	167,
	168,
	169,
	170,
	213,
	285,
	286,
	287,
	288,
	289,
	290,
};

static short _decode_freg[] = {
	0,
	11,
	12,
	191,
	197,
	198,
	203,
	204,
	205,
	206,
	207,
	208,
	209,
	210,
	211,
	212,
	214,
	215,
	216,
	217,
	268,
	269,
	270,
	271,
	272,
	273,
	274,
	275,
	276,
	277,
	278,
	279,
	280,
	281,
	282,
	283,
	284,
	293,
	294,
	297,
	298,
};

static short _decode_cnst[] = {
	0,
	25,
	26,
	27,
	28,
	29,
	30,
	31,
	32,
	33,
	34,
};

static short _decode_con[] = {
	0,
	35,
};

static short _decode_acon[] = {
	0,
	38,
	39,
	40,
};

static short _decode_baseaddr[] = {
	0,
	41,
};

static short _decode_base[] = {
	0,
	42,
	43,
	44,
	45,
	46,
	47,
};

static short _decode_index[] = {
	0,
	48,
	49,
	50,
	51,
	52,
	53,
	54,
};

static short _decode_con1[] = {
	0,
	57,
	58,
};

static short _decode_con2[] = {
	0,
	59,
	60,
};

static short _decode_con3[] = {
	0,
	61,
	62,
};

static short _decode_con0[] = {
	0,
	55,
	56,
};

static short _decode_addr[] = {
	0,
	63,
	64,
	65,
	66,
	67,
	68,
	69,
	70,
	71,
	72,
	73,
	74,
};

static short _decode_mem1[] = {
	0,
	75,
	76,
};

static short _decode_mem2[] = {
	0,
	77,
	78,
};

static short _decode_mem4[] = {
	0,
	79,
	80,
	81,
};

static short _decode_rc[] = {
	0,
	82,
	83,
};

static short _decode_mr[] = {
	0,
	84,
	85,
};

static short _decode_mr1[] = {
	0,
	86,
	87,
};

static short _decode_mr2[] = {
	0,
	88,
	89,
};

static short _decode_mrc[] = {
	0,
	90,
	91,
	92,
	93,
};

static short _decode_rc5[] = {
	0,
	148,
	149,
};

static short _decode_mrca[] = {
	0,
	171,
	172,
	173,
	174,
};

static short _decode_memf[] = {
	0,
	187,
	188,
	189,
	190,
};

static short _decode_flt[] = {
	0,
	199,
	200,
};

static short _decode_flt2[] = {
	0,
	201,
	202,
};

static short _decode_addrj[] = {
	0,
	218,
	219,
	220,
};

static short _decode_cmpf[] = {
	0,
	252,
	253,
	254,
	255,
};

static short _decode_burm0[] = {
	0,
	306,
};

static short _decode_burm1[] = {
	0,
	307,
};

static short _decode_burm2[] = {
	0,
	308,
};

static short _decode_burm3[] = {
	0,
	309,
};

static short _decode_burm4[] = {
	0,
	310,
};

static short _decode_burm5[] = {
	0,
	311,
};

static short _decode_burm6[] = {
	0,
	312,
};

static short _decode_burm7[] = {
	0,
	313,
};

static short _decode_burm8[] = {
	0,
	314,
};

static short _decode_burm9[] = {
	0,
	315,
};

static short _decode_burm10[] = {
	0,
	316,
};

static short _decode_burm11[] = {
	0,
	317,
};

static short _decode_burm12[] = {
	0,
	318,
};

static short _decode_burm13[] = {
	0,
	319,
};

static short _decode_burm14[] = {
	0,
	320,
};

static short _decode_burm15[] = {
	0,
	321,
};

static short _decode_burm16[] = {
	0,
	322,
};

static short _decode_burm17[] = {
	0,
	323,
};

static short _decode_burm18[] = {
	0,
	324,
};

static short _decode_burm19[] = {
	0,
	325,
};

static short _decode_burm20[] = {
	0,
	326,
};

static short _decode_burm21[] = {
	0,
	327,
};

static short _decode_burm22[] = {
	0,
	328,
};

static short _decode_burm23[] = {
	0,
	329,
};

static short _decode_burm24[] = {
	0,
	330,
};

static short _decode_burm25[] = {
	0,
	331,
};

static short _decode_burm26[] = {
	0,
	332,
};

static short _decode_burm27[] = {
	0,
	333,
};

static short _decode_burm28[] = {
	0,
	334,
};

static short _decode_burm29[] = {
	0,
	335,
};

static short _decode_burm30[] = {
	0,
	336,
};

static short _decode_burm31[] = {
	0,
	337,
};

static short _decode_burm32[] = {
	0,
	338,
};

static short _decode_burm33[] = {
	0,
	339,
};

static short _decode_burm34[] = {
	0,
	340,
};

static short _decode_burm35[] = {
	0,
	341,
};

static short _decode_burm36[] = {
	0,
	342,
};

static short _decode_burm37[] = {
	0,
	343,
};

static short _decode_burm38[] = {
	0,
	344,
};

static short _decode_burm39[] = {
	0,
	345,
};

static short _decode_burm40[] = {
	0,
	346,
};

static short _decode_burm41[] = {
	0,
	347,
};

static short _decode_burm42[] = {
	0,
	348,
};

static int _rule(void *state, int goalnt) {
	if (goalnt < 1 || goalnt > 72)
		fatal("_rule", "Bad goal nonterminal %d\n", goalnt);
	if (!state)
		return 0;
	switch (goalnt) {
	case _stmt_NT:	return _decode_stmt[((struct _state *)state)->rule._stmt];
	case _reg_NT:	return _decode_reg[((struct _state *)state)->rule._reg];
	case _freg_NT:	return _decode_freg[((struct _state *)state)->rule._freg];
	case _cnst_NT:	return _decode_cnst[((struct _state *)state)->rule._cnst];
	case _con_NT:	return _decode_con[((struct _state *)state)->rule._con];
	case _acon_NT:	return _decode_acon[((struct _state *)state)->rule._acon];
	case _baseaddr_NT:	return _decode_baseaddr[((struct _state *)state)->rule._baseaddr];
	case _base_NT:	return _decode_base[((struct _state *)state)->rule._base];
	case _index_NT:	return _decode_index[((struct _state *)state)->rule._index];
	case _con1_NT:	return _decode_con1[((struct _state *)state)->rule._con1];
	case _con2_NT:	return _decode_con2[((struct _state *)state)->rule._con2];
	case _con3_NT:	return _decode_con3[((struct _state *)state)->rule._con3];
	case _con0_NT:	return _decode_con0[((struct _state *)state)->rule._con0];
	case _addr_NT:	return _decode_addr[((struct _state *)state)->rule._addr];
	case _mem1_NT:	return _decode_mem1[((struct _state *)state)->rule._mem1];
	case _mem2_NT:	return _decode_mem2[((struct _state *)state)->rule._mem2];
	case _mem4_NT:	return _decode_mem4[((struct _state *)state)->rule._mem4];
	case _rc_NT:	return _decode_rc[((struct _state *)state)->rule._rc];
	case _mr_NT:	return _decode_mr[((struct _state *)state)->rule._mr];
	case _mr1_NT:	return _decode_mr1[((struct _state *)state)->rule._mr1];
	case _mr2_NT:	return _decode_mr2[((struct _state *)state)->rule._mr2];
	case _mrc_NT:	return _decode_mrc[((struct _state *)state)->rule._mrc];
	case _rc5_NT:	return _decode_rc5[((struct _state *)state)->rule._rc5];
	case _mrca_NT:	return _decode_mrca[((struct _state *)state)->rule._mrca];
	case _memf_NT:	return _decode_memf[((struct _state *)state)->rule._memf];
	case _flt_NT:	return _decode_flt[((struct _state *)state)->rule._flt];
	case _flt2_NT:	return _decode_flt2[((struct _state *)state)->rule._flt2];
	case _addrj_NT:	return _decode_addrj[((struct _state *)state)->rule._addrj];
	case _cmpf_NT:	return _decode_cmpf[((struct _state *)state)->rule._cmpf];
	case _burm0_NT:	return _decode_burm0[((struct _state *)state)->rule._burm0];
	case _burm1_NT:	return _decode_burm1[((struct _state *)state)->rule._burm1];
	case _burm2_NT:	return _decode_burm2[((struct _state *)state)->rule._burm2];
	case _burm3_NT:	return _decode_burm3[((struct _state *)state)->rule._burm3];
	case _burm4_NT:	return _decode_burm4[((struct _state *)state)->rule._burm4];
	case _burm5_NT:	return _decode_burm5[((struct _state *)state)->rule._burm5];
	case _burm6_NT:	return _decode_burm6[((struct _state *)state)->rule._burm6];
	case _burm7_NT:	return _decode_burm7[((struct _state *)state)->rule._burm7];
	case _burm8_NT:	return _decode_burm8[((struct _state *)state)->rule._burm8];
	case _burm9_NT:	return _decode_burm9[((struct _state *)state)->rule._burm9];
	case _burm10_NT:	return _decode_burm10[((struct _state *)state)->rule._burm10];
	case _burm11_NT:	return _decode_burm11[((struct _state *)state)->rule._burm11];
	case _burm12_NT:	return _decode_burm12[((struct _state *)state)->rule._burm12];
	case _burm13_NT:	return _decode_burm13[((struct _state *)state)->rule._burm13];
	case _burm14_NT:	return _decode_burm14[((struct _state *)state)->rule._burm14];
	case _burm15_NT:	return _decode_burm15[((struct _state *)state)->rule._burm15];
	case _burm16_NT:	return _decode_burm16[((struct _state *)state)->rule._burm16];
	case _burm17_NT:	return _decode_burm17[((struct _state *)state)->rule._burm17];
	case _burm18_NT:	return _decode_burm18[((struct _state *)state)->rule._burm18];
	case _burm19_NT:	return _decode_burm19[((struct _state *)state)->rule._burm19];
	case _burm20_NT:	return _decode_burm20[((struct _state *)state)->rule._burm20];
	case _burm21_NT:	return _decode_burm21[((struct _state *)state)->rule._burm21];
	case _burm22_NT:	return _decode_burm22[((struct _state *)state)->rule._burm22];
	case _burm23_NT:	return _decode_burm23[((struct _state *)state)->rule._burm23];
	case _burm24_NT:	return _decode_burm24[((struct _state *)state)->rule._burm24];
	case _burm25_NT:	return _decode_burm25[((struct _state *)state)->rule._burm25];
	case _burm26_NT:	return _decode_burm26[((struct _state *)state)->rule._burm26];
	case _burm27_NT:	return _decode_burm27[((struct _state *)state)->rule._burm27];
	case _burm28_NT:	return _decode_burm28[((struct _state *)state)->rule._burm28];
	case _burm29_NT:	return _decode_burm29[((struct _state *)state)->rule._burm29];
	case _burm30_NT:	return _decode_burm30[((struct _state *)state)->rule._burm30];
	case _burm31_NT:	return _decode_burm31[((struct _state *)state)->rule._burm31];
	case _burm32_NT:	return _decode_burm32[((struct _state *)state)->rule._burm32];
	case _burm33_NT:	return _decode_burm33[((struct _state *)state)->rule._burm33];
	case _burm34_NT:	return _decode_burm34[((struct _state *)state)->rule._burm34];
	case _burm35_NT:	return _decode_burm35[((struct _state *)state)->rule._burm35];
	case _burm36_NT:	return _decode_burm36[((struct _state *)state)->rule._burm36];
	case _burm37_NT:	return _decode_burm37[((struct _state *)state)->rule._burm37];
	case _burm38_NT:	return _decode_burm38[((struct _state *)state)->rule._burm38];
	case _burm39_NT:	return _decode_burm39[((struct _state *)state)->rule._burm39];
	case _burm40_NT:	return _decode_burm40[((struct _state *)state)->rule._burm40];
	case _burm41_NT:	return _decode_burm41[((struct _state *)state)->rule._burm41];
	case _burm42_NT:	return _decode_burm42[((struct _state *)state)->rule._burm42];
	default:
		fatal("_rule", "Bad goal nonterminal %d\n", goalnt);
		return 0;
	}
}

static void _closure_reg(NODEPTR_TYPE, int, struct _state *);
static void _closure_freg(NODEPTR_TYPE, int, struct _state *);
static void _closure_cnst(NODEPTR_TYPE, int, struct _state *);
static void _closure_con(NODEPTR_TYPE, int, struct _state *);
static void _closure_baseaddr(NODEPTR_TYPE, int, struct _state *);
static void _closure_base(NODEPTR_TYPE, int, struct _state *);
static void _closure_index(NODEPTR_TYPE, int, struct _state *);
static void _closure_addr(NODEPTR_TYPE, int, struct _state *);
static void _closure_mem1(NODEPTR_TYPE, int, struct _state *);
static void _closure_mem2(NODEPTR_TYPE, int, struct _state *);
static void _closure_mem4(NODEPTR_TYPE, int, struct _state *);
static void _closure_rc(NODEPTR_TYPE, int, struct _state *);
static void _closure_mr(NODEPTR_TYPE, int, struct _state *);
static void _closure_mr1(NODEPTR_TYPE, int, struct _state *);
static void _closure_mr2(NODEPTR_TYPE, int, struct _state *);
static void _closure_memf(NODEPTR_TYPE, int, struct _state *);

static void _closure_reg(NODEPTR_TYPE a, int c, struct _state *p) {
	if (c + 2 < p->cost[_addrj_NT]) {
		p->cost[_addrj_NT] = c + 2;
		p->rule._addrj = 2;
	}
	if (c + 0 < p->cost[_rc5_NT]) {
		p->cost[_rc5_NT] = c + 0;
		p->rule._rc5 = 2;
	}
	if (c + 0 < p->cost[_mr2_NT]) {
		p->cost[_mr2_NT] = c + 0;
		p->rule._mr2 = 1;
		_closure_mr2(a, c + 0, p);
	}
	if (c + 0 < p->cost[_mr1_NT]) {
		p->cost[_mr1_NT] = c + 0;
		p->rule._mr1 = 1;
		_closure_mr1(a, c + 0, p);
	}
	if (c + 0 < p->cost[_mr_NT]) {
		p->cost[_mr_NT] = c + 0;
		p->rule._mr = 1;
		_closure_mr(a, c + 0, p);
	}
	if (c + 0 < p->cost[_rc_NT]) {
		p->cost[_rc_NT] = c + 0;
		p->rule._rc = 1;
		_closure_rc(a, c + 0, p);
	}
	if (c + 0 < p->cost[_index_NT]) {
		p->cost[_index_NT] = c + 0;
		p->rule._index = 1;
		_closure_index(a, c + 0, p);
	}
	if (c + 0 < p->cost[_base_NT]) {
		p->cost[_base_NT] = c + 0;
		p->rule._base = 1;
		_closure_base(a, c + 0, p);
	}
	if (c + 0 < p->cost[_stmt_NT]) {
		p->cost[_stmt_NT] = c + 0;
		p->rule._stmt = 13;
	}
}

static void _closure_freg(NODEPTR_TYPE a, int c, struct _state *p) {
	if (c + 0 < p->cost[_cmpf_NT]) {
		p->cost[_cmpf_NT] = c + 0;
		p->rule._cmpf = 4;
	}
	if (c + 0 < p->cost[_flt2_NT]) {
		p->cost[_flt2_NT] = c + 0;
		p->rule._flt2 = 2;
	}
	if (c + 0 < p->cost[_flt_NT]) {
		p->cost[_flt_NT] = c + 0;
		p->rule._flt = 2;
	}
	if (c + 0 < p->cost[_stmt_NT]) {
		p->cost[_stmt_NT] = c + 0;
		p->rule._stmt = 14;
	}
}

static void _closure_cnst(NODEPTR_TYPE a, int c, struct _state *p) {
	if (c + 0 < p->cost[_acon_NT]) {
		p->cost[_acon_NT] = c + 0;
		p->rule._acon = 3;
	}
	if (c + 0 < p->cost[_con_NT]) {
		p->cost[_con_NT] = c + 0;
		p->rule._con = 1;
		_closure_con(a, c + 0, p);
	}
}

static void _closure_con(NODEPTR_TYPE a, int c, struct _state *p) {
	if (c + 1 < p->cost[_reg_NT]) {
		p->cost[_reg_NT] = c + 1;
		p->rule._reg = 15;
		_closure_reg(a, c + 1, p);
	}
	if (c + 0 < p->cost[_rc_NT]) {
		p->cost[_rc_NT] = c + 0;
		p->rule._rc = 2;
		_closure_rc(a, c + 0, p);
	}
}

static void _closure_baseaddr(NODEPTR_TYPE a, int c, struct _state *p) {
	if (c + 0 < p->cost[_addr_NT]) {
		p->cost[_addr_NT] = c + 0;
		p->rule._addr = 2;
		_closure_addr(a, c + 0, p);
	}
}

static void _closure_base(NODEPTR_TYPE a, int c, struct _state *p) {
	if (c + 0 < p->cost[_addr_NT]) {
		p->cost[_addr_NT] = c + 0;
		p->rule._addr = 1;
		_closure_addr(a, c + 0, p);
	}
}

static void _closure_index(NODEPTR_TYPE a, int c, struct _state *p) {
	if (c + 0 < p->cost[_addr_NT]) {
		p->cost[_addr_NT] = c + 0;
		p->rule._addr = 12;
		_closure_addr(a, c + 0, p);
	}
}

static void _closure_addr(NODEPTR_TYPE a, int c, struct _state *p) {
	if (c + 1 < p->cost[_reg_NT]) {
		p->cost[_reg_NT] = c + 1;
		p->rule._reg = 11;
		_closure_reg(a, c + 1, p);
	}
}

static void _closure_mem1(NODEPTR_TYPE a, int c, struct _state *p) {
	if (c + 1 < p->cost[_mrc_NT]) {
		p->cost[_mrc_NT] = c + 1;
		p->rule._mrc = 2;
	}
	if (c + 0 < p->cost[_mr1_NT]) {
		p->cost[_mr1_NT] = c + 0;
		p->rule._mr1 = 2;
		_closure_mr1(a, c + 0, p);
	}
}

static void _closure_mem2(NODEPTR_TYPE a, int c, struct _state *p) {
	if (c + 1 < p->cost[_mrc_NT]) {
		p->cost[_mrc_NT] = c + 1;
		p->rule._mrc = 3;
	}
	if (c + 0 < p->cost[_mr2_NT]) {
		p->cost[_mr2_NT] = c + 0;
		p->rule._mr2 = 2;
		_closure_mr2(a, c + 0, p);
	}
}

static void _closure_mem4(NODEPTR_TYPE a, int c, struct _state *p) {
	if (c + 2 < p->cost[_addrj_NT]) {
		p->cost[_addrj_NT] = c + 2;
		p->rule._addrj = 3;
	}
	if (c + 0 < p->cost[_mrca_NT]) {
		p->cost[_mrca_NT] = c + 0;
		p->rule._mrca = 1;
	}
	if (c + 1 < p->cost[_mrc_NT]) {
		p->cost[_mrc_NT] = c + 1;
		p->rule._mrc = 1;
	}
	if (c + 0 < p->cost[_mr_NT]) {
		p->cost[_mr_NT] = c + 0;
		p->rule._mr = 2;
		_closure_mr(a, c + 0, p);
	}
}

static void _closure_rc(NODEPTR_TYPE a, int c, struct _state *p) {
	if (c + 0 < p->cost[_mrca_NT]) {
		p->cost[_mrca_NT] = c + 0;
		p->rule._mrca = 2;
	}
	if (c + 0 < p->cost[_mrc_NT]) {
		p->cost[_mrc_NT] = c + 0;
		p->rule._mrc = 4;
	}
}

static void _closure_mr(NODEPTR_TYPE a, int c, struct _state *p) {
	if (c + 1 < p->cost[_reg_NT]) {
		p->cost[_reg_NT] = c + 1;
		p->rule._reg = 12;
		_closure_reg(a, c + 1, p);
	}
}

static void _closure_mr1(NODEPTR_TYPE a, int c, struct _state *p) {
	if (c + 1 < p->cost[_reg_NT]) {
		p->cost[_reg_NT] = c + 1;
		p->rule._reg = 13;
		_closure_reg(a, c + 1, p);
	}
}

static void _closure_mr2(NODEPTR_TYPE a, int c, struct _state *p) {
	if (c + 1 < p->cost[_reg_NT]) {
		p->cost[_reg_NT] = c + 1;
		p->rule._reg = 14;
		_closure_reg(a, c + 1, p);
	}
}

static void _closure_memf(NODEPTR_TYPE a, int c, struct _state *p) {
	if (c + 0 < p->cost[_flt2_NT]) {
		p->cost[_flt2_NT] = c + 0;
		p->rule._flt2 = 1;
	}
	if (c + 0 < p->cost[_flt_NT]) {
		p->cost[_flt_NT] = c + 0;
		p->rule._flt = 1;
	}
	if (c + 3 < p->cost[_freg_NT]) {
		p->cost[_freg_NT] = c + 3;
		p->rule._freg = 3;
		_closure_freg(a, c + 3, p);
	}
}

static struct _state * _label2(NODEPTR_TYPE a) {
	int c;
	struct _state *p;

	p = allocate(sizeof *p, PERM);
	p->rule._stmt = 0;
	p->cost[1] =
	p->cost[2] =
	p->cost[3] =
	p->cost[4] =
	p->cost[5] =
	p->cost[6] =
	p->cost[7] =
	p->cost[8] =
	p->cost[9] =
	p->cost[10] =
	p->cost[11] =
	p->cost[12] =
	p->cost[13] =
	p->cost[14] =
	p->cost[15] =
	p->cost[16] =
	p->cost[17] =
	p->cost[18] =
	p->cost[19] =
	p->cost[20] =
	p->cost[21] =
	p->cost[22] =
	p->cost[23] =
	p->cost[24] =
	p->cost[25] =
	p->cost[26] =
	p->cost[27] =
	p->cost[28] =
	p->cost[29] =
	p->cost[30] =
	p->cost[31] =
	p->cost[32] =
	p->cost[33] =
	p->cost[34] =
	p->cost[35] =
	p->cost[36] =
	p->cost[37] =
	p->cost[38] =
	p->cost[39] =
	p->cost[40] =
	p->cost[41] =
	p->cost[42] =
	p->cost[43] =
	p->cost[44] =
	p->cost[45] =
	p->cost[46] =
	p->cost[47] =
	p->cost[48] =
	p->cost[49] =
	p->cost[50] =
	p->cost[51] =
	p->cost[52] =
	p->cost[53] =
	p->cost[54] =
	p->cost[55] =
	p->cost[56] =
	p->cost[57] =
	p->cost[58] =
	p->cost[59] =
	p->cost[60] =
	p->cost[61] =
	p->cost[62] =
	p->cost[63] =
	p->cost[64] =
	p->cost[65] =
	p->cost[66] =
	p->cost[67] =
	p->cost[68] =
	p->cost[69] =
	p->cost[70] =
	p->cost[71] =
	p->cost[72] =
		0x7fff;
	switch (OP_LABEL(a)) {
	case 41: /* ARGB */
		/* stmt: ARGB(burm28) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm28_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 49;
		}
		break;
	case 57: /* ASGNB */
		/* stmt: ASGNB(reg,burm28) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_burm28_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 48;
		}
		break;
	case 73: /* INDIRB */
		/* burm28: INDIRB(reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
		if (c + 0 < p->cost[_burm28_NT]) {
			p->cost[_burm28_NT] = c + 0;
			p->rule._burm28 = 1;
		}
		break;
	case 216: /* CALLV */
		/* stmt: CALLV(addrj) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addrj_NT] + (hasargs(a));
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 98;
		}
		/* stmt: CALLV(addrj) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addrj_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 99;
		}
		break;
	case 217: /* CALLB */
		break;
	case 233: /* LOADB */
		break;
	case 248: /* RETV */
		break;
	case 584: /* JUMPV */
		/* stmt: JUMPV(addrj) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addrj_NT] + 3;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 56;
		}
		break;
	case 600: /* LABELV */
		/* stmt: LABELV */
		if (0 + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = 0 + 0;
			p->rule._stmt = 55;
		}
		break;
	case 711: /* VREGP */
		/* burm0: VREGP */
		if (0 + 0 < p->cost[_burm0_NT]) {
			p->cost[_burm0_NT] = 0 + 0;
			p->rule._burm0 = 1;
		}
		break;
	case 1045: /* CNSTI1 */
		/* cnst: CNSTI1 */
		if (0 + 0 < p->cost[_cnst_NT]) {
			p->cost[_cnst_NT] = 0 + 0;
			p->rule._cnst = 1;
			_closure_cnst(a, 0 + 0, p);
		}
		break;
	case 1046: /* CNSTU1 */
		/* cnst: CNSTU1 */
		if (0 + 0 < p->cost[_cnst_NT]) {
			p->cost[_cnst_NT] = 0 + 0;
			p->rule._cnst = 2;
			_closure_cnst(a, 0 + 0, p);
		}
		break;
	case 1077: /* ASGNI1 */
		/* stmt: ASGNI1(burm0,reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm0_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 1;
		}
		/* stmt: ASGNI1(addr,rc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 38;
		}
		break;
	case 1078: /* ASGNU1 */
		/* stmt: ASGNU1(burm0,reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm0_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 2;
		}
		/* stmt: ASGNU1(addr,rc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 41;
		}
		break;
	case 1093: /* INDIRI1 */
		/* reg: INDIRI1(burm0) */
		if (mayrecalc(a)) {
			struct _state *q = a->syms[RX]->u.t.cse->x.state;
			if (q->cost[_stmt_NT] == 0) {
				p->cost[_stmt_NT] = 0;
				p->rule._stmt = q->rule._stmt;
			}
			if (q->cost[_reg_NT] == 0) {
				p->cost[_reg_NT] = 0;
				p->rule._reg = q->rule._reg;
			}
			if (q->cost[_freg_NT] == 0) {
				p->cost[_freg_NT] = 0;
				p->rule._freg = q->rule._freg;
			}
			if (q->cost[_cnst_NT] == 0) {
				p->cost[_cnst_NT] = 0;
				p->rule._cnst = q->rule._cnst;
			}
			if (q->cost[_con_NT] == 0) {
				p->cost[_con_NT] = 0;
				p->rule._con = q->rule._con;
			}
			if (q->cost[_acon_NT] == 0) {
				p->cost[_acon_NT] = 0;
				p->rule._acon = q->rule._acon;
			}
			if (q->cost[_baseaddr_NT] == 0) {
				p->cost[_baseaddr_NT] = 0;
				p->rule._baseaddr = q->rule._baseaddr;
			}
			if (q->cost[_base_NT] == 0) {
				p->cost[_base_NT] = 0;
				p->rule._base = q->rule._base;
			}
			if (q->cost[_index_NT] == 0) {
				p->cost[_index_NT] = 0;
				p->rule._index = q->rule._index;
			}
			if (q->cost[_con1_NT] == 0) {
				p->cost[_con1_NT] = 0;
				p->rule._con1 = q->rule._con1;
			}
			if (q->cost[_con2_NT] == 0) {
				p->cost[_con2_NT] = 0;
				p->rule._con2 = q->rule._con2;
			}
			if (q->cost[_con3_NT] == 0) {
				p->cost[_con3_NT] = 0;
				p->rule._con3 = q->rule._con3;
			}
			if (q->cost[_con0_NT] == 0) {
				p->cost[_con0_NT] = 0;
				p->rule._con0 = q->rule._con0;
			}
			if (q->cost[_addr_NT] == 0) {
				p->cost[_addr_NT] = 0;
				p->rule._addr = q->rule._addr;
			}
			if (q->cost[_mem1_NT] == 0) {
				p->cost[_mem1_NT] = 0;
				p->rule._mem1 = q->rule._mem1;
			}
			if (q->cost[_mem2_NT] == 0) {
				p->cost[_mem2_NT] = 0;
				p->rule._mem2 = q->rule._mem2;
			}
			if (q->cost[_mem4_NT] == 0) {
				p->cost[_mem4_NT] = 0;
				p->rule._mem4 = q->rule._mem4;
			}
			if (q->cost[_rc_NT] == 0) {
				p->cost[_rc_NT] = 0;
				p->rule._rc = q->rule._rc;
			}
			if (q->cost[_mr_NT] == 0) {
				p->cost[_mr_NT] = 0;
				p->rule._mr = q->rule._mr;
			}
			if (q->cost[_mr1_NT] == 0) {
				p->cost[_mr1_NT] = 0;
				p->rule._mr1 = q->rule._mr1;
			}
			if (q->cost[_mr2_NT] == 0) {
				p->cost[_mr2_NT] = 0;
				p->rule._mr2 = q->rule._mr2;
			}
			if (q->cost[_mrc_NT] == 0) {
				p->cost[_mrc_NT] = 0;
				p->rule._mrc = q->rule._mrc;
			}
			if (q->cost[_rc5_NT] == 0) {
				p->cost[_rc5_NT] = 0;
				p->rule._rc5 = q->rule._rc5;
			}
			if (q->cost[_mrca_NT] == 0) {
				p->cost[_mrca_NT] = 0;
				p->rule._mrca = q->rule._mrca;
			}
			if (q->cost[_memf_NT] == 0) {
				p->cost[_memf_NT] = 0;
				p->rule._memf = q->rule._memf;
			}
			if (q->cost[_flt_NT] == 0) {
				p->cost[_flt_NT] = 0;
				p->rule._flt = q->rule._flt;
			}
			if (q->cost[_flt2_NT] == 0) {
				p->cost[_flt2_NT] = 0;
				p->rule._flt2 = q->rule._flt2;
			}
			if (q->cost[_addrj_NT] == 0) {
				p->cost[_addrj_NT] = 0;
				p->rule._addrj = q->rule._addrj;
			}
			if (q->cost[_cmpf_NT] == 0) {
				p->cost[_cmpf_NT] = 0;
				p->rule._cmpf = q->rule._cmpf;
			}
			if (q->cost[_burm0_NT] == 0) {
				p->cost[_burm0_NT] = 0;
				p->rule._burm0 = q->rule._burm0;
			}
			if (q->cost[_burm1_NT] == 0) {
				p->cost[_burm1_NT] = 0;
				p->rule._burm1 = q->rule._burm1;
			}
			if (q->cost[_burm2_NT] == 0) {
				p->cost[_burm2_NT] = 0;
				p->rule._burm2 = q->rule._burm2;
			}
			if (q->cost[_burm3_NT] == 0) {
				p->cost[_burm3_NT] = 0;
				p->rule._burm3 = q->rule._burm3;
			}
			if (q->cost[_burm4_NT] == 0) {
				p->cost[_burm4_NT] = 0;
				p->rule._burm4 = q->rule._burm4;
			}
			if (q->cost[_burm5_NT] == 0) {
				p->cost[_burm5_NT] = 0;
				p->rule._burm5 = q->rule._burm5;
			}
			if (q->cost[_burm6_NT] == 0) {
				p->cost[_burm6_NT] = 0;
				p->rule._burm6 = q->rule._burm6;
			}
			if (q->cost[_burm7_NT] == 0) {
				p->cost[_burm7_NT] = 0;
				p->rule._burm7 = q->rule._burm7;
			}
			if (q->cost[_burm8_NT] == 0) {
				p->cost[_burm8_NT] = 0;
				p->rule._burm8 = q->rule._burm8;
			}
			if (q->cost[_burm9_NT] == 0) {
				p->cost[_burm9_NT] = 0;
				p->rule._burm9 = q->rule._burm9;
			}
			if (q->cost[_burm10_NT] == 0) {
				p->cost[_burm10_NT] = 0;
				p->rule._burm10 = q->rule._burm10;
			}
			if (q->cost[_burm11_NT] == 0) {
				p->cost[_burm11_NT] = 0;
				p->rule._burm11 = q->rule._burm11;
			}
			if (q->cost[_burm12_NT] == 0) {
				p->cost[_burm12_NT] = 0;
				p->rule._burm12 = q->rule._burm12;
			}
			if (q->cost[_burm13_NT] == 0) {
				p->cost[_burm13_NT] = 0;
				p->rule._burm13 = q->rule._burm13;
			}
			if (q->cost[_burm14_NT] == 0) {
				p->cost[_burm14_NT] = 0;
				p->rule._burm14 = q->rule._burm14;
			}
			if (q->cost[_burm15_NT] == 0) {
				p->cost[_burm15_NT] = 0;
				p->rule._burm15 = q->rule._burm15;
			}
			if (q->cost[_burm16_NT] == 0) {
				p->cost[_burm16_NT] = 0;
				p->rule._burm16 = q->rule._burm16;
			}
			if (q->cost[_burm17_NT] == 0) {
				p->cost[_burm17_NT] = 0;
				p->rule._burm17 = q->rule._burm17;
			}
			if (q->cost[_burm18_NT] == 0) {
				p->cost[_burm18_NT] = 0;
				p->rule._burm18 = q->rule._burm18;
			}
			if (q->cost[_burm19_NT] == 0) {
				p->cost[_burm19_NT] = 0;
				p->rule._burm19 = q->rule._burm19;
			}
			if (q->cost[_burm20_NT] == 0) {
				p->cost[_burm20_NT] = 0;
				p->rule._burm20 = q->rule._burm20;
			}
			if (q->cost[_burm21_NT] == 0) {
				p->cost[_burm21_NT] = 0;
				p->rule._burm21 = q->rule._burm21;
			}
			if (q->cost[_burm22_NT] == 0) {
				p->cost[_burm22_NT] = 0;
				p->rule._burm22 = q->rule._burm22;
			}
			if (q->cost[_burm23_NT] == 0) {
				p->cost[_burm23_NT] = 0;
				p->rule._burm23 = q->rule._burm23;
			}
			if (q->cost[_burm24_NT] == 0) {
				p->cost[_burm24_NT] = 0;
				p->rule._burm24 = q->rule._burm24;
			}
			if (q->cost[_burm25_NT] == 0) {
				p->cost[_burm25_NT] = 0;
				p->rule._burm25 = q->rule._burm25;
			}
			if (q->cost[_burm26_NT] == 0) {
				p->cost[_burm26_NT] = 0;
				p->rule._burm26 = q->rule._burm26;
			}
			if (q->cost[_burm27_NT] == 0) {
				p->cost[_burm27_NT] = 0;
				p->rule._burm27 = q->rule._burm27;
			}
			if (q->cost[_burm28_NT] == 0) {
				p->cost[_burm28_NT] = 0;
				p->rule._burm28 = q->rule._burm28;
			}
			if (q->cost[_burm29_NT] == 0) {
				p->cost[_burm29_NT] = 0;
				p->rule._burm29 = q->rule._burm29;
			}
			if (q->cost[_burm30_NT] == 0) {
				p->cost[_burm30_NT] = 0;
				p->rule._burm30 = q->rule._burm30;
			}
			if (q->cost[_burm31_NT] == 0) {
				p->cost[_burm31_NT] = 0;
				p->rule._burm31 = q->rule._burm31;
			}
			if (q->cost[_burm32_NT] == 0) {
				p->cost[_burm32_NT] = 0;
				p->rule._burm32 = q->rule._burm32;
			}
			if (q->cost[_burm33_NT] == 0) {
				p->cost[_burm33_NT] = 0;
				p->rule._burm33 = q->rule._burm33;
			}
			if (q->cost[_burm34_NT] == 0) {
				p->cost[_burm34_NT] = 0;
				p->rule._burm34 = q->rule._burm34;
			}
			if (q->cost[_burm35_NT] == 0) {
				p->cost[_burm35_NT] = 0;
				p->rule._burm35 = q->rule._burm35;
			}
			if (q->cost[_burm36_NT] == 0) {
				p->cost[_burm36_NT] = 0;
				p->rule._burm36 = q->rule._burm36;
			}
			if (q->cost[_burm37_NT] == 0) {
				p->cost[_burm37_NT] = 0;
				p->rule._burm37 = q->rule._burm37;
			}
			if (q->cost[_burm38_NT] == 0) {
				p->cost[_burm38_NT] = 0;
				p->rule._burm38 = q->rule._burm38;
			}
			if (q->cost[_burm39_NT] == 0) {
				p->cost[_burm39_NT] = 0;
				p->rule._burm39 = q->rule._burm39;
			}
			if (q->cost[_burm40_NT] == 0) {
				p->cost[_burm40_NT] = 0;
				p->rule._burm40 = q->rule._burm40;
			}
			if (q->cost[_burm41_NT] == 0) {
				p->cost[_burm41_NT] = 0;
				p->rule._burm41 = q->rule._burm41;
			}
			if (q->cost[_burm42_NT] == 0) {
				p->cost[_burm42_NT] = 0;
				p->rule._burm42 = q->rule._burm42;
			}
		}
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm0_NT] + 0;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 1;
			_closure_reg(a, c + 0, p);
		}
		/* mem1: INDIRI1(addr) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + 0;
		if (c + 0 < p->cost[_mem1_NT]) {
			p->cost[_mem1_NT] = c + 0;
			p->rule._mem1 = 1;
			_closure_mem1(a, c + 0, p);
		}
		/* burm24: INDIRI1(addr) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + 0;
		if (c + 0 < p->cost[_burm24_NT]) {
			p->cost[_burm24_NT] = c + 0;
			p->rule._burm24 = 1;
		}
		break;
	case 1094: /* INDIRU1 */
		/* reg: INDIRU1(burm0) */
		if (mayrecalc(a)) {
			struct _state *q = a->syms[RX]->u.t.cse->x.state;
			if (q->cost[_stmt_NT] == 0) {
				p->cost[_stmt_NT] = 0;
				p->rule._stmt = q->rule._stmt;
			}
			if (q->cost[_reg_NT] == 0) {
				p->cost[_reg_NT] = 0;
				p->rule._reg = q->rule._reg;
			}
			if (q->cost[_freg_NT] == 0) {
				p->cost[_freg_NT] = 0;
				p->rule._freg = q->rule._freg;
			}
			if (q->cost[_cnst_NT] == 0) {
				p->cost[_cnst_NT] = 0;
				p->rule._cnst = q->rule._cnst;
			}
			if (q->cost[_con_NT] == 0) {
				p->cost[_con_NT] = 0;
				p->rule._con = q->rule._con;
			}
			if (q->cost[_acon_NT] == 0) {
				p->cost[_acon_NT] = 0;
				p->rule._acon = q->rule._acon;
			}
			if (q->cost[_baseaddr_NT] == 0) {
				p->cost[_baseaddr_NT] = 0;
				p->rule._baseaddr = q->rule._baseaddr;
			}
			if (q->cost[_base_NT] == 0) {
				p->cost[_base_NT] = 0;
				p->rule._base = q->rule._base;
			}
			if (q->cost[_index_NT] == 0) {
				p->cost[_index_NT] = 0;
				p->rule._index = q->rule._index;
			}
			if (q->cost[_con1_NT] == 0) {
				p->cost[_con1_NT] = 0;
				p->rule._con1 = q->rule._con1;
			}
			if (q->cost[_con2_NT] == 0) {
				p->cost[_con2_NT] = 0;
				p->rule._con2 = q->rule._con2;
			}
			if (q->cost[_con3_NT] == 0) {
				p->cost[_con3_NT] = 0;
				p->rule._con3 = q->rule._con3;
			}
			if (q->cost[_con0_NT] == 0) {
				p->cost[_con0_NT] = 0;
				p->rule._con0 = q->rule._con0;
			}
			if (q->cost[_addr_NT] == 0) {
				p->cost[_addr_NT] = 0;
				p->rule._addr = q->rule._addr;
			}
			if (q->cost[_mem1_NT] == 0) {
				p->cost[_mem1_NT] = 0;
				p->rule._mem1 = q->rule._mem1;
			}
			if (q->cost[_mem2_NT] == 0) {
				p->cost[_mem2_NT] = 0;
				p->rule._mem2 = q->rule._mem2;
			}
			if (q->cost[_mem4_NT] == 0) {
				p->cost[_mem4_NT] = 0;
				p->rule._mem4 = q->rule._mem4;
			}
			if (q->cost[_rc_NT] == 0) {
				p->cost[_rc_NT] = 0;
				p->rule._rc = q->rule._rc;
			}
			if (q->cost[_mr_NT] == 0) {
				p->cost[_mr_NT] = 0;
				p->rule._mr = q->rule._mr;
			}
			if (q->cost[_mr1_NT] == 0) {
				p->cost[_mr1_NT] = 0;
				p->rule._mr1 = q->rule._mr1;
			}
			if (q->cost[_mr2_NT] == 0) {
				p->cost[_mr2_NT] = 0;
				p->rule._mr2 = q->rule._mr2;
			}
			if (q->cost[_mrc_NT] == 0) {
				p->cost[_mrc_NT] = 0;
				p->rule._mrc = q->rule._mrc;
			}
			if (q->cost[_rc5_NT] == 0) {
				p->cost[_rc5_NT] = 0;
				p->rule._rc5 = q->rule._rc5;
			}
			if (q->cost[_mrca_NT] == 0) {
				p->cost[_mrca_NT] = 0;
				p->rule._mrca = q->rule._mrca;
			}
			if (q->cost[_memf_NT] == 0) {
				p->cost[_memf_NT] = 0;
				p->rule._memf = q->rule._memf;
			}
			if (q->cost[_flt_NT] == 0) {
				p->cost[_flt_NT] = 0;
				p->rule._flt = q->rule._flt;
			}
			if (q->cost[_flt2_NT] == 0) {
				p->cost[_flt2_NT] = 0;
				p->rule._flt2 = q->rule._flt2;
			}
			if (q->cost[_addrj_NT] == 0) {
				p->cost[_addrj_NT] = 0;
				p->rule._addrj = q->rule._addrj;
			}
			if (q->cost[_cmpf_NT] == 0) {
				p->cost[_cmpf_NT] = 0;
				p->rule._cmpf = q->rule._cmpf;
			}
			if (q->cost[_burm0_NT] == 0) {
				p->cost[_burm0_NT] = 0;
				p->rule._burm0 = q->rule._burm0;
			}
			if (q->cost[_burm1_NT] == 0) {
				p->cost[_burm1_NT] = 0;
				p->rule._burm1 = q->rule._burm1;
			}
			if (q->cost[_burm2_NT] == 0) {
				p->cost[_burm2_NT] = 0;
				p->rule._burm2 = q->rule._burm2;
			}
			if (q->cost[_burm3_NT] == 0) {
				p->cost[_burm3_NT] = 0;
				p->rule._burm3 = q->rule._burm3;
			}
			if (q->cost[_burm4_NT] == 0) {
				p->cost[_burm4_NT] = 0;
				p->rule._burm4 = q->rule._burm4;
			}
			if (q->cost[_burm5_NT] == 0) {
				p->cost[_burm5_NT] = 0;
				p->rule._burm5 = q->rule._burm5;
			}
			if (q->cost[_burm6_NT] == 0) {
				p->cost[_burm6_NT] = 0;
				p->rule._burm6 = q->rule._burm6;
			}
			if (q->cost[_burm7_NT] == 0) {
				p->cost[_burm7_NT] = 0;
				p->rule._burm7 = q->rule._burm7;
			}
			if (q->cost[_burm8_NT] == 0) {
				p->cost[_burm8_NT] = 0;
				p->rule._burm8 = q->rule._burm8;
			}
			if (q->cost[_burm9_NT] == 0) {
				p->cost[_burm9_NT] = 0;
				p->rule._burm9 = q->rule._burm9;
			}
			if (q->cost[_burm10_NT] == 0) {
				p->cost[_burm10_NT] = 0;
				p->rule._burm10 = q->rule._burm10;
			}
			if (q->cost[_burm11_NT] == 0) {
				p->cost[_burm11_NT] = 0;
				p->rule._burm11 = q->rule._burm11;
			}
			if (q->cost[_burm12_NT] == 0) {
				p->cost[_burm12_NT] = 0;
				p->rule._burm12 = q->rule._burm12;
			}
			if (q->cost[_burm13_NT] == 0) {
				p->cost[_burm13_NT] = 0;
				p->rule._burm13 = q->rule._burm13;
			}
			if (q->cost[_burm14_NT] == 0) {
				p->cost[_burm14_NT] = 0;
				p->rule._burm14 = q->rule._burm14;
			}
			if (q->cost[_burm15_NT] == 0) {
				p->cost[_burm15_NT] = 0;
				p->rule._burm15 = q->rule._burm15;
			}
			if (q->cost[_burm16_NT] == 0) {
				p->cost[_burm16_NT] = 0;
				p->rule._burm16 = q->rule._burm16;
			}
			if (q->cost[_burm17_NT] == 0) {
				p->cost[_burm17_NT] = 0;
				p->rule._burm17 = q->rule._burm17;
			}
			if (q->cost[_burm18_NT] == 0) {
				p->cost[_burm18_NT] = 0;
				p->rule._burm18 = q->rule._burm18;
			}
			if (q->cost[_burm19_NT] == 0) {
				p->cost[_burm19_NT] = 0;
				p->rule._burm19 = q->rule._burm19;
			}
			if (q->cost[_burm20_NT] == 0) {
				p->cost[_burm20_NT] = 0;
				p->rule._burm20 = q->rule._burm20;
			}
			if (q->cost[_burm21_NT] == 0) {
				p->cost[_burm21_NT] = 0;
				p->rule._burm21 = q->rule._burm21;
			}
			if (q->cost[_burm22_NT] == 0) {
				p->cost[_burm22_NT] = 0;
				p->rule._burm22 = q->rule._burm22;
			}
			if (q->cost[_burm23_NT] == 0) {
				p->cost[_burm23_NT] = 0;
				p->rule._burm23 = q->rule._burm23;
			}
			if (q->cost[_burm24_NT] == 0) {
				p->cost[_burm24_NT] = 0;
				p->rule._burm24 = q->rule._burm24;
			}
			if (q->cost[_burm25_NT] == 0) {
				p->cost[_burm25_NT] = 0;
				p->rule._burm25 = q->rule._burm25;
			}
			if (q->cost[_burm26_NT] == 0) {
				p->cost[_burm26_NT] = 0;
				p->rule._burm26 = q->rule._burm26;
			}
			if (q->cost[_burm27_NT] == 0) {
				p->cost[_burm27_NT] = 0;
				p->rule._burm27 = q->rule._burm27;
			}
			if (q->cost[_burm28_NT] == 0) {
				p->cost[_burm28_NT] = 0;
				p->rule._burm28 = q->rule._burm28;
			}
			if (q->cost[_burm29_NT] == 0) {
				p->cost[_burm29_NT] = 0;
				p->rule._burm29 = q->rule._burm29;
			}
			if (q->cost[_burm30_NT] == 0) {
				p->cost[_burm30_NT] = 0;
				p->rule._burm30 = q->rule._burm30;
			}
			if (q->cost[_burm31_NT] == 0) {
				p->cost[_burm31_NT] = 0;
				p->rule._burm31 = q->rule._burm31;
			}
			if (q->cost[_burm32_NT] == 0) {
				p->cost[_burm32_NT] = 0;
				p->rule._burm32 = q->rule._burm32;
			}
			if (q->cost[_burm33_NT] == 0) {
				p->cost[_burm33_NT] = 0;
				p->rule._burm33 = q->rule._burm33;
			}
			if (q->cost[_burm34_NT] == 0) {
				p->cost[_burm34_NT] = 0;
				p->rule._burm34 = q->rule._burm34;
			}
			if (q->cost[_burm35_NT] == 0) {
				p->cost[_burm35_NT] = 0;
				p->rule._burm35 = q->rule._burm35;
			}
			if (q->cost[_burm36_NT] == 0) {
				p->cost[_burm36_NT] = 0;
				p->rule._burm36 = q->rule._burm36;
			}
			if (q->cost[_burm37_NT] == 0) {
				p->cost[_burm37_NT] = 0;
				p->rule._burm37 = q->rule._burm37;
			}
			if (q->cost[_burm38_NT] == 0) {
				p->cost[_burm38_NT] = 0;
				p->rule._burm38 = q->rule._burm38;
			}
			if (q->cost[_burm39_NT] == 0) {
				p->cost[_burm39_NT] = 0;
				p->rule._burm39 = q->rule._burm39;
			}
			if (q->cost[_burm40_NT] == 0) {
				p->cost[_burm40_NT] = 0;
				p->rule._burm40 = q->rule._burm40;
			}
			if (q->cost[_burm41_NT] == 0) {
				p->cost[_burm41_NT] = 0;
				p->rule._burm41 = q->rule._burm41;
			}
			if (q->cost[_burm42_NT] == 0) {
				p->cost[_burm42_NT] = 0;
				p->rule._burm42 = q->rule._burm42;
			}
		}
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm0_NT] + 0;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 2;
			_closure_reg(a, c + 0, p);
		}
		/* mem1: INDIRU1(addr) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + 0;
		if (c + 0 < p->cost[_mem1_NT]) {
			p->cost[_mem1_NT] = c + 0;
			p->rule._mem1 = 2;
			_closure_mem1(a, c + 0, p);
		}
		/* burm26: INDIRU1(addr) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + 0;
		if (c + 0 < p->cost[_burm26_NT]) {
			p->cost[_burm26_NT] = c + 0;
			p->rule._burm26 = 1;
		}
		break;
	case 1157: /* CVII1 */
		/* reg: CVII1(reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 59;
			_closure_reg(a, c + 0, p);
		}
		/* burm42: CVII1(burm24) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm24_NT] + 0;
		if (c + 0 < p->cost[_burm42_NT]) {
			p->cost[_burm42_NT] = c + 0;
			p->rule._burm42 = 1;
		}
		break;
	case 1158: /* CVIU1 */
		break;
	case 1205: /* CVUI1 */
		break;
	case 1206: /* CVUU1 */
		/* reg: CVUU1(reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 61;
			_closure_reg(a, c + 0, p);
		}
		break;
	case 1253: /* LOADI1 */
		/* reg: LOADI1(reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 16;
			_closure_reg(a, c + 0, p);
		}
		break;
	case 1254: /* LOADU1 */
		/* reg: LOADU1(reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 19;
			_closure_reg(a, c + 0, p);
		}
		break;
	case 2069: /* CNSTI2 */
		/* cnst: CNSTI2 */
		if (0 + 0 < p->cost[_cnst_NT]) {
			p->cost[_cnst_NT] = 0 + 0;
			p->rule._cnst = 3;
			_closure_cnst(a, 0 + 0, p);
		}
		break;
	case 2070: /* CNSTU2 */
		/* cnst: CNSTU2 */
		if (0 + 0 < p->cost[_cnst_NT]) {
			p->cost[_cnst_NT] = 0 + 0;
			p->rule._cnst = 4;
			_closure_cnst(a, 0 + 0, p);
		}
		break;
	case 2101: /* ASGNI2 */
		/* stmt: ASGNI2(burm0,reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm0_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 3;
		}
		/* stmt: ASGNI2(addr,rc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 39;
		}
		break;
	case 2102: /* ASGNU2 */
		/* stmt: ASGNU2(burm0,reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm0_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 4;
		}
		/* stmt: ASGNU2(addr,rc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 42;
		}
		break;
	case 2117: /* INDIRI2 */
		/* reg: INDIRI2(burm0) */
		if (mayrecalc(a)) {
			struct _state *q = a->syms[RX]->u.t.cse->x.state;
			if (q->cost[_stmt_NT] == 0) {
				p->cost[_stmt_NT] = 0;
				p->rule._stmt = q->rule._stmt;
			}
			if (q->cost[_reg_NT] == 0) {
				p->cost[_reg_NT] = 0;
				p->rule._reg = q->rule._reg;
			}
			if (q->cost[_freg_NT] == 0) {
				p->cost[_freg_NT] = 0;
				p->rule._freg = q->rule._freg;
			}
			if (q->cost[_cnst_NT] == 0) {
				p->cost[_cnst_NT] = 0;
				p->rule._cnst = q->rule._cnst;
			}
			if (q->cost[_con_NT] == 0) {
				p->cost[_con_NT] = 0;
				p->rule._con = q->rule._con;
			}
			if (q->cost[_acon_NT] == 0) {
				p->cost[_acon_NT] = 0;
				p->rule._acon = q->rule._acon;
			}
			if (q->cost[_baseaddr_NT] == 0) {
				p->cost[_baseaddr_NT] = 0;
				p->rule._baseaddr = q->rule._baseaddr;
			}
			if (q->cost[_base_NT] == 0) {
				p->cost[_base_NT] = 0;
				p->rule._base = q->rule._base;
			}
			if (q->cost[_index_NT] == 0) {
				p->cost[_index_NT] = 0;
				p->rule._index = q->rule._index;
			}
			if (q->cost[_con1_NT] == 0) {
				p->cost[_con1_NT] = 0;
				p->rule._con1 = q->rule._con1;
			}
			if (q->cost[_con2_NT] == 0) {
				p->cost[_con2_NT] = 0;
				p->rule._con2 = q->rule._con2;
			}
			if (q->cost[_con3_NT] == 0) {
				p->cost[_con3_NT] = 0;
				p->rule._con3 = q->rule._con3;
			}
			if (q->cost[_con0_NT] == 0) {
				p->cost[_con0_NT] = 0;
				p->rule._con0 = q->rule._con0;
			}
			if (q->cost[_addr_NT] == 0) {
				p->cost[_addr_NT] = 0;
				p->rule._addr = q->rule._addr;
			}
			if (q->cost[_mem1_NT] == 0) {
				p->cost[_mem1_NT] = 0;
				p->rule._mem1 = q->rule._mem1;
			}
			if (q->cost[_mem2_NT] == 0) {
				p->cost[_mem2_NT] = 0;
				p->rule._mem2 = q->rule._mem2;
			}
			if (q->cost[_mem4_NT] == 0) {
				p->cost[_mem4_NT] = 0;
				p->rule._mem4 = q->rule._mem4;
			}
			if (q->cost[_rc_NT] == 0) {
				p->cost[_rc_NT] = 0;
				p->rule._rc = q->rule._rc;
			}
			if (q->cost[_mr_NT] == 0) {
				p->cost[_mr_NT] = 0;
				p->rule._mr = q->rule._mr;
			}
			if (q->cost[_mr1_NT] == 0) {
				p->cost[_mr1_NT] = 0;
				p->rule._mr1 = q->rule._mr1;
			}
			if (q->cost[_mr2_NT] == 0) {
				p->cost[_mr2_NT] = 0;
				p->rule._mr2 = q->rule._mr2;
			}
			if (q->cost[_mrc_NT] == 0) {
				p->cost[_mrc_NT] = 0;
				p->rule._mrc = q->rule._mrc;
			}
			if (q->cost[_rc5_NT] == 0) {
				p->cost[_rc5_NT] = 0;
				p->rule._rc5 = q->rule._rc5;
			}
			if (q->cost[_mrca_NT] == 0) {
				p->cost[_mrca_NT] = 0;
				p->rule._mrca = q->rule._mrca;
			}
			if (q->cost[_memf_NT] == 0) {
				p->cost[_memf_NT] = 0;
				p->rule._memf = q->rule._memf;
			}
			if (q->cost[_flt_NT] == 0) {
				p->cost[_flt_NT] = 0;
				p->rule._flt = q->rule._flt;
			}
			if (q->cost[_flt2_NT] == 0) {
				p->cost[_flt2_NT] = 0;
				p->rule._flt2 = q->rule._flt2;
			}
			if (q->cost[_addrj_NT] == 0) {
				p->cost[_addrj_NT] = 0;
				p->rule._addrj = q->rule._addrj;
			}
			if (q->cost[_cmpf_NT] == 0) {
				p->cost[_cmpf_NT] = 0;
				p->rule._cmpf = q->rule._cmpf;
			}
			if (q->cost[_burm0_NT] == 0) {
				p->cost[_burm0_NT] = 0;
				p->rule._burm0 = q->rule._burm0;
			}
			if (q->cost[_burm1_NT] == 0) {
				p->cost[_burm1_NT] = 0;
				p->rule._burm1 = q->rule._burm1;
			}
			if (q->cost[_burm2_NT] == 0) {
				p->cost[_burm2_NT] = 0;
				p->rule._burm2 = q->rule._burm2;
			}
			if (q->cost[_burm3_NT] == 0) {
				p->cost[_burm3_NT] = 0;
				p->rule._burm3 = q->rule._burm3;
			}
			if (q->cost[_burm4_NT] == 0) {
				p->cost[_burm4_NT] = 0;
				p->rule._burm4 = q->rule._burm4;
			}
			if (q->cost[_burm5_NT] == 0) {
				p->cost[_burm5_NT] = 0;
				p->rule._burm5 = q->rule._burm5;
			}
			if (q->cost[_burm6_NT] == 0) {
				p->cost[_burm6_NT] = 0;
				p->rule._burm6 = q->rule._burm6;
			}
			if (q->cost[_burm7_NT] == 0) {
				p->cost[_burm7_NT] = 0;
				p->rule._burm7 = q->rule._burm7;
			}
			if (q->cost[_burm8_NT] == 0) {
				p->cost[_burm8_NT] = 0;
				p->rule._burm8 = q->rule._burm8;
			}
			if (q->cost[_burm9_NT] == 0) {
				p->cost[_burm9_NT] = 0;
				p->rule._burm9 = q->rule._burm9;
			}
			if (q->cost[_burm10_NT] == 0) {
				p->cost[_burm10_NT] = 0;
				p->rule._burm10 = q->rule._burm10;
			}
			if (q->cost[_burm11_NT] == 0) {
				p->cost[_burm11_NT] = 0;
				p->rule._burm11 = q->rule._burm11;
			}
			if (q->cost[_burm12_NT] == 0) {
				p->cost[_burm12_NT] = 0;
				p->rule._burm12 = q->rule._burm12;
			}
			if (q->cost[_burm13_NT] == 0) {
				p->cost[_burm13_NT] = 0;
				p->rule._burm13 = q->rule._burm13;
			}
			if (q->cost[_burm14_NT] == 0) {
				p->cost[_burm14_NT] = 0;
				p->rule._burm14 = q->rule._burm14;
			}
			if (q->cost[_burm15_NT] == 0) {
				p->cost[_burm15_NT] = 0;
				p->rule._burm15 = q->rule._burm15;
			}
			if (q->cost[_burm16_NT] == 0) {
				p->cost[_burm16_NT] = 0;
				p->rule._burm16 = q->rule._burm16;
			}
			if (q->cost[_burm17_NT] == 0) {
				p->cost[_burm17_NT] = 0;
				p->rule._burm17 = q->rule._burm17;
			}
			if (q->cost[_burm18_NT] == 0) {
				p->cost[_burm18_NT] = 0;
				p->rule._burm18 = q->rule._burm18;
			}
			if (q->cost[_burm19_NT] == 0) {
				p->cost[_burm19_NT] = 0;
				p->rule._burm19 = q->rule._burm19;
			}
			if (q->cost[_burm20_NT] == 0) {
				p->cost[_burm20_NT] = 0;
				p->rule._burm20 = q->rule._burm20;
			}
			if (q->cost[_burm21_NT] == 0) {
				p->cost[_burm21_NT] = 0;
				p->rule._burm21 = q->rule._burm21;
			}
			if (q->cost[_burm22_NT] == 0) {
				p->cost[_burm22_NT] = 0;
				p->rule._burm22 = q->rule._burm22;
			}
			if (q->cost[_burm23_NT] == 0) {
				p->cost[_burm23_NT] = 0;
				p->rule._burm23 = q->rule._burm23;
			}
			if (q->cost[_burm24_NT] == 0) {
				p->cost[_burm24_NT] = 0;
				p->rule._burm24 = q->rule._burm24;
			}
			if (q->cost[_burm25_NT] == 0) {
				p->cost[_burm25_NT] = 0;
				p->rule._burm25 = q->rule._burm25;
			}
			if (q->cost[_burm26_NT] == 0) {
				p->cost[_burm26_NT] = 0;
				p->rule._burm26 = q->rule._burm26;
			}
			if (q->cost[_burm27_NT] == 0) {
				p->cost[_burm27_NT] = 0;
				p->rule._burm27 = q->rule._burm27;
			}
			if (q->cost[_burm28_NT] == 0) {
				p->cost[_burm28_NT] = 0;
				p->rule._burm28 = q->rule._burm28;
			}
			if (q->cost[_burm29_NT] == 0) {
				p->cost[_burm29_NT] = 0;
				p->rule._burm29 = q->rule._burm29;
			}
			if (q->cost[_burm30_NT] == 0) {
				p->cost[_burm30_NT] = 0;
				p->rule._burm30 = q->rule._burm30;
			}
			if (q->cost[_burm31_NT] == 0) {
				p->cost[_burm31_NT] = 0;
				p->rule._burm31 = q->rule._burm31;
			}
			if (q->cost[_burm32_NT] == 0) {
				p->cost[_burm32_NT] = 0;
				p->rule._burm32 = q->rule._burm32;
			}
			if (q->cost[_burm33_NT] == 0) {
				p->cost[_burm33_NT] = 0;
				p->rule._burm33 = q->rule._burm33;
			}
			if (q->cost[_burm34_NT] == 0) {
				p->cost[_burm34_NT] = 0;
				p->rule._burm34 = q->rule._burm34;
			}
			if (q->cost[_burm35_NT] == 0) {
				p->cost[_burm35_NT] = 0;
				p->rule._burm35 = q->rule._burm35;
			}
			if (q->cost[_burm36_NT] == 0) {
				p->cost[_burm36_NT] = 0;
				p->rule._burm36 = q->rule._burm36;
			}
			if (q->cost[_burm37_NT] == 0) {
				p->cost[_burm37_NT] = 0;
				p->rule._burm37 = q->rule._burm37;
			}
			if (q->cost[_burm38_NT] == 0) {
				p->cost[_burm38_NT] = 0;
				p->rule._burm38 = q->rule._burm38;
			}
			if (q->cost[_burm39_NT] == 0) {
				p->cost[_burm39_NT] = 0;
				p->rule._burm39 = q->rule._burm39;
			}
			if (q->cost[_burm40_NT] == 0) {
				p->cost[_burm40_NT] = 0;
				p->rule._burm40 = q->rule._burm40;
			}
			if (q->cost[_burm41_NT] == 0) {
				p->cost[_burm41_NT] = 0;
				p->rule._burm41 = q->rule._burm41;
			}
			if (q->cost[_burm42_NT] == 0) {
				p->cost[_burm42_NT] = 0;
				p->rule._burm42 = q->rule._burm42;
			}
		}
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm0_NT] + 0;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 3;
			_closure_reg(a, c + 0, p);
		}
		/* mem2: INDIRI2(addr) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + 0;
		if (c + 0 < p->cost[_mem2_NT]) {
			p->cost[_mem2_NT] = c + 0;
			p->rule._mem2 = 1;
			_closure_mem2(a, c + 0, p);
		}
		/* burm25: INDIRI2(addr) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + 0;
		if (c + 0 < p->cost[_burm25_NT]) {
			p->cost[_burm25_NT] = c + 0;
			p->rule._burm25 = 1;
		}
		break;
	case 2118: /* INDIRU2 */
		/* reg: INDIRU2(burm0) */
		if (mayrecalc(a)) {
			struct _state *q = a->syms[RX]->u.t.cse->x.state;
			if (q->cost[_stmt_NT] == 0) {
				p->cost[_stmt_NT] = 0;
				p->rule._stmt = q->rule._stmt;
			}
			if (q->cost[_reg_NT] == 0) {
				p->cost[_reg_NT] = 0;
				p->rule._reg = q->rule._reg;
			}
			if (q->cost[_freg_NT] == 0) {
				p->cost[_freg_NT] = 0;
				p->rule._freg = q->rule._freg;
			}
			if (q->cost[_cnst_NT] == 0) {
				p->cost[_cnst_NT] = 0;
				p->rule._cnst = q->rule._cnst;
			}
			if (q->cost[_con_NT] == 0) {
				p->cost[_con_NT] = 0;
				p->rule._con = q->rule._con;
			}
			if (q->cost[_acon_NT] == 0) {
				p->cost[_acon_NT] = 0;
				p->rule._acon = q->rule._acon;
			}
			if (q->cost[_baseaddr_NT] == 0) {
				p->cost[_baseaddr_NT] = 0;
				p->rule._baseaddr = q->rule._baseaddr;
			}
			if (q->cost[_base_NT] == 0) {
				p->cost[_base_NT] = 0;
				p->rule._base = q->rule._base;
			}
			if (q->cost[_index_NT] == 0) {
				p->cost[_index_NT] = 0;
				p->rule._index = q->rule._index;
			}
			if (q->cost[_con1_NT] == 0) {
				p->cost[_con1_NT] = 0;
				p->rule._con1 = q->rule._con1;
			}
			if (q->cost[_con2_NT] == 0) {
				p->cost[_con2_NT] = 0;
				p->rule._con2 = q->rule._con2;
			}
			if (q->cost[_con3_NT] == 0) {
				p->cost[_con3_NT] = 0;
				p->rule._con3 = q->rule._con3;
			}
			if (q->cost[_con0_NT] == 0) {
				p->cost[_con0_NT] = 0;
				p->rule._con0 = q->rule._con0;
			}
			if (q->cost[_addr_NT] == 0) {
				p->cost[_addr_NT] = 0;
				p->rule._addr = q->rule._addr;
			}
			if (q->cost[_mem1_NT] == 0) {
				p->cost[_mem1_NT] = 0;
				p->rule._mem1 = q->rule._mem1;
			}
			if (q->cost[_mem2_NT] == 0) {
				p->cost[_mem2_NT] = 0;
				p->rule._mem2 = q->rule._mem2;
			}
			if (q->cost[_mem4_NT] == 0) {
				p->cost[_mem4_NT] = 0;
				p->rule._mem4 = q->rule._mem4;
			}
			if (q->cost[_rc_NT] == 0) {
				p->cost[_rc_NT] = 0;
				p->rule._rc = q->rule._rc;
			}
			if (q->cost[_mr_NT] == 0) {
				p->cost[_mr_NT] = 0;
				p->rule._mr = q->rule._mr;
			}
			if (q->cost[_mr1_NT] == 0) {
				p->cost[_mr1_NT] = 0;
				p->rule._mr1 = q->rule._mr1;
			}
			if (q->cost[_mr2_NT] == 0) {
				p->cost[_mr2_NT] = 0;
				p->rule._mr2 = q->rule._mr2;
			}
			if (q->cost[_mrc_NT] == 0) {
				p->cost[_mrc_NT] = 0;
				p->rule._mrc = q->rule._mrc;
			}
			if (q->cost[_rc5_NT] == 0) {
				p->cost[_rc5_NT] = 0;
				p->rule._rc5 = q->rule._rc5;
			}
			if (q->cost[_mrca_NT] == 0) {
				p->cost[_mrca_NT] = 0;
				p->rule._mrca = q->rule._mrca;
			}
			if (q->cost[_memf_NT] == 0) {
				p->cost[_memf_NT] = 0;
				p->rule._memf = q->rule._memf;
			}
			if (q->cost[_flt_NT] == 0) {
				p->cost[_flt_NT] = 0;
				p->rule._flt = q->rule._flt;
			}
			if (q->cost[_flt2_NT] == 0) {
				p->cost[_flt2_NT] = 0;
				p->rule._flt2 = q->rule._flt2;
			}
			if (q->cost[_addrj_NT] == 0) {
				p->cost[_addrj_NT] = 0;
				p->rule._addrj = q->rule._addrj;
			}
			if (q->cost[_cmpf_NT] == 0) {
				p->cost[_cmpf_NT] = 0;
				p->rule._cmpf = q->rule._cmpf;
			}
			if (q->cost[_burm0_NT] == 0) {
				p->cost[_burm0_NT] = 0;
				p->rule._burm0 = q->rule._burm0;
			}
			if (q->cost[_burm1_NT] == 0) {
				p->cost[_burm1_NT] = 0;
				p->rule._burm1 = q->rule._burm1;
			}
			if (q->cost[_burm2_NT] == 0) {
				p->cost[_burm2_NT] = 0;
				p->rule._burm2 = q->rule._burm2;
			}
			if (q->cost[_burm3_NT] == 0) {
				p->cost[_burm3_NT] = 0;
				p->rule._burm3 = q->rule._burm3;
			}
			if (q->cost[_burm4_NT] == 0) {
				p->cost[_burm4_NT] = 0;
				p->rule._burm4 = q->rule._burm4;
			}
			if (q->cost[_burm5_NT] == 0) {
				p->cost[_burm5_NT] = 0;
				p->rule._burm5 = q->rule._burm5;
			}
			if (q->cost[_burm6_NT] == 0) {
				p->cost[_burm6_NT] = 0;
				p->rule._burm6 = q->rule._burm6;
			}
			if (q->cost[_burm7_NT] == 0) {
				p->cost[_burm7_NT] = 0;
				p->rule._burm7 = q->rule._burm7;
			}
			if (q->cost[_burm8_NT] == 0) {
				p->cost[_burm8_NT] = 0;
				p->rule._burm8 = q->rule._burm8;
			}
			if (q->cost[_burm9_NT] == 0) {
				p->cost[_burm9_NT] = 0;
				p->rule._burm9 = q->rule._burm9;
			}
			if (q->cost[_burm10_NT] == 0) {
				p->cost[_burm10_NT] = 0;
				p->rule._burm10 = q->rule._burm10;
			}
			if (q->cost[_burm11_NT] == 0) {
				p->cost[_burm11_NT] = 0;
				p->rule._burm11 = q->rule._burm11;
			}
			if (q->cost[_burm12_NT] == 0) {
				p->cost[_burm12_NT] = 0;
				p->rule._burm12 = q->rule._burm12;
			}
			if (q->cost[_burm13_NT] == 0) {
				p->cost[_burm13_NT] = 0;
				p->rule._burm13 = q->rule._burm13;
			}
			if (q->cost[_burm14_NT] == 0) {
				p->cost[_burm14_NT] = 0;
				p->rule._burm14 = q->rule._burm14;
			}
			if (q->cost[_burm15_NT] == 0) {
				p->cost[_burm15_NT] = 0;
				p->rule._burm15 = q->rule._burm15;
			}
			if (q->cost[_burm16_NT] == 0) {
				p->cost[_burm16_NT] = 0;
				p->rule._burm16 = q->rule._burm16;
			}
			if (q->cost[_burm17_NT] == 0) {
				p->cost[_burm17_NT] = 0;
				p->rule._burm17 = q->rule._burm17;
			}
			if (q->cost[_burm18_NT] == 0) {
				p->cost[_burm18_NT] = 0;
				p->rule._burm18 = q->rule._burm18;
			}
			if (q->cost[_burm19_NT] == 0) {
				p->cost[_burm19_NT] = 0;
				p->rule._burm19 = q->rule._burm19;
			}
			if (q->cost[_burm20_NT] == 0) {
				p->cost[_burm20_NT] = 0;
				p->rule._burm20 = q->rule._burm20;
			}
			if (q->cost[_burm21_NT] == 0) {
				p->cost[_burm21_NT] = 0;
				p->rule._burm21 = q->rule._burm21;
			}
			if (q->cost[_burm22_NT] == 0) {
				p->cost[_burm22_NT] = 0;
				p->rule._burm22 = q->rule._burm22;
			}
			if (q->cost[_burm23_NT] == 0) {
				p->cost[_burm23_NT] = 0;
				p->rule._burm23 = q->rule._burm23;
			}
			if (q->cost[_burm24_NT] == 0) {
				p->cost[_burm24_NT] = 0;
				p->rule._burm24 = q->rule._burm24;
			}
			if (q->cost[_burm25_NT] == 0) {
				p->cost[_burm25_NT] = 0;
				p->rule._burm25 = q->rule._burm25;
			}
			if (q->cost[_burm26_NT] == 0) {
				p->cost[_burm26_NT] = 0;
				p->rule._burm26 = q->rule._burm26;
			}
			if (q->cost[_burm27_NT] == 0) {
				p->cost[_burm27_NT] = 0;
				p->rule._burm27 = q->rule._burm27;
			}
			if (q->cost[_burm28_NT] == 0) {
				p->cost[_burm28_NT] = 0;
				p->rule._burm28 = q->rule._burm28;
			}
			if (q->cost[_burm29_NT] == 0) {
				p->cost[_burm29_NT] = 0;
				p->rule._burm29 = q->rule._burm29;
			}
			if (q->cost[_burm30_NT] == 0) {
				p->cost[_burm30_NT] = 0;
				p->rule._burm30 = q->rule._burm30;
			}
			if (q->cost[_burm31_NT] == 0) {
				p->cost[_burm31_NT] = 0;
				p->rule._burm31 = q->rule._burm31;
			}
			if (q->cost[_burm32_NT] == 0) {
				p->cost[_burm32_NT] = 0;
				p->rule._burm32 = q->rule._burm32;
			}
			if (q->cost[_burm33_NT] == 0) {
				p->cost[_burm33_NT] = 0;
				p->rule._burm33 = q->rule._burm33;
			}
			if (q->cost[_burm34_NT] == 0) {
				p->cost[_burm34_NT] = 0;
				p->rule._burm34 = q->rule._burm34;
			}
			if (q->cost[_burm35_NT] == 0) {
				p->cost[_burm35_NT] = 0;
				p->rule._burm35 = q->rule._burm35;
			}
			if (q->cost[_burm36_NT] == 0) {
				p->cost[_burm36_NT] = 0;
				p->rule._burm36 = q->rule._burm36;
			}
			if (q->cost[_burm37_NT] == 0) {
				p->cost[_burm37_NT] = 0;
				p->rule._burm37 = q->rule._burm37;
			}
			if (q->cost[_burm38_NT] == 0) {
				p->cost[_burm38_NT] = 0;
				p->rule._burm38 = q->rule._burm38;
			}
			if (q->cost[_burm39_NT] == 0) {
				p->cost[_burm39_NT] = 0;
				p->rule._burm39 = q->rule._burm39;
			}
			if (q->cost[_burm40_NT] == 0) {
				p->cost[_burm40_NT] = 0;
				p->rule._burm40 = q->rule._burm40;
			}
			if (q->cost[_burm41_NT] == 0) {
				p->cost[_burm41_NT] = 0;
				p->rule._burm41 = q->rule._burm41;
			}
			if (q->cost[_burm42_NT] == 0) {
				p->cost[_burm42_NT] = 0;
				p->rule._burm42 = q->rule._burm42;
			}
		}
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm0_NT] + 0;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 4;
			_closure_reg(a, c + 0, p);
		}
		/* mem2: INDIRU2(addr) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + 0;
		if (c + 0 < p->cost[_mem2_NT]) {
			p->cost[_mem2_NT] = c + 0;
			p->rule._mem2 = 2;
			_closure_mem2(a, c + 0, p);
		}
		/* burm27: INDIRU2(addr) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + 0;
		if (c + 0 < p->cost[_burm27_NT]) {
			p->cost[_burm27_NT] = c + 0;
			p->rule._burm27 = 1;
		}
		break;
	case 2181: /* CVII2 */
		/* reg: CVII2(reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 60;
			_closure_reg(a, c + 0, p);
		}
		/* burm40: CVII2(burm25) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm25_NT] + 0;
		if (c + 0 < p->cost[_burm40_NT]) {
			p->cost[_burm40_NT] = c + 0;
			p->rule._burm40 = 1;
		}
		break;
	case 2182: /* CVIU2 */
		/* burm41: CVIU2(burm25) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm25_NT] + 0;
		if (c + 0 < p->cost[_burm41_NT]) {
			p->cost[_burm41_NT] = c + 0;
			p->rule._burm41 = 1;
		}
		break;
	case 2229: /* CVUI2 */
		break;
	case 2230: /* CVUU2 */
		/* reg: CVUU2(reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 62;
			_closure_reg(a, c + 0, p);
		}
		break;
	case 2277: /* LOADI2 */
		/* reg: LOADI2(reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 17;
			_closure_reg(a, c + 0, p);
		}
		break;
	case 2278: /* LOADU2 */
		/* reg: LOADU2(reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 20;
			_closure_reg(a, c + 0, p);
		}
		break;
	case 4113: /* CNSTF4 */
		break;
	case 4117: /* CNSTI4 */
		/* cnst: CNSTI4 */
		if (0 + 0 < p->cost[_cnst_NT]) {
			p->cost[_cnst_NT] = 0 + 0;
			p->rule._cnst = 5;
			_closure_cnst(a, 0 + 0, p);
		}
		/* con0: CNSTI4 */
		c = (range(a, 0, 0));
		if (c + 0 < p->cost[_con0_NT]) {
			p->cost[_con0_NT] = c + 0;
			p->rule._con0 = 1;
		}
		/* con1: CNSTI4 */
		c = (range(a, 1, 1));
		if (c + 0 < p->cost[_con1_NT]) {
			p->cost[_con1_NT] = c + 0;
			p->rule._con1 = 1;
		}
		/* con2: CNSTI4 */
		c = (range(a, 2, 2));
		if (c + 0 < p->cost[_con2_NT]) {
			p->cost[_con2_NT] = c + 0;
			p->rule._con2 = 1;
		}
		/* con3: CNSTI4 */
		c = (range(a, 3, 3));
		if (c + 0 < p->cost[_con3_NT]) {
			p->cost[_con3_NT] = c + 0;
			p->rule._con3 = 1;
		}
		/* rc5: CNSTI4 */
		c = (range(a, 0, 31));
		if (c + 0 < p->cost[_rc5_NT]) {
			p->cost[_rc5_NT] = c + 0;
			p->rule._rc5 = 1;
		}
		break;
	case 4118: /* CNSTU4 */
		/* cnst: CNSTU4 */
		if (0 + 0 < p->cost[_cnst_NT]) {
			p->cost[_cnst_NT] = 0 + 0;
			p->rule._cnst = 6;
			_closure_cnst(a, 0 + 0, p);
		}
		/* con0: CNSTU4 */
		c = (range(a, 0, 0));
		if (c + 0 < p->cost[_con0_NT]) {
			p->cost[_con0_NT] = c + 0;
			p->rule._con0 = 2;
		}
		/* con1: CNSTU4 */
		c = (range(a, 1, 1));
		if (c + 0 < p->cost[_con1_NT]) {
			p->cost[_con1_NT] = c + 0;
			p->rule._con1 = 2;
		}
		/* con2: CNSTU4 */
		c = (range(a, 2, 2));
		if (c + 0 < p->cost[_con2_NT]) {
			p->cost[_con2_NT] = c + 0;
			p->rule._con2 = 2;
		}
		/* con3: CNSTU4 */
		c = (range(a, 3, 3));
		if (c + 0 < p->cost[_con3_NT]) {
			p->cost[_con3_NT] = c + 0;
			p->rule._con3 = 2;
		}
		break;
	case 4119: /* CNSTP4 */
		/* cnst: CNSTP4 */
		if (0 + 0 < p->cost[_cnst_NT]) {
			p->cost[_cnst_NT] = 0 + 0;
			p->rule._cnst = 7;
			_closure_cnst(a, 0 + 0, p);
		}
		break;
	case 4129: /* ARGF4 */
		/* stmt: ARGF4(freg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_freg_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 54;
		}
		break;
	case 4133: /* ARGI4 */
		/* stmt: ARGI4(mrca) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_mrca_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 45;
		}
		break;
	case 4134: /* ARGU4 */
		/* stmt: ARGU4(mrca) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_mrca_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 46;
		}
		break;
	case 4135: /* ARGP4 */
		/* stmt: ARGP4(mrca) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_mrca_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 47;
		}
		break;
	case 4145: /* ASGNF4 */
		/* stmt: ASGNF4(burm0,reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm0_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 5;
		}
		/* stmt: ASGNF4(addr,freg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_freg_NT] + 7;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 51;
		}
		/* stmt: ASGNF4(addr,burm31) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_burm31_NT] + 7;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 52;
		}
		break;
	case 4149: /* ASGNI4 */
		/* stmt: ASGNI4(burm0,reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm0_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 6;
		}
		/* stmt: ASGNI4(addr,burm1) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_burm1_NT] + (memop(a));
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 15;
		}
		/* stmt: ASGNI4(addr,burm2) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_burm2_NT] + (memop(a));
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 16;
		}
		/* stmt: ASGNI4(addr,burm4) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_burm4_NT] + (memop(a));
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 18;
		}
		/* stmt: ASGNI4(addr,burm5) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_burm5_NT] + (memop(a));
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 19;
		}
		/* stmt: ASGNI4(addr,burm7) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_burm7_NT] + (memop(a));
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 21;
		}
		/* stmt: ASGNI4(addr,burm8) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_burm8_NT] + (memop(a));
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 22;
		}
		/* stmt: ASGNI4(addr,burm11) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_burm11_NT] + (memop(a));
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 25;
		}
		/* stmt: ASGNI4(addr,burm12) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_burm12_NT] + (memop(a));
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 26;
		}
		/* stmt: ASGNI4(addr,burm13) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_burm13_NT] + (memop(a));
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 27;
		}
		/* stmt: ASGNI4(addr,burm17) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_burm17_NT] + (memop(a));
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 31;
		}
		/* stmt: ASGNI4(addr,burm19) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_burm19_NT] + (memop(a));
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 33;
		}
		/* stmt: ASGNI4(addr,burm20) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_burm20_NT] + (memop(a));
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 34;
		}
		/* stmt: ASGNI4(addr,burm21) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_burm21_NT] + (memop(a));
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 35;
		}
		/* stmt: ASGNI4(addr,burm22) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_burm22_NT] + (memop(a));
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 36;
		}
		/* stmt: ASGNI4(addr,burm23) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_burm23_NT] + (memop(a));
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 37;
		}
		/* stmt: ASGNI4(addr,rc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 40;
		}
		break;
	case 4150: /* ASGNU4 */
		/* stmt: ASGNU4(burm0,reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm0_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 8;
		}
		/* stmt: ASGNU4(addr,burm9) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_burm9_NT] + (memop(a));
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 23;
		}
		/* stmt: ASGNU4(addr,burm10) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_burm10_NT] + (memop(a));
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 24;
		}
		/* stmt: ASGNU4(addr,burm14) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_burm14_NT] + (memop(a));
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 28;
		}
		/* stmt: ASGNU4(addr,burm15) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_burm15_NT] + (memop(a));
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 29;
		}
		/* stmt: ASGNU4(addr,burm16) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_burm16_NT] + (memop(a));
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 30;
		}
		/* stmt: ASGNU4(addr,burm18) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_burm18_NT] + (memop(a));
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 32;
		}
		/* stmt: ASGNU4(addr,rc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 43;
		}
		break;
	case 4151: /* ASGNP4 */
		/* stmt: ASGNP4(burm0,reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm0_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 7;
		}
		/* stmt: ASGNP4(addr,burm3) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_burm3_NT] + (memop(a));
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 17;
		}
		/* stmt: ASGNP4(addr,burm6) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_burm6_NT] + (memop(a));
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 20;
		}
		/* stmt: ASGNP4(addr,rc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 44;
		}
		break;
	case 4161: /* INDIRF4 */
		/* freg: INDIRF4(burm0) */
		if (mayrecalc(a)) {
			struct _state *q = a->syms[RX]->u.t.cse->x.state;
			if (q->cost[_stmt_NT] == 0) {
				p->cost[_stmt_NT] = 0;
				p->rule._stmt = q->rule._stmt;
			}
			if (q->cost[_reg_NT] == 0) {
				p->cost[_reg_NT] = 0;
				p->rule._reg = q->rule._reg;
			}
			if (q->cost[_freg_NT] == 0) {
				p->cost[_freg_NT] = 0;
				p->rule._freg = q->rule._freg;
			}
			if (q->cost[_cnst_NT] == 0) {
				p->cost[_cnst_NT] = 0;
				p->rule._cnst = q->rule._cnst;
			}
			if (q->cost[_con_NT] == 0) {
				p->cost[_con_NT] = 0;
				p->rule._con = q->rule._con;
			}
			if (q->cost[_acon_NT] == 0) {
				p->cost[_acon_NT] = 0;
				p->rule._acon = q->rule._acon;
			}
			if (q->cost[_baseaddr_NT] == 0) {
				p->cost[_baseaddr_NT] = 0;
				p->rule._baseaddr = q->rule._baseaddr;
			}
			if (q->cost[_base_NT] == 0) {
				p->cost[_base_NT] = 0;
				p->rule._base = q->rule._base;
			}
			if (q->cost[_index_NT] == 0) {
				p->cost[_index_NT] = 0;
				p->rule._index = q->rule._index;
			}
			if (q->cost[_con1_NT] == 0) {
				p->cost[_con1_NT] = 0;
				p->rule._con1 = q->rule._con1;
			}
			if (q->cost[_con2_NT] == 0) {
				p->cost[_con2_NT] = 0;
				p->rule._con2 = q->rule._con2;
			}
			if (q->cost[_con3_NT] == 0) {
				p->cost[_con3_NT] = 0;
				p->rule._con3 = q->rule._con3;
			}
			if (q->cost[_con0_NT] == 0) {
				p->cost[_con0_NT] = 0;
				p->rule._con0 = q->rule._con0;
			}
			if (q->cost[_addr_NT] == 0) {
				p->cost[_addr_NT] = 0;
				p->rule._addr = q->rule._addr;
			}
			if (q->cost[_mem1_NT] == 0) {
				p->cost[_mem1_NT] = 0;
				p->rule._mem1 = q->rule._mem1;
			}
			if (q->cost[_mem2_NT] == 0) {
				p->cost[_mem2_NT] = 0;
				p->rule._mem2 = q->rule._mem2;
			}
			if (q->cost[_mem4_NT] == 0) {
				p->cost[_mem4_NT] = 0;
				p->rule._mem4 = q->rule._mem4;
			}
			if (q->cost[_rc_NT] == 0) {
				p->cost[_rc_NT] = 0;
				p->rule._rc = q->rule._rc;
			}
			if (q->cost[_mr_NT] == 0) {
				p->cost[_mr_NT] = 0;
				p->rule._mr = q->rule._mr;
			}
			if (q->cost[_mr1_NT] == 0) {
				p->cost[_mr1_NT] = 0;
				p->rule._mr1 = q->rule._mr1;
			}
			if (q->cost[_mr2_NT] == 0) {
				p->cost[_mr2_NT] = 0;
				p->rule._mr2 = q->rule._mr2;
			}
			if (q->cost[_mrc_NT] == 0) {
				p->cost[_mrc_NT] = 0;
				p->rule._mrc = q->rule._mrc;
			}
			if (q->cost[_rc5_NT] == 0) {
				p->cost[_rc5_NT] = 0;
				p->rule._rc5 = q->rule._rc5;
			}
			if (q->cost[_mrca_NT] == 0) {
				p->cost[_mrca_NT] = 0;
				p->rule._mrca = q->rule._mrca;
			}
			if (q->cost[_memf_NT] == 0) {
				p->cost[_memf_NT] = 0;
				p->rule._memf = q->rule._memf;
			}
			if (q->cost[_flt_NT] == 0) {
				p->cost[_flt_NT] = 0;
				p->rule._flt = q->rule._flt;
			}
			if (q->cost[_flt2_NT] == 0) {
				p->cost[_flt2_NT] = 0;
				p->rule._flt2 = q->rule._flt2;
			}
			if (q->cost[_addrj_NT] == 0) {
				p->cost[_addrj_NT] = 0;
				p->rule._addrj = q->rule._addrj;
			}
			if (q->cost[_cmpf_NT] == 0) {
				p->cost[_cmpf_NT] = 0;
				p->rule._cmpf = q->rule._cmpf;
			}
			if (q->cost[_burm0_NT] == 0) {
				p->cost[_burm0_NT] = 0;
				p->rule._burm0 = q->rule._burm0;
			}
			if (q->cost[_burm1_NT] == 0) {
				p->cost[_burm1_NT] = 0;
				p->rule._burm1 = q->rule._burm1;
			}
			if (q->cost[_burm2_NT] == 0) {
				p->cost[_burm2_NT] = 0;
				p->rule._burm2 = q->rule._burm2;
			}
			if (q->cost[_burm3_NT] == 0) {
				p->cost[_burm3_NT] = 0;
				p->rule._burm3 = q->rule._burm3;
			}
			if (q->cost[_burm4_NT] == 0) {
				p->cost[_burm4_NT] = 0;
				p->rule._burm4 = q->rule._burm4;
			}
			if (q->cost[_burm5_NT] == 0) {
				p->cost[_burm5_NT] = 0;
				p->rule._burm5 = q->rule._burm5;
			}
			if (q->cost[_burm6_NT] == 0) {
				p->cost[_burm6_NT] = 0;
				p->rule._burm6 = q->rule._burm6;
			}
			if (q->cost[_burm7_NT] == 0) {
				p->cost[_burm7_NT] = 0;
				p->rule._burm7 = q->rule._burm7;
			}
			if (q->cost[_burm8_NT] == 0) {
				p->cost[_burm8_NT] = 0;
				p->rule._burm8 = q->rule._burm8;
			}
			if (q->cost[_burm9_NT] == 0) {
				p->cost[_burm9_NT] = 0;
				p->rule._burm9 = q->rule._burm9;
			}
			if (q->cost[_burm10_NT] == 0) {
				p->cost[_burm10_NT] = 0;
				p->rule._burm10 = q->rule._burm10;
			}
			if (q->cost[_burm11_NT] == 0) {
				p->cost[_burm11_NT] = 0;
				p->rule._burm11 = q->rule._burm11;
			}
			if (q->cost[_burm12_NT] == 0) {
				p->cost[_burm12_NT] = 0;
				p->rule._burm12 = q->rule._burm12;
			}
			if (q->cost[_burm13_NT] == 0) {
				p->cost[_burm13_NT] = 0;
				p->rule._burm13 = q->rule._burm13;
			}
			if (q->cost[_burm14_NT] == 0) {
				p->cost[_burm14_NT] = 0;
				p->rule._burm14 = q->rule._burm14;
			}
			if (q->cost[_burm15_NT] == 0) {
				p->cost[_burm15_NT] = 0;
				p->rule._burm15 = q->rule._burm15;
			}
			if (q->cost[_burm16_NT] == 0) {
				p->cost[_burm16_NT] = 0;
				p->rule._burm16 = q->rule._burm16;
			}
			if (q->cost[_burm17_NT] == 0) {
				p->cost[_burm17_NT] = 0;
				p->rule._burm17 = q->rule._burm17;
			}
			if (q->cost[_burm18_NT] == 0) {
				p->cost[_burm18_NT] = 0;
				p->rule._burm18 = q->rule._burm18;
			}
			if (q->cost[_burm19_NT] == 0) {
				p->cost[_burm19_NT] = 0;
				p->rule._burm19 = q->rule._burm19;
			}
			if (q->cost[_burm20_NT] == 0) {
				p->cost[_burm20_NT] = 0;
				p->rule._burm20 = q->rule._burm20;
			}
			if (q->cost[_burm21_NT] == 0) {
				p->cost[_burm21_NT] = 0;
				p->rule._burm21 = q->rule._burm21;
			}
			if (q->cost[_burm22_NT] == 0) {
				p->cost[_burm22_NT] = 0;
				p->rule._burm22 = q->rule._burm22;
			}
			if (q->cost[_burm23_NT] == 0) {
				p->cost[_burm23_NT] = 0;
				p->rule._burm23 = q->rule._burm23;
			}
			if (q->cost[_burm24_NT] == 0) {
				p->cost[_burm24_NT] = 0;
				p->rule._burm24 = q->rule._burm24;
			}
			if (q->cost[_burm25_NT] == 0) {
				p->cost[_burm25_NT] = 0;
				p->rule._burm25 = q->rule._burm25;
			}
			if (q->cost[_burm26_NT] == 0) {
				p->cost[_burm26_NT] = 0;
				p->rule._burm26 = q->rule._burm26;
			}
			if (q->cost[_burm27_NT] == 0) {
				p->cost[_burm27_NT] = 0;
				p->rule._burm27 = q->rule._burm27;
			}
			if (q->cost[_burm28_NT] == 0) {
				p->cost[_burm28_NT] = 0;
				p->rule._burm28 = q->rule._burm28;
			}
			if (q->cost[_burm29_NT] == 0) {
				p->cost[_burm29_NT] = 0;
				p->rule._burm29 = q->rule._burm29;
			}
			if (q->cost[_burm30_NT] == 0) {
				p->cost[_burm30_NT] = 0;
				p->rule._burm30 = q->rule._burm30;
			}
			if (q->cost[_burm31_NT] == 0) {
				p->cost[_burm31_NT] = 0;
				p->rule._burm31 = q->rule._burm31;
			}
			if (q->cost[_burm32_NT] == 0) {
				p->cost[_burm32_NT] = 0;
				p->rule._burm32 = q->rule._burm32;
			}
			if (q->cost[_burm33_NT] == 0) {
				p->cost[_burm33_NT] = 0;
				p->rule._burm33 = q->rule._burm33;
			}
			if (q->cost[_burm34_NT] == 0) {
				p->cost[_burm34_NT] = 0;
				p->rule._burm34 = q->rule._burm34;
			}
			if (q->cost[_burm35_NT] == 0) {
				p->cost[_burm35_NT] = 0;
				p->rule._burm35 = q->rule._burm35;
			}
			if (q->cost[_burm36_NT] == 0) {
				p->cost[_burm36_NT] = 0;
				p->rule._burm36 = q->rule._burm36;
			}
			if (q->cost[_burm37_NT] == 0) {
				p->cost[_burm37_NT] = 0;
				p->rule._burm37 = q->rule._burm37;
			}
			if (q->cost[_burm38_NT] == 0) {
				p->cost[_burm38_NT] = 0;
				p->rule._burm38 = q->rule._burm38;
			}
			if (q->cost[_burm39_NT] == 0) {
				p->cost[_burm39_NT] = 0;
				p->rule._burm39 = q->rule._burm39;
			}
			if (q->cost[_burm40_NT] == 0) {
				p->cost[_burm40_NT] = 0;
				p->rule._burm40 = q->rule._burm40;
			}
			if (q->cost[_burm41_NT] == 0) {
				p->cost[_burm41_NT] = 0;
				p->rule._burm41 = q->rule._burm41;
			}
			if (q->cost[_burm42_NT] == 0) {
				p->cost[_burm42_NT] = 0;
				p->rule._burm42 = q->rule._burm42;
			}
		}
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm0_NT] + 0;
		if (c + 0 < p->cost[_freg_NT]) {
			p->cost[_freg_NT] = c + 0;
			p->rule._freg = 1;
			_closure_freg(a, c + 0, p);
		}
		/* memf: INDIRF4(addr) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + 0;
		if (c + 0 < p->cost[_memf_NT]) {
			p->cost[_memf_NT] = c + 0;
			p->rule._memf = 2;
			_closure_memf(a, c + 0, p);
		}
		/* cmpf: INDIRF4(addr) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + 0;
		if (c + 0 < p->cost[_cmpf_NT]) {
			p->cost[_cmpf_NT] = c + 0;
			p->rule._cmpf = 2;
		}
		/* burm29: INDIRF4(addr) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + 0;
		if (c + 0 < p->cost[_burm29_NT]) {
			p->cost[_burm29_NT] = c + 0;
			p->rule._burm29 = 1;
		}
		break;
	case 4165: /* INDIRI4 */
		/* reg: INDIRI4(burm0) */
		if (mayrecalc(a)) {
			struct _state *q = a->syms[RX]->u.t.cse->x.state;
			if (q->cost[_stmt_NT] == 0) {
				p->cost[_stmt_NT] = 0;
				p->rule._stmt = q->rule._stmt;
			}
			if (q->cost[_reg_NT] == 0) {
				p->cost[_reg_NT] = 0;
				p->rule._reg = q->rule._reg;
			}
			if (q->cost[_freg_NT] == 0) {
				p->cost[_freg_NT] = 0;
				p->rule._freg = q->rule._freg;
			}
			if (q->cost[_cnst_NT] == 0) {
				p->cost[_cnst_NT] = 0;
				p->rule._cnst = q->rule._cnst;
			}
			if (q->cost[_con_NT] == 0) {
				p->cost[_con_NT] = 0;
				p->rule._con = q->rule._con;
			}
			if (q->cost[_acon_NT] == 0) {
				p->cost[_acon_NT] = 0;
				p->rule._acon = q->rule._acon;
			}
			if (q->cost[_baseaddr_NT] == 0) {
				p->cost[_baseaddr_NT] = 0;
				p->rule._baseaddr = q->rule._baseaddr;
			}
			if (q->cost[_base_NT] == 0) {
				p->cost[_base_NT] = 0;
				p->rule._base = q->rule._base;
			}
			if (q->cost[_index_NT] == 0) {
				p->cost[_index_NT] = 0;
				p->rule._index = q->rule._index;
			}
			if (q->cost[_con1_NT] == 0) {
				p->cost[_con1_NT] = 0;
				p->rule._con1 = q->rule._con1;
			}
			if (q->cost[_con2_NT] == 0) {
				p->cost[_con2_NT] = 0;
				p->rule._con2 = q->rule._con2;
			}
			if (q->cost[_con3_NT] == 0) {
				p->cost[_con3_NT] = 0;
				p->rule._con3 = q->rule._con3;
			}
			if (q->cost[_con0_NT] == 0) {
				p->cost[_con0_NT] = 0;
				p->rule._con0 = q->rule._con0;
			}
			if (q->cost[_addr_NT] == 0) {
				p->cost[_addr_NT] = 0;
				p->rule._addr = q->rule._addr;
			}
			if (q->cost[_mem1_NT] == 0) {
				p->cost[_mem1_NT] = 0;
				p->rule._mem1 = q->rule._mem1;
			}
			if (q->cost[_mem2_NT] == 0) {
				p->cost[_mem2_NT] = 0;
				p->rule._mem2 = q->rule._mem2;
			}
			if (q->cost[_mem4_NT] == 0) {
				p->cost[_mem4_NT] = 0;
				p->rule._mem4 = q->rule._mem4;
			}
			if (q->cost[_rc_NT] == 0) {
				p->cost[_rc_NT] = 0;
				p->rule._rc = q->rule._rc;
			}
			if (q->cost[_mr_NT] == 0) {
				p->cost[_mr_NT] = 0;
				p->rule._mr = q->rule._mr;
			}
			if (q->cost[_mr1_NT] == 0) {
				p->cost[_mr1_NT] = 0;
				p->rule._mr1 = q->rule._mr1;
			}
			if (q->cost[_mr2_NT] == 0) {
				p->cost[_mr2_NT] = 0;
				p->rule._mr2 = q->rule._mr2;
			}
			if (q->cost[_mrc_NT] == 0) {
				p->cost[_mrc_NT] = 0;
				p->rule._mrc = q->rule._mrc;
			}
			if (q->cost[_rc5_NT] == 0) {
				p->cost[_rc5_NT] = 0;
				p->rule._rc5 = q->rule._rc5;
			}
			if (q->cost[_mrca_NT] == 0) {
				p->cost[_mrca_NT] = 0;
				p->rule._mrca = q->rule._mrca;
			}
			if (q->cost[_memf_NT] == 0) {
				p->cost[_memf_NT] = 0;
				p->rule._memf = q->rule._memf;
			}
			if (q->cost[_flt_NT] == 0) {
				p->cost[_flt_NT] = 0;
				p->rule._flt = q->rule._flt;
			}
			if (q->cost[_flt2_NT] == 0) {
				p->cost[_flt2_NT] = 0;
				p->rule._flt2 = q->rule._flt2;
			}
			if (q->cost[_addrj_NT] == 0) {
				p->cost[_addrj_NT] = 0;
				p->rule._addrj = q->rule._addrj;
			}
			if (q->cost[_cmpf_NT] == 0) {
				p->cost[_cmpf_NT] = 0;
				p->rule._cmpf = q->rule._cmpf;
			}
			if (q->cost[_burm0_NT] == 0) {
				p->cost[_burm0_NT] = 0;
				p->rule._burm0 = q->rule._burm0;
			}
			if (q->cost[_burm1_NT] == 0) {
				p->cost[_burm1_NT] = 0;
				p->rule._burm1 = q->rule._burm1;
			}
			if (q->cost[_burm2_NT] == 0) {
				p->cost[_burm2_NT] = 0;
				p->rule._burm2 = q->rule._burm2;
			}
			if (q->cost[_burm3_NT] == 0) {
				p->cost[_burm3_NT] = 0;
				p->rule._burm3 = q->rule._burm3;
			}
			if (q->cost[_burm4_NT] == 0) {
				p->cost[_burm4_NT] = 0;
				p->rule._burm4 = q->rule._burm4;
			}
			if (q->cost[_burm5_NT] == 0) {
				p->cost[_burm5_NT] = 0;
				p->rule._burm5 = q->rule._burm5;
			}
			if (q->cost[_burm6_NT] == 0) {
				p->cost[_burm6_NT] = 0;
				p->rule._burm6 = q->rule._burm6;
			}
			if (q->cost[_burm7_NT] == 0) {
				p->cost[_burm7_NT] = 0;
				p->rule._burm7 = q->rule._burm7;
			}
			if (q->cost[_burm8_NT] == 0) {
				p->cost[_burm8_NT] = 0;
				p->rule._burm8 = q->rule._burm8;
			}
			if (q->cost[_burm9_NT] == 0) {
				p->cost[_burm9_NT] = 0;
				p->rule._burm9 = q->rule._burm9;
			}
			if (q->cost[_burm10_NT] == 0) {
				p->cost[_burm10_NT] = 0;
				p->rule._burm10 = q->rule._burm10;
			}
			if (q->cost[_burm11_NT] == 0) {
				p->cost[_burm11_NT] = 0;
				p->rule._burm11 = q->rule._burm11;
			}
			if (q->cost[_burm12_NT] == 0) {
				p->cost[_burm12_NT] = 0;
				p->rule._burm12 = q->rule._burm12;
			}
			if (q->cost[_burm13_NT] == 0) {
				p->cost[_burm13_NT] = 0;
				p->rule._burm13 = q->rule._burm13;
			}
			if (q->cost[_burm14_NT] == 0) {
				p->cost[_burm14_NT] = 0;
				p->rule._burm14 = q->rule._burm14;
			}
			if (q->cost[_burm15_NT] == 0) {
				p->cost[_burm15_NT] = 0;
				p->rule._burm15 = q->rule._burm15;
			}
			if (q->cost[_burm16_NT] == 0) {
				p->cost[_burm16_NT] = 0;
				p->rule._burm16 = q->rule._burm16;
			}
			if (q->cost[_burm17_NT] == 0) {
				p->cost[_burm17_NT] = 0;
				p->rule._burm17 = q->rule._burm17;
			}
			if (q->cost[_burm18_NT] == 0) {
				p->cost[_burm18_NT] = 0;
				p->rule._burm18 = q->rule._burm18;
			}
			if (q->cost[_burm19_NT] == 0) {
				p->cost[_burm19_NT] = 0;
				p->rule._burm19 = q->rule._burm19;
			}
			if (q->cost[_burm20_NT] == 0) {
				p->cost[_burm20_NT] = 0;
				p->rule._burm20 = q->rule._burm20;
			}
			if (q->cost[_burm21_NT] == 0) {
				p->cost[_burm21_NT] = 0;
				p->rule._burm21 = q->rule._burm21;
			}
			if (q->cost[_burm22_NT] == 0) {
				p->cost[_burm22_NT] = 0;
				p->rule._burm22 = q->rule._burm22;
			}
			if (q->cost[_burm23_NT] == 0) {
				p->cost[_burm23_NT] = 0;
				p->rule._burm23 = q->rule._burm23;
			}
			if (q->cost[_burm24_NT] == 0) {
				p->cost[_burm24_NT] = 0;
				p->rule._burm24 = q->rule._burm24;
			}
			if (q->cost[_burm25_NT] == 0) {
				p->cost[_burm25_NT] = 0;
				p->rule._burm25 = q->rule._burm25;
			}
			if (q->cost[_burm26_NT] == 0) {
				p->cost[_burm26_NT] = 0;
				p->rule._burm26 = q->rule._burm26;
			}
			if (q->cost[_burm27_NT] == 0) {
				p->cost[_burm27_NT] = 0;
				p->rule._burm27 = q->rule._burm27;
			}
			if (q->cost[_burm28_NT] == 0) {
				p->cost[_burm28_NT] = 0;
				p->rule._burm28 = q->rule._burm28;
			}
			if (q->cost[_burm29_NT] == 0) {
				p->cost[_burm29_NT] = 0;
				p->rule._burm29 = q->rule._burm29;
			}
			if (q->cost[_burm30_NT] == 0) {
				p->cost[_burm30_NT] = 0;
				p->rule._burm30 = q->rule._burm30;
			}
			if (q->cost[_burm31_NT] == 0) {
				p->cost[_burm31_NT] = 0;
				p->rule._burm31 = q->rule._burm31;
			}
			if (q->cost[_burm32_NT] == 0) {
				p->cost[_burm32_NT] = 0;
				p->rule._burm32 = q->rule._burm32;
			}
			if (q->cost[_burm33_NT] == 0) {
				p->cost[_burm33_NT] = 0;
				p->rule._burm33 = q->rule._burm33;
			}
			if (q->cost[_burm34_NT] == 0) {
				p->cost[_burm34_NT] = 0;
				p->rule._burm34 = q->rule._burm34;
			}
			if (q->cost[_burm35_NT] == 0) {
				p->cost[_burm35_NT] = 0;
				p->rule._burm35 = q->rule._burm35;
			}
			if (q->cost[_burm36_NT] == 0) {
				p->cost[_burm36_NT] = 0;
				p->rule._burm36 = q->rule._burm36;
			}
			if (q->cost[_burm37_NT] == 0) {
				p->cost[_burm37_NT] = 0;
				p->rule._burm37 = q->rule._burm37;
			}
			if (q->cost[_burm38_NT] == 0) {
				p->cost[_burm38_NT] = 0;
				p->rule._burm38 = q->rule._burm38;
			}
			if (q->cost[_burm39_NT] == 0) {
				p->cost[_burm39_NT] = 0;
				p->rule._burm39 = q->rule._burm39;
			}
			if (q->cost[_burm40_NT] == 0) {
				p->cost[_burm40_NT] = 0;
				p->rule._burm40 = q->rule._burm40;
			}
			if (q->cost[_burm41_NT] == 0) {
				p->cost[_burm41_NT] = 0;
				p->rule._burm41 = q->rule._burm41;
			}
			if (q->cost[_burm42_NT] == 0) {
				p->cost[_burm42_NT] = 0;
				p->rule._burm42 = q->rule._burm42;
			}
		}
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm0_NT] + 0;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 5;
			_closure_reg(a, c + 0, p);
		}
		/* mem4: INDIRI4(addr) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + 0;
		if (c + 0 < p->cost[_mem4_NT]) {
			p->cost[_mem4_NT] = c + 0;
			p->rule._mem4 = 1;
			_closure_mem4(a, c + 0, p);
		}
		/* burm32: INDIRI4(addr) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + 0;
		if (c + 0 < p->cost[_burm32_NT]) {
			p->cost[_burm32_NT] = c + 0;
			p->rule._burm32 = 1;
		}
		break;
	case 4166: /* INDIRU4 */
		/* reg: INDIRU4(burm0) */
		if (mayrecalc(a)) {
			struct _state *q = a->syms[RX]->u.t.cse->x.state;
			if (q->cost[_stmt_NT] == 0) {
				p->cost[_stmt_NT] = 0;
				p->rule._stmt = q->rule._stmt;
			}
			if (q->cost[_reg_NT] == 0) {
				p->cost[_reg_NT] = 0;
				p->rule._reg = q->rule._reg;
			}
			if (q->cost[_freg_NT] == 0) {
				p->cost[_freg_NT] = 0;
				p->rule._freg = q->rule._freg;
			}
			if (q->cost[_cnst_NT] == 0) {
				p->cost[_cnst_NT] = 0;
				p->rule._cnst = q->rule._cnst;
			}
			if (q->cost[_con_NT] == 0) {
				p->cost[_con_NT] = 0;
				p->rule._con = q->rule._con;
			}
			if (q->cost[_acon_NT] == 0) {
				p->cost[_acon_NT] = 0;
				p->rule._acon = q->rule._acon;
			}
			if (q->cost[_baseaddr_NT] == 0) {
				p->cost[_baseaddr_NT] = 0;
				p->rule._baseaddr = q->rule._baseaddr;
			}
			if (q->cost[_base_NT] == 0) {
				p->cost[_base_NT] = 0;
				p->rule._base = q->rule._base;
			}
			if (q->cost[_index_NT] == 0) {
				p->cost[_index_NT] = 0;
				p->rule._index = q->rule._index;
			}
			if (q->cost[_con1_NT] == 0) {
				p->cost[_con1_NT] = 0;
				p->rule._con1 = q->rule._con1;
			}
			if (q->cost[_con2_NT] == 0) {
				p->cost[_con2_NT] = 0;
				p->rule._con2 = q->rule._con2;
			}
			if (q->cost[_con3_NT] == 0) {
				p->cost[_con3_NT] = 0;
				p->rule._con3 = q->rule._con3;
			}
			if (q->cost[_con0_NT] == 0) {
				p->cost[_con0_NT] = 0;
				p->rule._con0 = q->rule._con0;
			}
			if (q->cost[_addr_NT] == 0) {
				p->cost[_addr_NT] = 0;
				p->rule._addr = q->rule._addr;
			}
			if (q->cost[_mem1_NT] == 0) {
				p->cost[_mem1_NT] = 0;
				p->rule._mem1 = q->rule._mem1;
			}
			if (q->cost[_mem2_NT] == 0) {
				p->cost[_mem2_NT] = 0;
				p->rule._mem2 = q->rule._mem2;
			}
			if (q->cost[_mem4_NT] == 0) {
				p->cost[_mem4_NT] = 0;
				p->rule._mem4 = q->rule._mem4;
			}
			if (q->cost[_rc_NT] == 0) {
				p->cost[_rc_NT] = 0;
				p->rule._rc = q->rule._rc;
			}
			if (q->cost[_mr_NT] == 0) {
				p->cost[_mr_NT] = 0;
				p->rule._mr = q->rule._mr;
			}
			if (q->cost[_mr1_NT] == 0) {
				p->cost[_mr1_NT] = 0;
				p->rule._mr1 = q->rule._mr1;
			}
			if (q->cost[_mr2_NT] == 0) {
				p->cost[_mr2_NT] = 0;
				p->rule._mr2 = q->rule._mr2;
			}
			if (q->cost[_mrc_NT] == 0) {
				p->cost[_mrc_NT] = 0;
				p->rule._mrc = q->rule._mrc;
			}
			if (q->cost[_rc5_NT] == 0) {
				p->cost[_rc5_NT] = 0;
				p->rule._rc5 = q->rule._rc5;
			}
			if (q->cost[_mrca_NT] == 0) {
				p->cost[_mrca_NT] = 0;
				p->rule._mrca = q->rule._mrca;
			}
			if (q->cost[_memf_NT] == 0) {
				p->cost[_memf_NT] = 0;
				p->rule._memf = q->rule._memf;
			}
			if (q->cost[_flt_NT] == 0) {
				p->cost[_flt_NT] = 0;
				p->rule._flt = q->rule._flt;
			}
			if (q->cost[_flt2_NT] == 0) {
				p->cost[_flt2_NT] = 0;
				p->rule._flt2 = q->rule._flt2;
			}
			if (q->cost[_addrj_NT] == 0) {
				p->cost[_addrj_NT] = 0;
				p->rule._addrj = q->rule._addrj;
			}
			if (q->cost[_cmpf_NT] == 0) {
				p->cost[_cmpf_NT] = 0;
				p->rule._cmpf = q->rule._cmpf;
			}
			if (q->cost[_burm0_NT] == 0) {
				p->cost[_burm0_NT] = 0;
				p->rule._burm0 = q->rule._burm0;
			}
			if (q->cost[_burm1_NT] == 0) {
				p->cost[_burm1_NT] = 0;
				p->rule._burm1 = q->rule._burm1;
			}
			if (q->cost[_burm2_NT] == 0) {
				p->cost[_burm2_NT] = 0;
				p->rule._burm2 = q->rule._burm2;
			}
			if (q->cost[_burm3_NT] == 0) {
				p->cost[_burm3_NT] = 0;
				p->rule._burm3 = q->rule._burm3;
			}
			if (q->cost[_burm4_NT] == 0) {
				p->cost[_burm4_NT] = 0;
				p->rule._burm4 = q->rule._burm4;
			}
			if (q->cost[_burm5_NT] == 0) {
				p->cost[_burm5_NT] = 0;
				p->rule._burm5 = q->rule._burm5;
			}
			if (q->cost[_burm6_NT] == 0) {
				p->cost[_burm6_NT] = 0;
				p->rule._burm6 = q->rule._burm6;
			}
			if (q->cost[_burm7_NT] == 0) {
				p->cost[_burm7_NT] = 0;
				p->rule._burm7 = q->rule._burm7;
			}
			if (q->cost[_burm8_NT] == 0) {
				p->cost[_burm8_NT] = 0;
				p->rule._burm8 = q->rule._burm8;
			}
			if (q->cost[_burm9_NT] == 0) {
				p->cost[_burm9_NT] = 0;
				p->rule._burm9 = q->rule._burm9;
			}
			if (q->cost[_burm10_NT] == 0) {
				p->cost[_burm10_NT] = 0;
				p->rule._burm10 = q->rule._burm10;
			}
			if (q->cost[_burm11_NT] == 0) {
				p->cost[_burm11_NT] = 0;
				p->rule._burm11 = q->rule._burm11;
			}
			if (q->cost[_burm12_NT] == 0) {
				p->cost[_burm12_NT] = 0;
				p->rule._burm12 = q->rule._burm12;
			}
			if (q->cost[_burm13_NT] == 0) {
				p->cost[_burm13_NT] = 0;
				p->rule._burm13 = q->rule._burm13;
			}
			if (q->cost[_burm14_NT] == 0) {
				p->cost[_burm14_NT] = 0;
				p->rule._burm14 = q->rule._burm14;
			}
			if (q->cost[_burm15_NT] == 0) {
				p->cost[_burm15_NT] = 0;
				p->rule._burm15 = q->rule._burm15;
			}
			if (q->cost[_burm16_NT] == 0) {
				p->cost[_burm16_NT] = 0;
				p->rule._burm16 = q->rule._burm16;
			}
			if (q->cost[_burm17_NT] == 0) {
				p->cost[_burm17_NT] = 0;
				p->rule._burm17 = q->rule._burm17;
			}
			if (q->cost[_burm18_NT] == 0) {
				p->cost[_burm18_NT] = 0;
				p->rule._burm18 = q->rule._burm18;
			}
			if (q->cost[_burm19_NT] == 0) {
				p->cost[_burm19_NT] = 0;
				p->rule._burm19 = q->rule._burm19;
			}
			if (q->cost[_burm20_NT] == 0) {
				p->cost[_burm20_NT] = 0;
				p->rule._burm20 = q->rule._burm20;
			}
			if (q->cost[_burm21_NT] == 0) {
				p->cost[_burm21_NT] = 0;
				p->rule._burm21 = q->rule._burm21;
			}
			if (q->cost[_burm22_NT] == 0) {
				p->cost[_burm22_NT] = 0;
				p->rule._burm22 = q->rule._burm22;
			}
			if (q->cost[_burm23_NT] == 0) {
				p->cost[_burm23_NT] = 0;
				p->rule._burm23 = q->rule._burm23;
			}
			if (q->cost[_burm24_NT] == 0) {
				p->cost[_burm24_NT] = 0;
				p->rule._burm24 = q->rule._burm24;
			}
			if (q->cost[_burm25_NT] == 0) {
				p->cost[_burm25_NT] = 0;
				p->rule._burm25 = q->rule._burm25;
			}
			if (q->cost[_burm26_NT] == 0) {
				p->cost[_burm26_NT] = 0;
				p->rule._burm26 = q->rule._burm26;
			}
			if (q->cost[_burm27_NT] == 0) {
				p->cost[_burm27_NT] = 0;
				p->rule._burm27 = q->rule._burm27;
			}
			if (q->cost[_burm28_NT] == 0) {
				p->cost[_burm28_NT] = 0;
				p->rule._burm28 = q->rule._burm28;
			}
			if (q->cost[_burm29_NT] == 0) {
				p->cost[_burm29_NT] = 0;
				p->rule._burm29 = q->rule._burm29;
			}
			if (q->cost[_burm30_NT] == 0) {
				p->cost[_burm30_NT] = 0;
				p->rule._burm30 = q->rule._burm30;
			}
			if (q->cost[_burm31_NT] == 0) {
				p->cost[_burm31_NT] = 0;
				p->rule._burm31 = q->rule._burm31;
			}
			if (q->cost[_burm32_NT] == 0) {
				p->cost[_burm32_NT] = 0;
				p->rule._burm32 = q->rule._burm32;
			}
			if (q->cost[_burm33_NT] == 0) {
				p->cost[_burm33_NT] = 0;
				p->rule._burm33 = q->rule._burm33;
			}
			if (q->cost[_burm34_NT] == 0) {
				p->cost[_burm34_NT] = 0;
				p->rule._burm34 = q->rule._burm34;
			}
			if (q->cost[_burm35_NT] == 0) {
				p->cost[_burm35_NT] = 0;
				p->rule._burm35 = q->rule._burm35;
			}
			if (q->cost[_burm36_NT] == 0) {
				p->cost[_burm36_NT] = 0;
				p->rule._burm36 = q->rule._burm36;
			}
			if (q->cost[_burm37_NT] == 0) {
				p->cost[_burm37_NT] = 0;
				p->rule._burm37 = q->rule._burm37;
			}
			if (q->cost[_burm38_NT] == 0) {
				p->cost[_burm38_NT] = 0;
				p->rule._burm38 = q->rule._burm38;
			}
			if (q->cost[_burm39_NT] == 0) {
				p->cost[_burm39_NT] = 0;
				p->rule._burm39 = q->rule._burm39;
			}
			if (q->cost[_burm40_NT] == 0) {
				p->cost[_burm40_NT] = 0;
				p->rule._burm40 = q->rule._burm40;
			}
			if (q->cost[_burm41_NT] == 0) {
				p->cost[_burm41_NT] = 0;
				p->rule._burm41 = q->rule._burm41;
			}
			if (q->cost[_burm42_NT] == 0) {
				p->cost[_burm42_NT] = 0;
				p->rule._burm42 = q->rule._burm42;
			}
		}
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm0_NT] + 0;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 7;
			_closure_reg(a, c + 0, p);
		}
		/* mem4: INDIRU4(addr) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + 0;
		if (c + 0 < p->cost[_mem4_NT]) {
			p->cost[_mem4_NT] = c + 0;
			p->rule._mem4 = 2;
			_closure_mem4(a, c + 0, p);
		}
		break;
	case 4167: /* INDIRP4 */
		/* reg: INDIRP4(burm0) */
		if (mayrecalc(a)) {
			struct _state *q = a->syms[RX]->u.t.cse->x.state;
			if (q->cost[_stmt_NT] == 0) {
				p->cost[_stmt_NT] = 0;
				p->rule._stmt = q->rule._stmt;
			}
			if (q->cost[_reg_NT] == 0) {
				p->cost[_reg_NT] = 0;
				p->rule._reg = q->rule._reg;
			}
			if (q->cost[_freg_NT] == 0) {
				p->cost[_freg_NT] = 0;
				p->rule._freg = q->rule._freg;
			}
			if (q->cost[_cnst_NT] == 0) {
				p->cost[_cnst_NT] = 0;
				p->rule._cnst = q->rule._cnst;
			}
			if (q->cost[_con_NT] == 0) {
				p->cost[_con_NT] = 0;
				p->rule._con = q->rule._con;
			}
			if (q->cost[_acon_NT] == 0) {
				p->cost[_acon_NT] = 0;
				p->rule._acon = q->rule._acon;
			}
			if (q->cost[_baseaddr_NT] == 0) {
				p->cost[_baseaddr_NT] = 0;
				p->rule._baseaddr = q->rule._baseaddr;
			}
			if (q->cost[_base_NT] == 0) {
				p->cost[_base_NT] = 0;
				p->rule._base = q->rule._base;
			}
			if (q->cost[_index_NT] == 0) {
				p->cost[_index_NT] = 0;
				p->rule._index = q->rule._index;
			}
			if (q->cost[_con1_NT] == 0) {
				p->cost[_con1_NT] = 0;
				p->rule._con1 = q->rule._con1;
			}
			if (q->cost[_con2_NT] == 0) {
				p->cost[_con2_NT] = 0;
				p->rule._con2 = q->rule._con2;
			}
			if (q->cost[_con3_NT] == 0) {
				p->cost[_con3_NT] = 0;
				p->rule._con3 = q->rule._con3;
			}
			if (q->cost[_con0_NT] == 0) {
				p->cost[_con0_NT] = 0;
				p->rule._con0 = q->rule._con0;
			}
			if (q->cost[_addr_NT] == 0) {
				p->cost[_addr_NT] = 0;
				p->rule._addr = q->rule._addr;
			}
			if (q->cost[_mem1_NT] == 0) {
				p->cost[_mem1_NT] = 0;
				p->rule._mem1 = q->rule._mem1;
			}
			if (q->cost[_mem2_NT] == 0) {
				p->cost[_mem2_NT] = 0;
				p->rule._mem2 = q->rule._mem2;
			}
			if (q->cost[_mem4_NT] == 0) {
				p->cost[_mem4_NT] = 0;
				p->rule._mem4 = q->rule._mem4;
			}
			if (q->cost[_rc_NT] == 0) {
				p->cost[_rc_NT] = 0;
				p->rule._rc = q->rule._rc;
			}
			if (q->cost[_mr_NT] == 0) {
				p->cost[_mr_NT] = 0;
				p->rule._mr = q->rule._mr;
			}
			if (q->cost[_mr1_NT] == 0) {
				p->cost[_mr1_NT] = 0;
				p->rule._mr1 = q->rule._mr1;
			}
			if (q->cost[_mr2_NT] == 0) {
				p->cost[_mr2_NT] = 0;
				p->rule._mr2 = q->rule._mr2;
			}
			if (q->cost[_mrc_NT] == 0) {
				p->cost[_mrc_NT] = 0;
				p->rule._mrc = q->rule._mrc;
			}
			if (q->cost[_rc5_NT] == 0) {
				p->cost[_rc5_NT] = 0;
				p->rule._rc5 = q->rule._rc5;
			}
			if (q->cost[_mrca_NT] == 0) {
				p->cost[_mrca_NT] = 0;
				p->rule._mrca = q->rule._mrca;
			}
			if (q->cost[_memf_NT] == 0) {
				p->cost[_memf_NT] = 0;
				p->rule._memf = q->rule._memf;
			}
			if (q->cost[_flt_NT] == 0) {
				p->cost[_flt_NT] = 0;
				p->rule._flt = q->rule._flt;
			}
			if (q->cost[_flt2_NT] == 0) {
				p->cost[_flt2_NT] = 0;
				p->rule._flt2 = q->rule._flt2;
			}
			if (q->cost[_addrj_NT] == 0) {
				p->cost[_addrj_NT] = 0;
				p->rule._addrj = q->rule._addrj;
			}
			if (q->cost[_cmpf_NT] == 0) {
				p->cost[_cmpf_NT] = 0;
				p->rule._cmpf = q->rule._cmpf;
			}
			if (q->cost[_burm0_NT] == 0) {
				p->cost[_burm0_NT] = 0;
				p->rule._burm0 = q->rule._burm0;
			}
			if (q->cost[_burm1_NT] == 0) {
				p->cost[_burm1_NT] = 0;
				p->rule._burm1 = q->rule._burm1;
			}
			if (q->cost[_burm2_NT] == 0) {
				p->cost[_burm2_NT] = 0;
				p->rule._burm2 = q->rule._burm2;
			}
			if (q->cost[_burm3_NT] == 0) {
				p->cost[_burm3_NT] = 0;
				p->rule._burm3 = q->rule._burm3;
			}
			if (q->cost[_burm4_NT] == 0) {
				p->cost[_burm4_NT] = 0;
				p->rule._burm4 = q->rule._burm4;
			}
			if (q->cost[_burm5_NT] == 0) {
				p->cost[_burm5_NT] = 0;
				p->rule._burm5 = q->rule._burm5;
			}
			if (q->cost[_burm6_NT] == 0) {
				p->cost[_burm6_NT] = 0;
				p->rule._burm6 = q->rule._burm6;
			}
			if (q->cost[_burm7_NT] == 0) {
				p->cost[_burm7_NT] = 0;
				p->rule._burm7 = q->rule._burm7;
			}
			if (q->cost[_burm8_NT] == 0) {
				p->cost[_burm8_NT] = 0;
				p->rule._burm8 = q->rule._burm8;
			}
			if (q->cost[_burm9_NT] == 0) {
				p->cost[_burm9_NT] = 0;
				p->rule._burm9 = q->rule._burm9;
			}
			if (q->cost[_burm10_NT] == 0) {
				p->cost[_burm10_NT] = 0;
				p->rule._burm10 = q->rule._burm10;
			}
			if (q->cost[_burm11_NT] == 0) {
				p->cost[_burm11_NT] = 0;
				p->rule._burm11 = q->rule._burm11;
			}
			if (q->cost[_burm12_NT] == 0) {
				p->cost[_burm12_NT] = 0;
				p->rule._burm12 = q->rule._burm12;
			}
			if (q->cost[_burm13_NT] == 0) {
				p->cost[_burm13_NT] = 0;
				p->rule._burm13 = q->rule._burm13;
			}
			if (q->cost[_burm14_NT] == 0) {
				p->cost[_burm14_NT] = 0;
				p->rule._burm14 = q->rule._burm14;
			}
			if (q->cost[_burm15_NT] == 0) {
				p->cost[_burm15_NT] = 0;
				p->rule._burm15 = q->rule._burm15;
			}
			if (q->cost[_burm16_NT] == 0) {
				p->cost[_burm16_NT] = 0;
				p->rule._burm16 = q->rule._burm16;
			}
			if (q->cost[_burm17_NT] == 0) {
				p->cost[_burm17_NT] = 0;
				p->rule._burm17 = q->rule._burm17;
			}
			if (q->cost[_burm18_NT] == 0) {
				p->cost[_burm18_NT] = 0;
				p->rule._burm18 = q->rule._burm18;
			}
			if (q->cost[_burm19_NT] == 0) {
				p->cost[_burm19_NT] = 0;
				p->rule._burm19 = q->rule._burm19;
			}
			if (q->cost[_burm20_NT] == 0) {
				p->cost[_burm20_NT] = 0;
				p->rule._burm20 = q->rule._burm20;
			}
			if (q->cost[_burm21_NT] == 0) {
				p->cost[_burm21_NT] = 0;
				p->rule._burm21 = q->rule._burm21;
			}
			if (q->cost[_burm22_NT] == 0) {
				p->cost[_burm22_NT] = 0;
				p->rule._burm22 = q->rule._burm22;
			}
			if (q->cost[_burm23_NT] == 0) {
				p->cost[_burm23_NT] = 0;
				p->rule._burm23 = q->rule._burm23;
			}
			if (q->cost[_burm24_NT] == 0) {
				p->cost[_burm24_NT] = 0;
				p->rule._burm24 = q->rule._burm24;
			}
			if (q->cost[_burm25_NT] == 0) {
				p->cost[_burm25_NT] = 0;
				p->rule._burm25 = q->rule._burm25;
			}
			if (q->cost[_burm26_NT] == 0) {
				p->cost[_burm26_NT] = 0;
				p->rule._burm26 = q->rule._burm26;
			}
			if (q->cost[_burm27_NT] == 0) {
				p->cost[_burm27_NT] = 0;
				p->rule._burm27 = q->rule._burm27;
			}
			if (q->cost[_burm28_NT] == 0) {
				p->cost[_burm28_NT] = 0;
				p->rule._burm28 = q->rule._burm28;
			}
			if (q->cost[_burm29_NT] == 0) {
				p->cost[_burm29_NT] = 0;
				p->rule._burm29 = q->rule._burm29;
			}
			if (q->cost[_burm30_NT] == 0) {
				p->cost[_burm30_NT] = 0;
				p->rule._burm30 = q->rule._burm30;
			}
			if (q->cost[_burm31_NT] == 0) {
				p->cost[_burm31_NT] = 0;
				p->rule._burm31 = q->rule._burm31;
			}
			if (q->cost[_burm32_NT] == 0) {
				p->cost[_burm32_NT] = 0;
				p->rule._burm32 = q->rule._burm32;
			}
			if (q->cost[_burm33_NT] == 0) {
				p->cost[_burm33_NT] = 0;
				p->rule._burm33 = q->rule._burm33;
			}
			if (q->cost[_burm34_NT] == 0) {
				p->cost[_burm34_NT] = 0;
				p->rule._burm34 = q->rule._burm34;
			}
			if (q->cost[_burm35_NT] == 0) {
				p->cost[_burm35_NT] = 0;
				p->rule._burm35 = q->rule._burm35;
			}
			if (q->cost[_burm36_NT] == 0) {
				p->cost[_burm36_NT] = 0;
				p->rule._burm36 = q->rule._burm36;
			}
			if (q->cost[_burm37_NT] == 0) {
				p->cost[_burm37_NT] = 0;
				p->rule._burm37 = q->rule._burm37;
			}
			if (q->cost[_burm38_NT] == 0) {
				p->cost[_burm38_NT] = 0;
				p->rule._burm38 = q->rule._burm38;
			}
			if (q->cost[_burm39_NT] == 0) {
				p->cost[_burm39_NT] = 0;
				p->rule._burm39 = q->rule._burm39;
			}
			if (q->cost[_burm40_NT] == 0) {
				p->cost[_burm40_NT] = 0;
				p->rule._burm40 = q->rule._burm40;
			}
			if (q->cost[_burm41_NT] == 0) {
				p->cost[_burm41_NT] = 0;
				p->rule._burm41 = q->rule._burm41;
			}
			if (q->cost[_burm42_NT] == 0) {
				p->cost[_burm42_NT] = 0;
				p->rule._burm42 = q->rule._burm42;
			}
		}
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm0_NT] + 0;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 6;
			_closure_reg(a, c + 0, p);
		}
		/* mem4: INDIRP4(addr) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + 0;
		if (c + 0 < p->cost[_mem4_NT]) {
			p->cost[_mem4_NT] = c + 0;
			p->rule._mem4 = 3;
			_closure_mem4(a, c + 0, p);
		}
		break;
	case 4209: /* CVFF4 */
		/* memf: CVFF4(burm30) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm30_NT] + 0;
		if (c + 0 < p->cost[_memf_NT]) {
			p->cost[_memf_NT] = c + 0;
			p->rule._memf = 4;
			_closure_memf(a, c + 0, p);
		}
		/* freg: CVFF4(freg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_freg_NT] + 12;
		if (c + 0 < p->cost[_freg_NT]) {
			p->cost[_freg_NT] = c + 0;
			p->rule._freg = 15;
			_closure_freg(a, c + 0, p);
		}
		/* burm31: CVFF4(freg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_freg_NT] + 0;
		if (c + 0 < p->cost[_burm31_NT]) {
			p->cost[_burm31_NT] = c + 0;
			p->rule._burm31 = 1;
		}
		break;
	case 4213: /* CVFI4 */
		/* reg: CVFI4(freg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_freg_NT] + 31;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 63;
			_closure_reg(a, c + 0, p);
		}
		break;
	case 4225: /* CVIF4 */
		/* freg: CVIF4(burm32) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm32_NT] + 10;
		if (c + 0 < p->cost[_freg_NT]) {
			p->cost[_freg_NT] = c + 0;
			p->rule._freg = 18;
			_closure_freg(a, c + 0, p);
		}
		/* freg: CVIF4(reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 12;
		if (c + 0 < p->cost[_freg_NT]) {
			p->cost[_freg_NT] = c + 0;
			p->rule._freg = 19;
			_closure_freg(a, c + 0, p);
		}
		break;
	case 4229: /* CVII4 */
		/* reg: CVII4(burm24) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm24_NT] + 3;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 51;
			_closure_reg(a, c + 0, p);
		}
		/* reg: CVII4(burm25) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm25_NT] + 3;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 52;
			_closure_reg(a, c + 0, p);
		}
		/* reg: CVII4(reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 3;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 55;
			_closure_reg(a, c + 0, p);
		}
		break;
	case 4230: /* CVIU4 */
		/* reg: CVIU4(reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 3;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 56;
			_closure_reg(a, c + 0, p);
		}
		break;
	case 4246: /* CVPU4 */
		/* reg: CVPU4(reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + (move(a));
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 49;
			_closure_reg(a, c + 0, p);
		}
		break;
	case 4247: /* CVPP4 */
		break;
	case 4277: /* CVUI4 */
		/* reg: CVUI4(reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 3;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 57;
			_closure_reg(a, c + 0, p);
		}
		break;
	case 4278: /* CVUU4 */
		/* reg: CVUU4(burm26) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm26_NT] + 3;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 53;
			_closure_reg(a, c + 0, p);
		}
		/* reg: CVUU4(burm27) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm27_NT] + 3;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 54;
			_closure_reg(a, c + 0, p);
		}
		/* reg: CVUU4(reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 3;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 58;
			_closure_reg(a, c + 0, p);
		}
		break;
	case 4279: /* CVUP4 */
		/* reg: CVUP4(reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + (move(a));
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 50;
			_closure_reg(a, c + 0, p);
		}
		break;
	case 4289: /* NEGF4 */
		/* freg: NEGF4(freg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_freg_NT] + 0;
		if (c + 0 < p->cost[_freg_NT]) {
			p->cost[_freg_NT] = c + 0;
			p->rule._freg = 5;
			_closure_freg(a, c + 0, p);
		}
		break;
	case 4293: /* NEGI4 */
		/* reg: NEGI4(reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 2;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 37;
			_closure_reg(a, c + 0, p);
		}
		/* burm19: NEGI4(mem4) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_mem4_NT] + 0;
		if (c + 0 < p->cost[_burm19_NT]) {
			p->cost[_burm19_NT] = c + 0;
			p->rule._burm19 = 1;
		}
		break;
	case 4305: /* CALLF4 */
		/* freg: CALLF4(addrj) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addrj_NT] + (hasargs(a));
		if (c + 0 < p->cost[_freg_NT]) {
			p->cost[_freg_NT] = c + 0;
			p->rule._freg = 37;
			_closure_freg(a, c + 0, p);
		}
		/* freg: CALLF4(addrj) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addrj_NT] + 1;
		if (c + 0 < p->cost[_freg_NT]) {
			p->cost[_freg_NT] = c + 0;
			p->rule._freg = 38;
			_closure_freg(a, c + 0, p);
		}
		/* stmt: CALLF4(addrj) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addrj_NT] + (hasargs(a));
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 100;
		}
		/* stmt: CALLF4(addrj) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addrj_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 101;
		}
		break;
	case 4309: /* CALLI4 */
		/* reg: CALLI4(addrj) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addrj_NT] + (hasargs(a));
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 64;
			_closure_reg(a, c + 0, p);
		}
		/* reg: CALLI4(addrj) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addrj_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 67;
			_closure_reg(a, c + 0, p);
		}
		break;
	case 4310: /* CALLU4 */
		/* reg: CALLU4(addrj) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addrj_NT] + (hasargs(a));
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 65;
			_closure_reg(a, c + 0, p);
		}
		/* reg: CALLU4(addrj) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addrj_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 68;
			_closure_reg(a, c + 0, p);
		}
		break;
	case 4311: /* CALLP4 */
		/* reg: CALLP4(addrj) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addrj_NT] + (hasargs(a));
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 66;
			_closure_reg(a, c + 0, p);
		}
		/* reg: CALLP4(addrj) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addrj_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 69;
			_closure_reg(a, c + 0, p);
		}
		break;
	case 4321: /* LOADF4 */
		break;
	case 4325: /* LOADI4 */
		/* reg: LOADI4(reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + (move(a));
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 18;
			_closure_reg(a, c + 0, p);
		}
		break;
	case 4326: /* LOADU4 */
		/* reg: LOADU4(reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + (move(a));
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 21;
			_closure_reg(a, c + 0, p);
		}
		break;
	case 4327: /* LOADP4 */
		/* reg: LOADP4(reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + (move(a));
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 22;
			_closure_reg(a, c + 0, p);
		}
		break;
	case 4337: /* RETF4 */
		/* stmt: RETF4(freg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_freg_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 107;
		}
		break;
	case 4341: /* RETI4 */
		/* stmt: RETI4(reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 104;
		}
		break;
	case 4342: /* RETU4 */
		/* stmt: RETU4(reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 105;
		}
		break;
	case 4343: /* RETP4 */
		/* stmt: RETP4(reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 106;
		}
		break;
	case 4359: /* ADDRGP4 */
		/* acon: ADDRGP4 */
		if (0 + 0 < p->cost[_acon_NT]) {
			p->cost[_acon_NT] = 0 + 0;
			p->rule._acon = 1;
		}
		/* baseaddr: ADDRGP4 */
		if (0 + 0 < p->cost[_baseaddr_NT]) {
			p->cost[_baseaddr_NT] = 0 + 0;
			p->rule._baseaddr = 1;
			_closure_baseaddr(a, 0 + 0, p);
		}
		/* mrca: ADDRGP4 */
		if (0 + 0 < p->cost[_mrca_NT]) {
			p->cost[_mrca_NT] = 0 + 0;
			p->rule._mrca = 3;
		}
		/* addrj: ADDRGP4 */
		if (0 + 0 < p->cost[_addrj_NT]) {
			p->cost[_addrj_NT] = 0 + 0;
			p->rule._addrj = 1;
		}
		break;
	case 4375: /* ADDRFP4 */
		/* base: ADDRFP4 */
		if (0 + 0 < p->cost[_base_NT]) {
			p->cost[_base_NT] = 0 + 0;
			p->rule._base = 5;
			_closure_base(a, 0 + 0, p);
		}
		break;
	case 4391: /* ADDRLP4 */
		/* base: ADDRLP4 */
		if (0 + 0 < p->cost[_base_NT]) {
			p->cost[_base_NT] = 0 + 0;
			p->rule._base = 6;
			_closure_base(a, 0 + 0, p);
		}
		break;
	case 4401: /* ADDF4 */
		/* freg: ADDF4(freg,flt) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_freg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_flt_NT] + 0;
		if (c + 0 < p->cost[_freg_NT]) {
			p->cost[_freg_NT] = c + 0;
			p->rule._freg = 6;
			_closure_freg(a, c + 0, p);
		}
		break;
	case 4405: /* ADDI4 */
		/* base: ADDI4(reg,acon) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_acon_NT] + 0;
		if (c + 0 < p->cost[_base_NT]) {
			p->cost[_base_NT] = c + 0;
			p->rule._base = 2;
			_closure_base(a, c + 0, p);
		}
		/* addr: ADDI4(index,baseaddr) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_index_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_baseaddr_NT] + 0;
		if (c + 0 < p->cost[_addr_NT]) {
			p->cost[_addr_NT] = c + 0;
			p->rule._addr = 3;
			_closure_addr(a, c + 0, p);
		}
		/* addr: ADDI4(reg,baseaddr) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_baseaddr_NT] + 0;
		if (c + 0 < p->cost[_addr_NT]) {
			p->cost[_addr_NT] = c + 0;
			p->rule._addr = 6;
			_closure_addr(a, c + 0, p);
		}
		/* addr: ADDI4(index,reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_index_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
		if (c + 0 < p->cost[_addr_NT]) {
			p->cost[_addr_NT] = c + 0;
			p->rule._addr = 9;
			_closure_addr(a, c + 0, p);
		}
		/* reg: ADDI4(reg,mrc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_mrc_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 23;
			_closure_reg(a, c + 0, p);
		}
		/* burm1: ADDI4(mem4,con1) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_mem4_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_con1_NT] + 0;
		if (c + 0 < p->cost[_burm1_NT]) {
			p->cost[_burm1_NT] = c + 0;
			p->rule._burm1 = 1;
		}
		/* burm7: ADDI4(mem4,rc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_mem4_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 0;
		if (c + 0 < p->cost[_burm7_NT]) {
			p->cost[_burm7_NT] = c + 0;
			p->rule._burm7 = 1;
		}
		break;
	case 4406: /* ADDU4 */
		/* base: ADDU4(reg,acon) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_acon_NT] + 0;
		if (c + 0 < p->cost[_base_NT]) {
			p->cost[_base_NT] = c + 0;
			p->rule._base = 4;
			_closure_base(a, c + 0, p);
		}
		/* addr: ADDU4(index,baseaddr) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_index_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_baseaddr_NT] + 0;
		if (c + 0 < p->cost[_addr_NT]) {
			p->cost[_addr_NT] = c + 0;
			p->rule._addr = 5;
			_closure_addr(a, c + 0, p);
		}
		/* addr: ADDU4(reg,baseaddr) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_baseaddr_NT] + 0;
		if (c + 0 < p->cost[_addr_NT]) {
			p->cost[_addr_NT] = c + 0;
			p->rule._addr = 8;
			_closure_addr(a, c + 0, p);
		}
		/* addr: ADDU4(index,reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_index_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
		if (c + 0 < p->cost[_addr_NT]) {
			p->cost[_addr_NT] = c + 0;
			p->rule._addr = 11;
			_closure_addr(a, c + 0, p);
		}
		/* reg: ADDU4(reg,mrc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_mrc_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 25;
			_closure_reg(a, c + 0, p);
		}
		/* burm2: ADDU4(mem4,con1) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_mem4_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_con1_NT] + 0;
		if (c + 0 < p->cost[_burm2_NT]) {
			p->cost[_burm2_NT] = c + 0;
			p->rule._burm2 = 1;
		}
		/* burm9: ADDU4(mem4,rc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_mem4_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 0;
		if (c + 0 < p->cost[_burm9_NT]) {
			p->cost[_burm9_NT] = c + 0;
			p->rule._burm9 = 1;
		}
		break;
	case 4407: /* ADDP4 */
		/* base: ADDP4(reg,acon) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_acon_NT] + 0;
		if (c + 0 < p->cost[_base_NT]) {
			p->cost[_base_NT] = c + 0;
			p->rule._base = 3;
			_closure_base(a, c + 0, p);
		}
		/* addr: ADDP4(index,baseaddr) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_index_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_baseaddr_NT] + 0;
		if (c + 0 < p->cost[_addr_NT]) {
			p->cost[_addr_NT] = c + 0;
			p->rule._addr = 4;
			_closure_addr(a, c + 0, p);
		}
		/* addr: ADDP4(reg,baseaddr) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_baseaddr_NT] + 0;
		if (c + 0 < p->cost[_addr_NT]) {
			p->cost[_addr_NT] = c + 0;
			p->rule._addr = 7;
			_closure_addr(a, c + 0, p);
		}
		/* addr: ADDP4(index,reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_index_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
		if (c + 0 < p->cost[_addr_NT]) {
			p->cost[_addr_NT] = c + 0;
			p->rule._addr = 10;
			_closure_addr(a, c + 0, p);
		}
		/* reg: ADDP4(reg,mrc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_mrc_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 24;
			_closure_reg(a, c + 0, p);
		}
		/* burm3: ADDP4(mem4,con1) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_mem4_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_con1_NT] + 0;
		if (c + 0 < p->cost[_burm3_NT]) {
			p->cost[_burm3_NT] = c + 0;
			p->rule._burm3 = 1;
		}
		break;
	case 4417: /* SUBF4 */
		/* freg: SUBF4(freg,flt2) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_freg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_flt2_NT] + 0;
		if (c + 0 < p->cost[_freg_NT]) {
			p->cost[_freg_NT] = c + 0;
			p->rule._freg = 12;
			_closure_freg(a, c + 0, p);
		}
		break;
	case 4421: /* SUBI4 */
		/* reg: SUBI4(reg,mrc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_mrc_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 26;
			_closure_reg(a, c + 0, p);
		}
		/* burm4: SUBI4(mem4,con1) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_mem4_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_con1_NT] + 0;
		if (c + 0 < p->cost[_burm4_NT]) {
			p->cost[_burm4_NT] = c + 0;
			p->rule._burm4 = 1;
		}
		/* burm8: SUBI4(mem4,rc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_mem4_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 0;
		if (c + 0 < p->cost[_burm8_NT]) {
			p->cost[_burm8_NT] = c + 0;
			p->rule._burm8 = 1;
		}
		break;
	case 4422: /* SUBU4 */
		/* reg: SUBU4(reg,mrc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_mrc_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 28;
			_closure_reg(a, c + 0, p);
		}
		/* burm5: SUBU4(mem4,con1) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_mem4_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_con1_NT] + 0;
		if (c + 0 < p->cost[_burm5_NT]) {
			p->cost[_burm5_NT] = c + 0;
			p->rule._burm5 = 1;
		}
		/* burm10: SUBU4(mem4,rc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_mem4_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 0;
		if (c + 0 < p->cost[_burm10_NT]) {
			p->cost[_burm10_NT] = c + 0;
			p->rule._burm10 = 1;
		}
		break;
	case 4423: /* SUBP4 */
		/* reg: SUBP4(reg,mrc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_mrc_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 27;
			_closure_reg(a, c + 0, p);
		}
		/* burm6: SUBP4(mem4,con1) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_mem4_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_con1_NT] + 0;
		if (c + 0 < p->cost[_burm6_NT]) {
			p->cost[_burm6_NT] = c + 0;
			p->rule._burm6 = 1;
		}
		break;
	case 4437: /* LSHI4 */
		/* index: LSHI4(reg,con1) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_con1_NT] + 0;
		if (c + 0 < p->cost[_index_NT]) {
			p->cost[_index_NT] = c + 0;
			p->rule._index = 2;
			_closure_index(a, c + 0, p);
		}
		/* index: LSHI4(reg,con2) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_con2_NT] + 0;
		if (c + 0 < p->cost[_index_NT]) {
			p->cost[_index_NT] = c + 0;
			p->rule._index = 3;
			_closure_index(a, c + 0, p);
		}
		/* index: LSHI4(reg,con3) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_con3_NT] + 0;
		if (c + 0 < p->cost[_index_NT]) {
			p->cost[_index_NT] = c + 0;
			p->rule._index = 4;
			_closure_index(a, c + 0, p);
		}
		/* reg: LSHI4(reg,rc5) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_rc5_NT] + 2;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 38;
			_closure_reg(a, c + 0, p);
		}
		/* burm20: LSHI4(mem4,rc5) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_mem4_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_rc5_NT] + 0;
		if (c + 0 < p->cost[_burm20_NT]) {
			p->cost[_burm20_NT] = c + 0;
			p->rule._burm20 = 1;
		}
		break;
	case 4438: /* LSHU4 */
		/* index: LSHU4(reg,con1) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_con1_NT] + 0;
		if (c + 0 < p->cost[_index_NT]) {
			p->cost[_index_NT] = c + 0;
			p->rule._index = 5;
			_closure_index(a, c + 0, p);
		}
		/* index: LSHU4(reg,con2) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_con2_NT] + 0;
		if (c + 0 < p->cost[_index_NT]) {
			p->cost[_index_NT] = c + 0;
			p->rule._index = 6;
			_closure_index(a, c + 0, p);
		}
		/* index: LSHU4(reg,con3) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_con3_NT] + 0;
		if (c + 0 < p->cost[_index_NT]) {
			p->cost[_index_NT] = c + 0;
			p->rule._index = 7;
			_closure_index(a, c + 0, p);
		}
		/* reg: LSHU4(reg,rc5) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_rc5_NT] + 2;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 39;
			_closure_reg(a, c + 0, p);
		}
		/* burm21: LSHU4(mem4,rc5) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_mem4_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_rc5_NT] + 0;
		if (c + 0 < p->cost[_burm21_NT]) {
			p->cost[_burm21_NT] = c + 0;
			p->rule._burm21 = 1;
		}
		break;
	case 4453: /* MODI4 */
		/* reg: MODI4(reg,reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 48;
			_closure_reg(a, c + 0, p);
		}
		break;
	case 4454: /* MODU4 */
		/* reg: MODU4(reg,reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 46;
			_closure_reg(a, c + 0, p);
		}
		break;
	case 4469: /* RSHI4 */
		/* reg: RSHI4(reg,rc5) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_rc5_NT] + 2;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 40;
			_closure_reg(a, c + 0, p);
		}
		/* burm22: RSHI4(mem4,rc5) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_mem4_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_rc5_NT] + 0;
		if (c + 0 < p->cost[_burm22_NT]) {
			p->cost[_burm22_NT] = c + 0;
			p->rule._burm22 = 1;
		}
		break;
	case 4470: /* RSHU4 */
		/* reg: RSHU4(reg,rc5) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_rc5_NT] + 2;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 41;
			_closure_reg(a, c + 0, p);
		}
		/* burm23: RSHU4(mem4,rc5) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_mem4_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_rc5_NT] + 0;
		if (c + 0 < p->cost[_burm23_NT]) {
			p->cost[_burm23_NT] = c + 0;
			p->rule._burm23 = 1;
		}
		break;
	case 4485: /* BANDI4 */
		/* reg: BANDI4(reg,mrc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_mrc_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 29;
			_closure_reg(a, c + 0, p);
		}
		/* burm11: BANDI4(mem4,rc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_mem4_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 0;
		if (c + 0 < p->cost[_burm11_NT]) {
			p->cost[_burm11_NT] = c + 0;
			p->rule._burm11 = 1;
		}
		break;
	case 4486: /* BANDU4 */
		/* reg: BANDU4(reg,mrc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_mrc_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 32;
			_closure_reg(a, c + 0, p);
		}
		/* burm14: BANDU4(mem4,rc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_mem4_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 0;
		if (c + 0 < p->cost[_burm14_NT]) {
			p->cost[_burm14_NT] = c + 0;
			p->rule._burm14 = 1;
		}
		/* burm33: BANDU4(mr,con) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_mr_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_con_NT] + 0;
		if (c + 0 < p->cost[_burm33_NT]) {
			p->cost[_burm33_NT] = c + 0;
			p->rule._burm33 = 1;
		}
		/* burm34: BANDU4(burm40,con) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm40_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_con_NT] + 0;
		if (c + 0 < p->cost[_burm34_NT]) {
			p->cost[_burm34_NT] = c + 0;
			p->rule._burm34 = 1;
		}
		/* burm35: BANDU4(burm41,con) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm41_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_con_NT] + 0;
		if (c + 0 < p->cost[_burm35_NT]) {
			p->cost[_burm35_NT] = c + 0;
			p->rule._burm35 = 1;
		}
		/* burm36: BANDU4(burm42,con) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm42_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_con_NT] + 0;
		if (c + 0 < p->cost[_burm36_NT]) {
			p->cost[_burm36_NT] = c + 0;
			p->rule._burm36 = 1;
		}
		break;
	case 4501: /* BCOMI4 */
		/* reg: BCOMI4(reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 2;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 35;
			_closure_reg(a, c + 0, p);
		}
		/* burm17: BCOMI4(mem4) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_mem4_NT] + 0;
		if (c + 0 < p->cost[_burm17_NT]) {
			p->cost[_burm17_NT] = c + 0;
			p->rule._burm17 = 1;
		}
		break;
	case 4502: /* BCOMU4 */
		/* reg: BCOMU4(reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 2;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 36;
			_closure_reg(a, c + 0, p);
		}
		/* burm18: BCOMU4(mem4) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_mem4_NT] + 0;
		if (c + 0 < p->cost[_burm18_NT]) {
			p->cost[_burm18_NT] = c + 0;
			p->rule._burm18 = 1;
		}
		break;
	case 4517: /* BORI4 */
		/* reg: BORI4(reg,mrc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_mrc_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 30;
			_closure_reg(a, c + 0, p);
		}
		/* burm12: BORI4(mem4,rc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_mem4_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 0;
		if (c + 0 < p->cost[_burm12_NT]) {
			p->cost[_burm12_NT] = c + 0;
			p->rule._burm12 = 1;
		}
		break;
	case 4518: /* BORU4 */
		/* reg: BORU4(reg,mrc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_mrc_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 33;
			_closure_reg(a, c + 0, p);
		}
		/* burm15: BORU4(mem4,rc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_mem4_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 0;
		if (c + 0 < p->cost[_burm15_NT]) {
			p->cost[_burm15_NT] = c + 0;
			p->rule._burm15 = 1;
		}
		break;
	case 4533: /* BXORI4 */
		/* reg: BXORI4(reg,mrc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_mrc_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 31;
			_closure_reg(a, c + 0, p);
		}
		/* burm13: BXORI4(mem4,rc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_mem4_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 0;
		if (c + 0 < p->cost[_burm13_NT]) {
			p->cost[_burm13_NT] = c + 0;
			p->rule._burm13 = 1;
		}
		break;
	case 4534: /* BXORU4 */
		/* reg: BXORU4(reg,mrc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_mrc_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 34;
			_closure_reg(a, c + 0, p);
		}
		/* burm16: BXORU4(mem4,rc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_mem4_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 0;
		if (c + 0 < p->cost[_burm16_NT]) {
			p->cost[_burm16_NT] = c + 0;
			p->rule._burm16 = 1;
		}
		break;
	case 4545: /* DIVF4 */
		/* freg: DIVF4(freg,flt2) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_freg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_flt2_NT] + 0;
		if (c + 0 < p->cost[_freg_NT]) {
			p->cost[_freg_NT] = c + 0;
			p->rule._freg = 8;
			_closure_freg(a, c + 0, p);
		}
		break;
	case 4549: /* DIVI4 */
		/* reg: DIVI4(reg,reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 47;
			_closure_reg(a, c + 0, p);
		}
		break;
	case 4550: /* DIVU4 */
		/* reg: DIVU4(reg,reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 45;
			_closure_reg(a, c + 0, p);
		}
		break;
	case 4561: /* MULF4 */
		/* freg: MULF4(freg,flt) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_freg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_flt_NT] + 0;
		if (c + 0 < p->cost[_freg_NT]) {
			p->cost[_freg_NT] = c + 0;
			p->rule._freg = 10;
			_closure_freg(a, c + 0, p);
		}
		break;
	case 4565: /* MULI4 */
		/* reg: MULI4(reg,mrc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_mrc_NT] + 14;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 42;
			_closure_reg(a, c + 0, p);
		}
		/* reg: MULI4(con,mr) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_con_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_mr_NT] + 13;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 43;
			_closure_reg(a, c + 0, p);
		}
		break;
	case 4566: /* MULU4 */
		/* reg: MULU4(reg,mr) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_mr_NT] + 13;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 44;
			_closure_reg(a, c + 0, p);
		}
		break;
	case 4577: /* EQF4 */
		/* stmt: EQF4(cmpf,freg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_cmpf_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_freg_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 92;
		}
		break;
	case 4581: /* EQI4 */
		/* stmt: EQI4(mem4,rc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_mem4_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 5;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 57;
		}
		/* stmt: EQI4(reg,mrc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_mrc_NT] + 4;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 67;
		}
		/* stmt: EQI4(burm33,con0) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm33_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_con0_NT] + 3;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 79;
		}
		/* stmt: EQI4(burm34,con0) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm34_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_con0_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 81;
		}
		/* stmt: EQI4(burm35,con0) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm35_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_con0_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 83;
		}
		/* stmt: EQI4(burm36,con0) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm36_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_con0_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 85;
		}
		break;
	case 4582: /* EQU4 */
		/* stmt: EQU4(reg,mrc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_mrc_NT] + 4;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 73;
		}
		break;
	case 4593: /* GEF4 */
		/* stmt: GEF4(cmpf,freg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_cmpf_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_freg_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 93;
		}
		break;
	case 4597: /* GEI4 */
		/* stmt: GEI4(mem4,rc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_mem4_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 5;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 58;
		}
		/* stmt: GEI4(reg,mrc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_mrc_NT] + 4;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 68;
		}
		break;
	case 4598: /* GEU4 */
		/* stmt: GEU4(mem4,rc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_mem4_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 5;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 63;
		}
		/* stmt: GEU4(reg,mrc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_mrc_NT] + 4;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 74;
		}
		break;
	case 4609: /* GTF4 */
		/* stmt: GTF4(cmpf,freg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_cmpf_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_freg_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 94;
		}
		break;
	case 4613: /* GTI4 */
		/* stmt: GTI4(mem4,rc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_mem4_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 5;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 59;
		}
		/* stmt: GTI4(reg,mrc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_mrc_NT] + 4;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 69;
		}
		break;
	case 4614: /* GTU4 */
		/* stmt: GTU4(mem4,rc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_mem4_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 5;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 64;
		}
		/* stmt: GTU4(reg,mrc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_mrc_NT] + 4;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 75;
		}
		break;
	case 4625: /* LEF4 */
		/* stmt: LEF4(cmpf,freg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_cmpf_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_freg_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 95;
		}
		break;
	case 4629: /* LEI4 */
		/* stmt: LEI4(mem4,rc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_mem4_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 5;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 60;
		}
		/* stmt: LEI4(reg,mrc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_mrc_NT] + 4;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 70;
		}
		break;
	case 4630: /* LEU4 */
		/* stmt: LEU4(mem4,rc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_mem4_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 5;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 65;
		}
		/* stmt: LEU4(reg,mrc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_mrc_NT] + 4;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 76;
		}
		break;
	case 4641: /* LTF4 */
		/* stmt: LTF4(cmpf,freg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_cmpf_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_freg_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 96;
		}
		break;
	case 4645: /* LTI4 */
		/* stmt: LTI4(mem4,rc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_mem4_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 5;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 61;
		}
		/* stmt: LTI4(reg,mrc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_mrc_NT] + 4;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 71;
		}
		break;
	case 4646: /* LTU4 */
		/* stmt: LTU4(mem4,rc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_mem4_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 5;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 66;
		}
		/* stmt: LTU4(reg,mrc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_mrc_NT] + 4;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 77;
		}
		break;
	case 4657: /* NEF4 */
		/* stmt: NEF4(cmpf,freg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_cmpf_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_freg_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 97;
		}
		break;
	case 4661: /* NEI4 */
		/* stmt: NEI4(mem4,rc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_mem4_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 5;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 62;
		}
		/* stmt: NEI4(reg,mrc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_mrc_NT] + 4;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 72;
		}
		/* stmt: NEI4(burm33,con0) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm33_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_con0_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 80;
		}
		/* stmt: NEI4(burm34,con0) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm34_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_con0_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 82;
		}
		/* stmt: NEI4(burm35,con0) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm35_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_con0_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 84;
		}
		break;
	case 4662: /* NEU4 */
		/* stmt: NEU4(reg,mrc) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_mrc_NT] + 4;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 78;
		}
		break;
	case 8209: /* CNSTF8 */
		break;
	case 8213: /* CNSTI8 */
		/* cnst: CNSTI8 */
		if (0 + 0 < p->cost[_cnst_NT]) {
			p->cost[_cnst_NT] = 0 + 0;
			p->rule._cnst = 8;
			_closure_cnst(a, 0 + 0, p);
		}
		break;
	case 8214: /* CNSTU8 */
		/* cnst: CNSTU8 */
		if (0 + 0 < p->cost[_cnst_NT]) {
			p->cost[_cnst_NT] = 0 + 0;
			p->rule._cnst = 9;
			_closure_cnst(a, 0 + 0, p);
		}
		break;
	case 8215: /* CNSTP8 */
		/* cnst: CNSTP8 */
		if (0 + 0 < p->cost[_cnst_NT]) {
			p->cost[_cnst_NT] = 0 + 0;
			p->rule._cnst = 10;
			_closure_cnst(a, 0 + 0, p);
		}
		break;
	case 8225: /* ARGF8 */
		/* stmt: ARGF8(freg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_freg_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 53;
		}
		break;
	case 8229: /* ARGI8 */
		break;
	case 8230: /* ARGU8 */
		break;
	case 8231: /* ARGP8 */
		break;
	case 8241: /* ASGNF8 */
		/* stmt: ASGNF8(burm0,reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm0_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 9;
		}
		/* stmt: ASGNF8(addr,freg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_freg_NT] + 7;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 50;
		}
		break;
	case 8245: /* ASGNI8 */
		/* stmt: ASGNI8(burm0,reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm0_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 10;
		}
		break;
	case 8246: /* ASGNU8 */
		/* stmt: ASGNU8(burm0,reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm0_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 12;
		}
		break;
	case 8247: /* ASGNP8 */
		/* stmt: ASGNP8(burm0,reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm0_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 11;
		}
		break;
	case 8257: /* INDIRF8 */
		/* freg: INDIRF8(burm0) */
		if (mayrecalc(a)) {
			struct _state *q = a->syms[RX]->u.t.cse->x.state;
			if (q->cost[_stmt_NT] == 0) {
				p->cost[_stmt_NT] = 0;
				p->rule._stmt = q->rule._stmt;
			}
			if (q->cost[_reg_NT] == 0) {
				p->cost[_reg_NT] = 0;
				p->rule._reg = q->rule._reg;
			}
			if (q->cost[_freg_NT] == 0) {
				p->cost[_freg_NT] = 0;
				p->rule._freg = q->rule._freg;
			}
			if (q->cost[_cnst_NT] == 0) {
				p->cost[_cnst_NT] = 0;
				p->rule._cnst = q->rule._cnst;
			}
			if (q->cost[_con_NT] == 0) {
				p->cost[_con_NT] = 0;
				p->rule._con = q->rule._con;
			}
			if (q->cost[_acon_NT] == 0) {
				p->cost[_acon_NT] = 0;
				p->rule._acon = q->rule._acon;
			}
			if (q->cost[_baseaddr_NT] == 0) {
				p->cost[_baseaddr_NT] = 0;
				p->rule._baseaddr = q->rule._baseaddr;
			}
			if (q->cost[_base_NT] == 0) {
				p->cost[_base_NT] = 0;
				p->rule._base = q->rule._base;
			}
			if (q->cost[_index_NT] == 0) {
				p->cost[_index_NT] = 0;
				p->rule._index = q->rule._index;
			}
			if (q->cost[_con1_NT] == 0) {
				p->cost[_con1_NT] = 0;
				p->rule._con1 = q->rule._con1;
			}
			if (q->cost[_con2_NT] == 0) {
				p->cost[_con2_NT] = 0;
				p->rule._con2 = q->rule._con2;
			}
			if (q->cost[_con3_NT] == 0) {
				p->cost[_con3_NT] = 0;
				p->rule._con3 = q->rule._con3;
			}
			if (q->cost[_con0_NT] == 0) {
				p->cost[_con0_NT] = 0;
				p->rule._con0 = q->rule._con0;
			}
			if (q->cost[_addr_NT] == 0) {
				p->cost[_addr_NT] = 0;
				p->rule._addr = q->rule._addr;
			}
			if (q->cost[_mem1_NT] == 0) {
				p->cost[_mem1_NT] = 0;
				p->rule._mem1 = q->rule._mem1;
			}
			if (q->cost[_mem2_NT] == 0) {
				p->cost[_mem2_NT] = 0;
				p->rule._mem2 = q->rule._mem2;
			}
			if (q->cost[_mem4_NT] == 0) {
				p->cost[_mem4_NT] = 0;
				p->rule._mem4 = q->rule._mem4;
			}
			if (q->cost[_rc_NT] == 0) {
				p->cost[_rc_NT] = 0;
				p->rule._rc = q->rule._rc;
			}
			if (q->cost[_mr_NT] == 0) {
				p->cost[_mr_NT] = 0;
				p->rule._mr = q->rule._mr;
			}
			if (q->cost[_mr1_NT] == 0) {
				p->cost[_mr1_NT] = 0;
				p->rule._mr1 = q->rule._mr1;
			}
			if (q->cost[_mr2_NT] == 0) {
				p->cost[_mr2_NT] = 0;
				p->rule._mr2 = q->rule._mr2;
			}
			if (q->cost[_mrc_NT] == 0) {
				p->cost[_mrc_NT] = 0;
				p->rule._mrc = q->rule._mrc;
			}
			if (q->cost[_rc5_NT] == 0) {
				p->cost[_rc5_NT] = 0;
				p->rule._rc5 = q->rule._rc5;
			}
			if (q->cost[_mrca_NT] == 0) {
				p->cost[_mrca_NT] = 0;
				p->rule._mrca = q->rule._mrca;
			}
			if (q->cost[_memf_NT] == 0) {
				p->cost[_memf_NT] = 0;
				p->rule._memf = q->rule._memf;
			}
			if (q->cost[_flt_NT] == 0) {
				p->cost[_flt_NT] = 0;
				p->rule._flt = q->rule._flt;
			}
			if (q->cost[_flt2_NT] == 0) {
				p->cost[_flt2_NT] = 0;
				p->rule._flt2 = q->rule._flt2;
			}
			if (q->cost[_addrj_NT] == 0) {
				p->cost[_addrj_NT] = 0;
				p->rule._addrj = q->rule._addrj;
			}
			if (q->cost[_cmpf_NT] == 0) {
				p->cost[_cmpf_NT] = 0;
				p->rule._cmpf = q->rule._cmpf;
			}
			if (q->cost[_burm0_NT] == 0) {
				p->cost[_burm0_NT] = 0;
				p->rule._burm0 = q->rule._burm0;
			}
			if (q->cost[_burm1_NT] == 0) {
				p->cost[_burm1_NT] = 0;
				p->rule._burm1 = q->rule._burm1;
			}
			if (q->cost[_burm2_NT] == 0) {
				p->cost[_burm2_NT] = 0;
				p->rule._burm2 = q->rule._burm2;
			}
			if (q->cost[_burm3_NT] == 0) {
				p->cost[_burm3_NT] = 0;
				p->rule._burm3 = q->rule._burm3;
			}
			if (q->cost[_burm4_NT] == 0) {
				p->cost[_burm4_NT] = 0;
				p->rule._burm4 = q->rule._burm4;
			}
			if (q->cost[_burm5_NT] == 0) {
				p->cost[_burm5_NT] = 0;
				p->rule._burm5 = q->rule._burm5;
			}
			if (q->cost[_burm6_NT] == 0) {
				p->cost[_burm6_NT] = 0;
				p->rule._burm6 = q->rule._burm6;
			}
			if (q->cost[_burm7_NT] == 0) {
				p->cost[_burm7_NT] = 0;
				p->rule._burm7 = q->rule._burm7;
			}
			if (q->cost[_burm8_NT] == 0) {
				p->cost[_burm8_NT] = 0;
				p->rule._burm8 = q->rule._burm8;
			}
			if (q->cost[_burm9_NT] == 0) {
				p->cost[_burm9_NT] = 0;
				p->rule._burm9 = q->rule._burm9;
			}
			if (q->cost[_burm10_NT] == 0) {
				p->cost[_burm10_NT] = 0;
				p->rule._burm10 = q->rule._burm10;
			}
			if (q->cost[_burm11_NT] == 0) {
				p->cost[_burm11_NT] = 0;
				p->rule._burm11 = q->rule._burm11;
			}
			if (q->cost[_burm12_NT] == 0) {
				p->cost[_burm12_NT] = 0;
				p->rule._burm12 = q->rule._burm12;
			}
			if (q->cost[_burm13_NT] == 0) {
				p->cost[_burm13_NT] = 0;
				p->rule._burm13 = q->rule._burm13;
			}
			if (q->cost[_burm14_NT] == 0) {
				p->cost[_burm14_NT] = 0;
				p->rule._burm14 = q->rule._burm14;
			}
			if (q->cost[_burm15_NT] == 0) {
				p->cost[_burm15_NT] = 0;
				p->rule._burm15 = q->rule._burm15;
			}
			if (q->cost[_burm16_NT] == 0) {
				p->cost[_burm16_NT] = 0;
				p->rule._burm16 = q->rule._burm16;
			}
			if (q->cost[_burm17_NT] == 0) {
				p->cost[_burm17_NT] = 0;
				p->rule._burm17 = q->rule._burm17;
			}
			if (q->cost[_burm18_NT] == 0) {
				p->cost[_burm18_NT] = 0;
				p->rule._burm18 = q->rule._burm18;
			}
			if (q->cost[_burm19_NT] == 0) {
				p->cost[_burm19_NT] = 0;
				p->rule._burm19 = q->rule._burm19;
			}
			if (q->cost[_burm20_NT] == 0) {
				p->cost[_burm20_NT] = 0;
				p->rule._burm20 = q->rule._burm20;
			}
			if (q->cost[_burm21_NT] == 0) {
				p->cost[_burm21_NT] = 0;
				p->rule._burm21 = q->rule._burm21;
			}
			if (q->cost[_burm22_NT] == 0) {
				p->cost[_burm22_NT] = 0;
				p->rule._burm22 = q->rule._burm22;
			}
			if (q->cost[_burm23_NT] == 0) {
				p->cost[_burm23_NT] = 0;
				p->rule._burm23 = q->rule._burm23;
			}
			if (q->cost[_burm24_NT] == 0) {
				p->cost[_burm24_NT] = 0;
				p->rule._burm24 = q->rule._burm24;
			}
			if (q->cost[_burm25_NT] == 0) {
				p->cost[_burm25_NT] = 0;
				p->rule._burm25 = q->rule._burm25;
			}
			if (q->cost[_burm26_NT] == 0) {
				p->cost[_burm26_NT] = 0;
				p->rule._burm26 = q->rule._burm26;
			}
			if (q->cost[_burm27_NT] == 0) {
				p->cost[_burm27_NT] = 0;
				p->rule._burm27 = q->rule._burm27;
			}
			if (q->cost[_burm28_NT] == 0) {
				p->cost[_burm28_NT] = 0;
				p->rule._burm28 = q->rule._burm28;
			}
			if (q->cost[_burm29_NT] == 0) {
				p->cost[_burm29_NT] = 0;
				p->rule._burm29 = q->rule._burm29;
			}
			if (q->cost[_burm30_NT] == 0) {
				p->cost[_burm30_NT] = 0;
				p->rule._burm30 = q->rule._burm30;
			}
			if (q->cost[_burm31_NT] == 0) {
				p->cost[_burm31_NT] = 0;
				p->rule._burm31 = q->rule._burm31;
			}
			if (q->cost[_burm32_NT] == 0) {
				p->cost[_burm32_NT] = 0;
				p->rule._burm32 = q->rule._burm32;
			}
			if (q->cost[_burm33_NT] == 0) {
				p->cost[_burm33_NT] = 0;
				p->rule._burm33 = q->rule._burm33;
			}
			if (q->cost[_burm34_NT] == 0) {
				p->cost[_burm34_NT] = 0;
				p->rule._burm34 = q->rule._burm34;
			}
			if (q->cost[_burm35_NT] == 0) {
				p->cost[_burm35_NT] = 0;
				p->rule._burm35 = q->rule._burm35;
			}
			if (q->cost[_burm36_NT] == 0) {
				p->cost[_burm36_NT] = 0;
				p->rule._burm36 = q->rule._burm36;
			}
			if (q->cost[_burm37_NT] == 0) {
				p->cost[_burm37_NT] = 0;
				p->rule._burm37 = q->rule._burm37;
			}
			if (q->cost[_burm38_NT] == 0) {
				p->cost[_burm38_NT] = 0;
				p->rule._burm38 = q->rule._burm38;
			}
			if (q->cost[_burm39_NT] == 0) {
				p->cost[_burm39_NT] = 0;
				p->rule._burm39 = q->rule._burm39;
			}
			if (q->cost[_burm40_NT] == 0) {
				p->cost[_burm40_NT] = 0;
				p->rule._burm40 = q->rule._burm40;
			}
			if (q->cost[_burm41_NT] == 0) {
				p->cost[_burm41_NT] = 0;
				p->rule._burm41 = q->rule._burm41;
			}
			if (q->cost[_burm42_NT] == 0) {
				p->cost[_burm42_NT] = 0;
				p->rule._burm42 = q->rule._burm42;
			}
		}
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm0_NT] + 0;
		if (c + 0 < p->cost[_freg_NT]) {
			p->cost[_freg_NT] = c + 0;
			p->rule._freg = 2;
			_closure_freg(a, c + 0, p);
		}
		/* memf: INDIRF8(addr) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + 0;
		if (c + 0 < p->cost[_memf_NT]) {
			p->cost[_memf_NT] = c + 0;
			p->rule._memf = 1;
			_closure_memf(a, c + 0, p);
		}
		/* cmpf: INDIRF8(addr) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + 0;
		if (c + 0 < p->cost[_cmpf_NT]) {
			p->cost[_cmpf_NT] = c + 0;
			p->rule._cmpf = 1;
		}
		/* burm30: INDIRF8(addr) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + 0;
		if (c + 0 < p->cost[_burm30_NT]) {
			p->cost[_burm30_NT] = c + 0;
			p->rule._burm30 = 1;
		}
		break;
	case 8261: /* INDIRI8 */
		/* reg: INDIRI8(burm0) */
		if (mayrecalc(a)) {
			struct _state *q = a->syms[RX]->u.t.cse->x.state;
			if (q->cost[_stmt_NT] == 0) {
				p->cost[_stmt_NT] = 0;
				p->rule._stmt = q->rule._stmt;
			}
			if (q->cost[_reg_NT] == 0) {
				p->cost[_reg_NT] = 0;
				p->rule._reg = q->rule._reg;
			}
			if (q->cost[_freg_NT] == 0) {
				p->cost[_freg_NT] = 0;
				p->rule._freg = q->rule._freg;
			}
			if (q->cost[_cnst_NT] == 0) {
				p->cost[_cnst_NT] = 0;
				p->rule._cnst = q->rule._cnst;
			}
			if (q->cost[_con_NT] == 0) {
				p->cost[_con_NT] = 0;
				p->rule._con = q->rule._con;
			}
			if (q->cost[_acon_NT] == 0) {
				p->cost[_acon_NT] = 0;
				p->rule._acon = q->rule._acon;
			}
			if (q->cost[_baseaddr_NT] == 0) {
				p->cost[_baseaddr_NT] = 0;
				p->rule._baseaddr = q->rule._baseaddr;
			}
			if (q->cost[_base_NT] == 0) {
				p->cost[_base_NT] = 0;
				p->rule._base = q->rule._base;
			}
			if (q->cost[_index_NT] == 0) {
				p->cost[_index_NT] = 0;
				p->rule._index = q->rule._index;
			}
			if (q->cost[_con1_NT] == 0) {
				p->cost[_con1_NT] = 0;
				p->rule._con1 = q->rule._con1;
			}
			if (q->cost[_con2_NT] == 0) {
				p->cost[_con2_NT] = 0;
				p->rule._con2 = q->rule._con2;
			}
			if (q->cost[_con3_NT] == 0) {
				p->cost[_con3_NT] = 0;
				p->rule._con3 = q->rule._con3;
			}
			if (q->cost[_con0_NT] == 0) {
				p->cost[_con0_NT] = 0;
				p->rule._con0 = q->rule._con0;
			}
			if (q->cost[_addr_NT] == 0) {
				p->cost[_addr_NT] = 0;
				p->rule._addr = q->rule._addr;
			}
			if (q->cost[_mem1_NT] == 0) {
				p->cost[_mem1_NT] = 0;
				p->rule._mem1 = q->rule._mem1;
			}
			if (q->cost[_mem2_NT] == 0) {
				p->cost[_mem2_NT] = 0;
				p->rule._mem2 = q->rule._mem2;
			}
			if (q->cost[_mem4_NT] == 0) {
				p->cost[_mem4_NT] = 0;
				p->rule._mem4 = q->rule._mem4;
			}
			if (q->cost[_rc_NT] == 0) {
				p->cost[_rc_NT] = 0;
				p->rule._rc = q->rule._rc;
			}
			if (q->cost[_mr_NT] == 0) {
				p->cost[_mr_NT] = 0;
				p->rule._mr = q->rule._mr;
			}
			if (q->cost[_mr1_NT] == 0) {
				p->cost[_mr1_NT] = 0;
				p->rule._mr1 = q->rule._mr1;
			}
			if (q->cost[_mr2_NT] == 0) {
				p->cost[_mr2_NT] = 0;
				p->rule._mr2 = q->rule._mr2;
			}
			if (q->cost[_mrc_NT] == 0) {
				p->cost[_mrc_NT] = 0;
				p->rule._mrc = q->rule._mrc;
			}
			if (q->cost[_rc5_NT] == 0) {
				p->cost[_rc5_NT] = 0;
				p->rule._rc5 = q->rule._rc5;
			}
			if (q->cost[_mrca_NT] == 0) {
				p->cost[_mrca_NT] = 0;
				p->rule._mrca = q->rule._mrca;
			}
			if (q->cost[_memf_NT] == 0) {
				p->cost[_memf_NT] = 0;
				p->rule._memf = q->rule._memf;
			}
			if (q->cost[_flt_NT] == 0) {
				p->cost[_flt_NT] = 0;
				p->rule._flt = q->rule._flt;
			}
			if (q->cost[_flt2_NT] == 0) {
				p->cost[_flt2_NT] = 0;
				p->rule._flt2 = q->rule._flt2;
			}
			if (q->cost[_addrj_NT] == 0) {
				p->cost[_addrj_NT] = 0;
				p->rule._addrj = q->rule._addrj;
			}
			if (q->cost[_cmpf_NT] == 0) {
				p->cost[_cmpf_NT] = 0;
				p->rule._cmpf = q->rule._cmpf;
			}
			if (q->cost[_burm0_NT] == 0) {
				p->cost[_burm0_NT] = 0;
				p->rule._burm0 = q->rule._burm0;
			}
			if (q->cost[_burm1_NT] == 0) {
				p->cost[_burm1_NT] = 0;
				p->rule._burm1 = q->rule._burm1;
			}
			if (q->cost[_burm2_NT] == 0) {
				p->cost[_burm2_NT] = 0;
				p->rule._burm2 = q->rule._burm2;
			}
			if (q->cost[_burm3_NT] == 0) {
				p->cost[_burm3_NT] = 0;
				p->rule._burm3 = q->rule._burm3;
			}
			if (q->cost[_burm4_NT] == 0) {
				p->cost[_burm4_NT] = 0;
				p->rule._burm4 = q->rule._burm4;
			}
			if (q->cost[_burm5_NT] == 0) {
				p->cost[_burm5_NT] = 0;
				p->rule._burm5 = q->rule._burm5;
			}
			if (q->cost[_burm6_NT] == 0) {
				p->cost[_burm6_NT] = 0;
				p->rule._burm6 = q->rule._burm6;
			}
			if (q->cost[_burm7_NT] == 0) {
				p->cost[_burm7_NT] = 0;
				p->rule._burm7 = q->rule._burm7;
			}
			if (q->cost[_burm8_NT] == 0) {
				p->cost[_burm8_NT] = 0;
				p->rule._burm8 = q->rule._burm8;
			}
			if (q->cost[_burm9_NT] == 0) {
				p->cost[_burm9_NT] = 0;
				p->rule._burm9 = q->rule._burm9;
			}
			if (q->cost[_burm10_NT] == 0) {
				p->cost[_burm10_NT] = 0;
				p->rule._burm10 = q->rule._burm10;
			}
			if (q->cost[_burm11_NT] == 0) {
				p->cost[_burm11_NT] = 0;
				p->rule._burm11 = q->rule._burm11;
			}
			if (q->cost[_burm12_NT] == 0) {
				p->cost[_burm12_NT] = 0;
				p->rule._burm12 = q->rule._burm12;
			}
			if (q->cost[_burm13_NT] == 0) {
				p->cost[_burm13_NT] = 0;
				p->rule._burm13 = q->rule._burm13;
			}
			if (q->cost[_burm14_NT] == 0) {
				p->cost[_burm14_NT] = 0;
				p->rule._burm14 = q->rule._burm14;
			}
			if (q->cost[_burm15_NT] == 0) {
				p->cost[_burm15_NT] = 0;
				p->rule._burm15 = q->rule._burm15;
			}
			if (q->cost[_burm16_NT] == 0) {
				p->cost[_burm16_NT] = 0;
				p->rule._burm16 = q->rule._burm16;
			}
			if (q->cost[_burm17_NT] == 0) {
				p->cost[_burm17_NT] = 0;
				p->rule._burm17 = q->rule._burm17;
			}
			if (q->cost[_burm18_NT] == 0) {
				p->cost[_burm18_NT] = 0;
				p->rule._burm18 = q->rule._burm18;
			}
			if (q->cost[_burm19_NT] == 0) {
				p->cost[_burm19_NT] = 0;
				p->rule._burm19 = q->rule._burm19;
			}
			if (q->cost[_burm20_NT] == 0) {
				p->cost[_burm20_NT] = 0;
				p->rule._burm20 = q->rule._burm20;
			}
			if (q->cost[_burm21_NT] == 0) {
				p->cost[_burm21_NT] = 0;
				p->rule._burm21 = q->rule._burm21;
			}
			if (q->cost[_burm22_NT] == 0) {
				p->cost[_burm22_NT] = 0;
				p->rule._burm22 = q->rule._burm22;
			}
			if (q->cost[_burm23_NT] == 0) {
				p->cost[_burm23_NT] = 0;
				p->rule._burm23 = q->rule._burm23;
			}
			if (q->cost[_burm24_NT] == 0) {
				p->cost[_burm24_NT] = 0;
				p->rule._burm24 = q->rule._burm24;
			}
			if (q->cost[_burm25_NT] == 0) {
				p->cost[_burm25_NT] = 0;
				p->rule._burm25 = q->rule._burm25;
			}
			if (q->cost[_burm26_NT] == 0) {
				p->cost[_burm26_NT] = 0;
				p->rule._burm26 = q->rule._burm26;
			}
			if (q->cost[_burm27_NT] == 0) {
				p->cost[_burm27_NT] = 0;
				p->rule._burm27 = q->rule._burm27;
			}
			if (q->cost[_burm28_NT] == 0) {
				p->cost[_burm28_NT] = 0;
				p->rule._burm28 = q->rule._burm28;
			}
			if (q->cost[_burm29_NT] == 0) {
				p->cost[_burm29_NT] = 0;
				p->rule._burm29 = q->rule._burm29;
			}
			if (q->cost[_burm30_NT] == 0) {
				p->cost[_burm30_NT] = 0;
				p->rule._burm30 = q->rule._burm30;
			}
			if (q->cost[_burm31_NT] == 0) {
				p->cost[_burm31_NT] = 0;
				p->rule._burm31 = q->rule._burm31;
			}
			if (q->cost[_burm32_NT] == 0) {
				p->cost[_burm32_NT] = 0;
				p->rule._burm32 = q->rule._burm32;
			}
			if (q->cost[_burm33_NT] == 0) {
				p->cost[_burm33_NT] = 0;
				p->rule._burm33 = q->rule._burm33;
			}
			if (q->cost[_burm34_NT] == 0) {
				p->cost[_burm34_NT] = 0;
				p->rule._burm34 = q->rule._burm34;
			}
			if (q->cost[_burm35_NT] == 0) {
				p->cost[_burm35_NT] = 0;
				p->rule._burm35 = q->rule._burm35;
			}
			if (q->cost[_burm36_NT] == 0) {
				p->cost[_burm36_NT] = 0;
				p->rule._burm36 = q->rule._burm36;
			}
			if (q->cost[_burm37_NT] == 0) {
				p->cost[_burm37_NT] = 0;
				p->rule._burm37 = q->rule._burm37;
			}
			if (q->cost[_burm38_NT] == 0) {
				p->cost[_burm38_NT] = 0;
				p->rule._burm38 = q->rule._burm38;
			}
			if (q->cost[_burm39_NT] == 0) {
				p->cost[_burm39_NT] = 0;
				p->rule._burm39 = q->rule._burm39;
			}
			if (q->cost[_burm40_NT] == 0) {
				p->cost[_burm40_NT] = 0;
				p->rule._burm40 = q->rule._burm40;
			}
			if (q->cost[_burm41_NT] == 0) {
				p->cost[_burm41_NT] = 0;
				p->rule._burm41 = q->rule._burm41;
			}
			if (q->cost[_burm42_NT] == 0) {
				p->cost[_burm42_NT] = 0;
				p->rule._burm42 = q->rule._burm42;
			}
		}
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm0_NT] + 0;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 8;
			_closure_reg(a, c + 0, p);
		}
		break;
	case 8262: /* INDIRU8 */
		/* reg: INDIRU8(burm0) */
		if (mayrecalc(a)) {
			struct _state *q = a->syms[RX]->u.t.cse->x.state;
			if (q->cost[_stmt_NT] == 0) {
				p->cost[_stmt_NT] = 0;
				p->rule._stmt = q->rule._stmt;
			}
			if (q->cost[_reg_NT] == 0) {
				p->cost[_reg_NT] = 0;
				p->rule._reg = q->rule._reg;
			}
			if (q->cost[_freg_NT] == 0) {
				p->cost[_freg_NT] = 0;
				p->rule._freg = q->rule._freg;
			}
			if (q->cost[_cnst_NT] == 0) {
				p->cost[_cnst_NT] = 0;
				p->rule._cnst = q->rule._cnst;
			}
			if (q->cost[_con_NT] == 0) {
				p->cost[_con_NT] = 0;
				p->rule._con = q->rule._con;
			}
			if (q->cost[_acon_NT] == 0) {
				p->cost[_acon_NT] = 0;
				p->rule._acon = q->rule._acon;
			}
			if (q->cost[_baseaddr_NT] == 0) {
				p->cost[_baseaddr_NT] = 0;
				p->rule._baseaddr = q->rule._baseaddr;
			}
			if (q->cost[_base_NT] == 0) {
				p->cost[_base_NT] = 0;
				p->rule._base = q->rule._base;
			}
			if (q->cost[_index_NT] == 0) {
				p->cost[_index_NT] = 0;
				p->rule._index = q->rule._index;
			}
			if (q->cost[_con1_NT] == 0) {
				p->cost[_con1_NT] = 0;
				p->rule._con1 = q->rule._con1;
			}
			if (q->cost[_con2_NT] == 0) {
				p->cost[_con2_NT] = 0;
				p->rule._con2 = q->rule._con2;
			}
			if (q->cost[_con3_NT] == 0) {
				p->cost[_con3_NT] = 0;
				p->rule._con3 = q->rule._con3;
			}
			if (q->cost[_con0_NT] == 0) {
				p->cost[_con0_NT] = 0;
				p->rule._con0 = q->rule._con0;
			}
			if (q->cost[_addr_NT] == 0) {
				p->cost[_addr_NT] = 0;
				p->rule._addr = q->rule._addr;
			}
			if (q->cost[_mem1_NT] == 0) {
				p->cost[_mem1_NT] = 0;
				p->rule._mem1 = q->rule._mem1;
			}
			if (q->cost[_mem2_NT] == 0) {
				p->cost[_mem2_NT] = 0;
				p->rule._mem2 = q->rule._mem2;
			}
			if (q->cost[_mem4_NT] == 0) {
				p->cost[_mem4_NT] = 0;
				p->rule._mem4 = q->rule._mem4;
			}
			if (q->cost[_rc_NT] == 0) {
				p->cost[_rc_NT] = 0;
				p->rule._rc = q->rule._rc;
			}
			if (q->cost[_mr_NT] == 0) {
				p->cost[_mr_NT] = 0;
				p->rule._mr = q->rule._mr;
			}
			if (q->cost[_mr1_NT] == 0) {
				p->cost[_mr1_NT] = 0;
				p->rule._mr1 = q->rule._mr1;
			}
			if (q->cost[_mr2_NT] == 0) {
				p->cost[_mr2_NT] = 0;
				p->rule._mr2 = q->rule._mr2;
			}
			if (q->cost[_mrc_NT] == 0) {
				p->cost[_mrc_NT] = 0;
				p->rule._mrc = q->rule._mrc;
			}
			if (q->cost[_rc5_NT] == 0) {
				p->cost[_rc5_NT] = 0;
				p->rule._rc5 = q->rule._rc5;
			}
			if (q->cost[_mrca_NT] == 0) {
				p->cost[_mrca_NT] = 0;
				p->rule._mrca = q->rule._mrca;
			}
			if (q->cost[_memf_NT] == 0) {
				p->cost[_memf_NT] = 0;
				p->rule._memf = q->rule._memf;
			}
			if (q->cost[_flt_NT] == 0) {
				p->cost[_flt_NT] = 0;
				p->rule._flt = q->rule._flt;
			}
			if (q->cost[_flt2_NT] == 0) {
				p->cost[_flt2_NT] = 0;
				p->rule._flt2 = q->rule._flt2;
			}
			if (q->cost[_addrj_NT] == 0) {
				p->cost[_addrj_NT] = 0;
				p->rule._addrj = q->rule._addrj;
			}
			if (q->cost[_cmpf_NT] == 0) {
				p->cost[_cmpf_NT] = 0;
				p->rule._cmpf = q->rule._cmpf;
			}
			if (q->cost[_burm0_NT] == 0) {
				p->cost[_burm0_NT] = 0;
				p->rule._burm0 = q->rule._burm0;
			}
			if (q->cost[_burm1_NT] == 0) {
				p->cost[_burm1_NT] = 0;
				p->rule._burm1 = q->rule._burm1;
			}
			if (q->cost[_burm2_NT] == 0) {
				p->cost[_burm2_NT] = 0;
				p->rule._burm2 = q->rule._burm2;
			}
			if (q->cost[_burm3_NT] == 0) {
				p->cost[_burm3_NT] = 0;
				p->rule._burm3 = q->rule._burm3;
			}
			if (q->cost[_burm4_NT] == 0) {
				p->cost[_burm4_NT] = 0;
				p->rule._burm4 = q->rule._burm4;
			}
			if (q->cost[_burm5_NT] == 0) {
				p->cost[_burm5_NT] = 0;
				p->rule._burm5 = q->rule._burm5;
			}
			if (q->cost[_burm6_NT] == 0) {
				p->cost[_burm6_NT] = 0;
				p->rule._burm6 = q->rule._burm6;
			}
			if (q->cost[_burm7_NT] == 0) {
				p->cost[_burm7_NT] = 0;
				p->rule._burm7 = q->rule._burm7;
			}
			if (q->cost[_burm8_NT] == 0) {
				p->cost[_burm8_NT] = 0;
				p->rule._burm8 = q->rule._burm8;
			}
			if (q->cost[_burm9_NT] == 0) {
				p->cost[_burm9_NT] = 0;
				p->rule._burm9 = q->rule._burm9;
			}
			if (q->cost[_burm10_NT] == 0) {
				p->cost[_burm10_NT] = 0;
				p->rule._burm10 = q->rule._burm10;
			}
			if (q->cost[_burm11_NT] == 0) {
				p->cost[_burm11_NT] = 0;
				p->rule._burm11 = q->rule._burm11;
			}
			if (q->cost[_burm12_NT] == 0) {
				p->cost[_burm12_NT] = 0;
				p->rule._burm12 = q->rule._burm12;
			}
			if (q->cost[_burm13_NT] == 0) {
				p->cost[_burm13_NT] = 0;
				p->rule._burm13 = q->rule._burm13;
			}
			if (q->cost[_burm14_NT] == 0) {
				p->cost[_burm14_NT] = 0;
				p->rule._burm14 = q->rule._burm14;
			}
			if (q->cost[_burm15_NT] == 0) {
				p->cost[_burm15_NT] = 0;
				p->rule._burm15 = q->rule._burm15;
			}
			if (q->cost[_burm16_NT] == 0) {
				p->cost[_burm16_NT] = 0;
				p->rule._burm16 = q->rule._burm16;
			}
			if (q->cost[_burm17_NT] == 0) {
				p->cost[_burm17_NT] = 0;
				p->rule._burm17 = q->rule._burm17;
			}
			if (q->cost[_burm18_NT] == 0) {
				p->cost[_burm18_NT] = 0;
				p->rule._burm18 = q->rule._burm18;
			}
			if (q->cost[_burm19_NT] == 0) {
				p->cost[_burm19_NT] = 0;
				p->rule._burm19 = q->rule._burm19;
			}
			if (q->cost[_burm20_NT] == 0) {
				p->cost[_burm20_NT] = 0;
				p->rule._burm20 = q->rule._burm20;
			}
			if (q->cost[_burm21_NT] == 0) {
				p->cost[_burm21_NT] = 0;
				p->rule._burm21 = q->rule._burm21;
			}
			if (q->cost[_burm22_NT] == 0) {
				p->cost[_burm22_NT] = 0;
				p->rule._burm22 = q->rule._burm22;
			}
			if (q->cost[_burm23_NT] == 0) {
				p->cost[_burm23_NT] = 0;
				p->rule._burm23 = q->rule._burm23;
			}
			if (q->cost[_burm24_NT] == 0) {
				p->cost[_burm24_NT] = 0;
				p->rule._burm24 = q->rule._burm24;
			}
			if (q->cost[_burm25_NT] == 0) {
				p->cost[_burm25_NT] = 0;
				p->rule._burm25 = q->rule._burm25;
			}
			if (q->cost[_burm26_NT] == 0) {
				p->cost[_burm26_NT] = 0;
				p->rule._burm26 = q->rule._burm26;
			}
			if (q->cost[_burm27_NT] == 0) {
				p->cost[_burm27_NT] = 0;
				p->rule._burm27 = q->rule._burm27;
			}
			if (q->cost[_burm28_NT] == 0) {
				p->cost[_burm28_NT] = 0;
				p->rule._burm28 = q->rule._burm28;
			}
			if (q->cost[_burm29_NT] == 0) {
				p->cost[_burm29_NT] = 0;
				p->rule._burm29 = q->rule._burm29;
			}
			if (q->cost[_burm30_NT] == 0) {
				p->cost[_burm30_NT] = 0;
				p->rule._burm30 = q->rule._burm30;
			}
			if (q->cost[_burm31_NT] == 0) {
				p->cost[_burm31_NT] = 0;
				p->rule._burm31 = q->rule._burm31;
			}
			if (q->cost[_burm32_NT] == 0) {
				p->cost[_burm32_NT] = 0;
				p->rule._burm32 = q->rule._burm32;
			}
			if (q->cost[_burm33_NT] == 0) {
				p->cost[_burm33_NT] = 0;
				p->rule._burm33 = q->rule._burm33;
			}
			if (q->cost[_burm34_NT] == 0) {
				p->cost[_burm34_NT] = 0;
				p->rule._burm34 = q->rule._burm34;
			}
			if (q->cost[_burm35_NT] == 0) {
				p->cost[_burm35_NT] = 0;
				p->rule._burm35 = q->rule._burm35;
			}
			if (q->cost[_burm36_NT] == 0) {
				p->cost[_burm36_NT] = 0;
				p->rule._burm36 = q->rule._burm36;
			}
			if (q->cost[_burm37_NT] == 0) {
				p->cost[_burm37_NT] = 0;
				p->rule._burm37 = q->rule._burm37;
			}
			if (q->cost[_burm38_NT] == 0) {
				p->cost[_burm38_NT] = 0;
				p->rule._burm38 = q->rule._burm38;
			}
			if (q->cost[_burm39_NT] == 0) {
				p->cost[_burm39_NT] = 0;
				p->rule._burm39 = q->rule._burm39;
			}
			if (q->cost[_burm40_NT] == 0) {
				p->cost[_burm40_NT] = 0;
				p->rule._burm40 = q->rule._burm40;
			}
			if (q->cost[_burm41_NT] == 0) {
				p->cost[_burm41_NT] = 0;
				p->rule._burm41 = q->rule._burm41;
			}
			if (q->cost[_burm42_NT] == 0) {
				p->cost[_burm42_NT] = 0;
				p->rule._burm42 = q->rule._burm42;
			}
		}
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm0_NT] + 0;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 10;
			_closure_reg(a, c + 0, p);
		}
		break;
	case 8263: /* INDIRP8 */
		/* reg: INDIRP8(burm0) */
		if (mayrecalc(a)) {
			struct _state *q = a->syms[RX]->u.t.cse->x.state;
			if (q->cost[_stmt_NT] == 0) {
				p->cost[_stmt_NT] = 0;
				p->rule._stmt = q->rule._stmt;
			}
			if (q->cost[_reg_NT] == 0) {
				p->cost[_reg_NT] = 0;
				p->rule._reg = q->rule._reg;
			}
			if (q->cost[_freg_NT] == 0) {
				p->cost[_freg_NT] = 0;
				p->rule._freg = q->rule._freg;
			}
			if (q->cost[_cnst_NT] == 0) {
				p->cost[_cnst_NT] = 0;
				p->rule._cnst = q->rule._cnst;
			}
			if (q->cost[_con_NT] == 0) {
				p->cost[_con_NT] = 0;
				p->rule._con = q->rule._con;
			}
			if (q->cost[_acon_NT] == 0) {
				p->cost[_acon_NT] = 0;
				p->rule._acon = q->rule._acon;
			}
			if (q->cost[_baseaddr_NT] == 0) {
				p->cost[_baseaddr_NT] = 0;
				p->rule._baseaddr = q->rule._baseaddr;
			}
			if (q->cost[_base_NT] == 0) {
				p->cost[_base_NT] = 0;
				p->rule._base = q->rule._base;
			}
			if (q->cost[_index_NT] == 0) {
				p->cost[_index_NT] = 0;
				p->rule._index = q->rule._index;
			}
			if (q->cost[_con1_NT] == 0) {
				p->cost[_con1_NT] = 0;
				p->rule._con1 = q->rule._con1;
			}
			if (q->cost[_con2_NT] == 0) {
				p->cost[_con2_NT] = 0;
				p->rule._con2 = q->rule._con2;
			}
			if (q->cost[_con3_NT] == 0) {
				p->cost[_con3_NT] = 0;
				p->rule._con3 = q->rule._con3;
			}
			if (q->cost[_con0_NT] == 0) {
				p->cost[_con0_NT] = 0;
				p->rule._con0 = q->rule._con0;
			}
			if (q->cost[_addr_NT] == 0) {
				p->cost[_addr_NT] = 0;
				p->rule._addr = q->rule._addr;
			}
			if (q->cost[_mem1_NT] == 0) {
				p->cost[_mem1_NT] = 0;
				p->rule._mem1 = q->rule._mem1;
			}
			if (q->cost[_mem2_NT] == 0) {
				p->cost[_mem2_NT] = 0;
				p->rule._mem2 = q->rule._mem2;
			}
			if (q->cost[_mem4_NT] == 0) {
				p->cost[_mem4_NT] = 0;
				p->rule._mem4 = q->rule._mem4;
			}
			if (q->cost[_rc_NT] == 0) {
				p->cost[_rc_NT] = 0;
				p->rule._rc = q->rule._rc;
			}
			if (q->cost[_mr_NT] == 0) {
				p->cost[_mr_NT] = 0;
				p->rule._mr = q->rule._mr;
			}
			if (q->cost[_mr1_NT] == 0) {
				p->cost[_mr1_NT] = 0;
				p->rule._mr1 = q->rule._mr1;
			}
			if (q->cost[_mr2_NT] == 0) {
				p->cost[_mr2_NT] = 0;
				p->rule._mr2 = q->rule._mr2;
			}
			if (q->cost[_mrc_NT] == 0) {
				p->cost[_mrc_NT] = 0;
				p->rule._mrc = q->rule._mrc;
			}
			if (q->cost[_rc5_NT] == 0) {
				p->cost[_rc5_NT] = 0;
				p->rule._rc5 = q->rule._rc5;
			}
			if (q->cost[_mrca_NT] == 0) {
				p->cost[_mrca_NT] = 0;
				p->rule._mrca = q->rule._mrca;
			}
			if (q->cost[_memf_NT] == 0) {
				p->cost[_memf_NT] = 0;
				p->rule._memf = q->rule._memf;
			}
			if (q->cost[_flt_NT] == 0) {
				p->cost[_flt_NT] = 0;
				p->rule._flt = q->rule._flt;
			}
			if (q->cost[_flt2_NT] == 0) {
				p->cost[_flt2_NT] = 0;
				p->rule._flt2 = q->rule._flt2;
			}
			if (q->cost[_addrj_NT] == 0) {
				p->cost[_addrj_NT] = 0;
				p->rule._addrj = q->rule._addrj;
			}
			if (q->cost[_cmpf_NT] == 0) {
				p->cost[_cmpf_NT] = 0;
				p->rule._cmpf = q->rule._cmpf;
			}
			if (q->cost[_burm0_NT] == 0) {
				p->cost[_burm0_NT] = 0;
				p->rule._burm0 = q->rule._burm0;
			}
			if (q->cost[_burm1_NT] == 0) {
				p->cost[_burm1_NT] = 0;
				p->rule._burm1 = q->rule._burm1;
			}
			if (q->cost[_burm2_NT] == 0) {
				p->cost[_burm2_NT] = 0;
				p->rule._burm2 = q->rule._burm2;
			}
			if (q->cost[_burm3_NT] == 0) {
				p->cost[_burm3_NT] = 0;
				p->rule._burm3 = q->rule._burm3;
			}
			if (q->cost[_burm4_NT] == 0) {
				p->cost[_burm4_NT] = 0;
				p->rule._burm4 = q->rule._burm4;
			}
			if (q->cost[_burm5_NT] == 0) {
				p->cost[_burm5_NT] = 0;
				p->rule._burm5 = q->rule._burm5;
			}
			if (q->cost[_burm6_NT] == 0) {
				p->cost[_burm6_NT] = 0;
				p->rule._burm6 = q->rule._burm6;
			}
			if (q->cost[_burm7_NT] == 0) {
				p->cost[_burm7_NT] = 0;
				p->rule._burm7 = q->rule._burm7;
			}
			if (q->cost[_burm8_NT] == 0) {
				p->cost[_burm8_NT] = 0;
				p->rule._burm8 = q->rule._burm8;
			}
			if (q->cost[_burm9_NT] == 0) {
				p->cost[_burm9_NT] = 0;
				p->rule._burm9 = q->rule._burm9;
			}
			if (q->cost[_burm10_NT] == 0) {
				p->cost[_burm10_NT] = 0;
				p->rule._burm10 = q->rule._burm10;
			}
			if (q->cost[_burm11_NT] == 0) {
				p->cost[_burm11_NT] = 0;
				p->rule._burm11 = q->rule._burm11;
			}
			if (q->cost[_burm12_NT] == 0) {
				p->cost[_burm12_NT] = 0;
				p->rule._burm12 = q->rule._burm12;
			}
			if (q->cost[_burm13_NT] == 0) {
				p->cost[_burm13_NT] = 0;
				p->rule._burm13 = q->rule._burm13;
			}
			if (q->cost[_burm14_NT] == 0) {
				p->cost[_burm14_NT] = 0;
				p->rule._burm14 = q->rule._burm14;
			}
			if (q->cost[_burm15_NT] == 0) {
				p->cost[_burm15_NT] = 0;
				p->rule._burm15 = q->rule._burm15;
			}
			if (q->cost[_burm16_NT] == 0) {
				p->cost[_burm16_NT] = 0;
				p->rule._burm16 = q->rule._burm16;
			}
			if (q->cost[_burm17_NT] == 0) {
				p->cost[_burm17_NT] = 0;
				p->rule._burm17 = q->rule._burm17;
			}
			if (q->cost[_burm18_NT] == 0) {
				p->cost[_burm18_NT] = 0;
				p->rule._burm18 = q->rule._burm18;
			}
			if (q->cost[_burm19_NT] == 0) {
				p->cost[_burm19_NT] = 0;
				p->rule._burm19 = q->rule._burm19;
			}
			if (q->cost[_burm20_NT] == 0) {
				p->cost[_burm20_NT] = 0;
				p->rule._burm20 = q->rule._burm20;
			}
			if (q->cost[_burm21_NT] == 0) {
				p->cost[_burm21_NT] = 0;
				p->rule._burm21 = q->rule._burm21;
			}
			if (q->cost[_burm22_NT] == 0) {
				p->cost[_burm22_NT] = 0;
				p->rule._burm22 = q->rule._burm22;
			}
			if (q->cost[_burm23_NT] == 0) {
				p->cost[_burm23_NT] = 0;
				p->rule._burm23 = q->rule._burm23;
			}
			if (q->cost[_burm24_NT] == 0) {
				p->cost[_burm24_NT] = 0;
				p->rule._burm24 = q->rule._burm24;
			}
			if (q->cost[_burm25_NT] == 0) {
				p->cost[_burm25_NT] = 0;
				p->rule._burm25 = q->rule._burm25;
			}
			if (q->cost[_burm26_NT] == 0) {
				p->cost[_burm26_NT] = 0;
				p->rule._burm26 = q->rule._burm26;
			}
			if (q->cost[_burm27_NT] == 0) {
				p->cost[_burm27_NT] = 0;
				p->rule._burm27 = q->rule._burm27;
			}
			if (q->cost[_burm28_NT] == 0) {
				p->cost[_burm28_NT] = 0;
				p->rule._burm28 = q->rule._burm28;
			}
			if (q->cost[_burm29_NT] == 0) {
				p->cost[_burm29_NT] = 0;
				p->rule._burm29 = q->rule._burm29;
			}
			if (q->cost[_burm30_NT] == 0) {
				p->cost[_burm30_NT] = 0;
				p->rule._burm30 = q->rule._burm30;
			}
			if (q->cost[_burm31_NT] == 0) {
				p->cost[_burm31_NT] = 0;
				p->rule._burm31 = q->rule._burm31;
			}
			if (q->cost[_burm32_NT] == 0) {
				p->cost[_burm32_NT] = 0;
				p->rule._burm32 = q->rule._burm32;
			}
			if (q->cost[_burm33_NT] == 0) {
				p->cost[_burm33_NT] = 0;
				p->rule._burm33 = q->rule._burm33;
			}
			if (q->cost[_burm34_NT] == 0) {
				p->cost[_burm34_NT] = 0;
				p->rule._burm34 = q->rule._burm34;
			}
			if (q->cost[_burm35_NT] == 0) {
				p->cost[_burm35_NT] = 0;
				p->rule._burm35 = q->rule._burm35;
			}
			if (q->cost[_burm36_NT] == 0) {
				p->cost[_burm36_NT] = 0;
				p->rule._burm36 = q->rule._burm36;
			}
			if (q->cost[_burm37_NT] == 0) {
				p->cost[_burm37_NT] = 0;
				p->rule._burm37 = q->rule._burm37;
			}
			if (q->cost[_burm38_NT] == 0) {
				p->cost[_burm38_NT] = 0;
				p->rule._burm38 = q->rule._burm38;
			}
			if (q->cost[_burm39_NT] == 0) {
				p->cost[_burm39_NT] = 0;
				p->rule._burm39 = q->rule._burm39;
			}
			if (q->cost[_burm40_NT] == 0) {
				p->cost[_burm40_NT] = 0;
				p->rule._burm40 = q->rule._burm40;
			}
			if (q->cost[_burm41_NT] == 0) {
				p->cost[_burm41_NT] = 0;
				p->rule._burm41 = q->rule._burm41;
			}
			if (q->cost[_burm42_NT] == 0) {
				p->cost[_burm42_NT] = 0;
				p->rule._burm42 = q->rule._burm42;
			}
		}
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm0_NT] + 0;
		if (c + 0 < p->cost[_reg_NT]) {
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 9;
			_closure_reg(a, c + 0, p);
		}
		break;
	case 8305: /* CVFF8 */
		/* memf: CVFF8(burm29) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm29_NT] + 0;
		if (c + 0 < p->cost[_memf_NT]) {
			p->cost[_memf_NT] = c + 0;
			p->rule._memf = 3;
			_closure_memf(a, c + 0, p);
		}
		/* freg: CVFF8(freg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_freg_NT] + 0;
		if (c + 0 < p->cost[_freg_NT]) {
			p->cost[_freg_NT] = c + 0;
			p->rule._freg = 14;
			_closure_freg(a, c + 0, p);
		}
		/* cmpf: CVFF8(burm29) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm29_NT] + 0;
		if (c + 0 < p->cost[_cmpf_NT]) {
			p->cost[_cmpf_NT] = c + 0;
			p->rule._cmpf = 3;
		}
		/* burm39: CVFF8(burm29) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm29_NT] + 0;
		if (c + 0 < p->cost[_burm39_NT]) {
			p->cost[_burm39_NT] = c + 0;
			p->rule._burm39 = 1;
		}
		break;
	case 8309: /* CVFI8 */
		break;
	case 8321: /* CVIF8 */
		/* freg: CVIF8(burm32) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm32_NT] + 10;
		if (c + 0 < p->cost[_freg_NT]) {
			p->cost[_freg_NT] = c + 0;
			p->rule._freg = 16;
			_closure_freg(a, c + 0, p);
		}
		/* freg: CVIF8(reg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 12;
		if (c + 0 < p->cost[_freg_NT]) {
			p->cost[_freg_NT] = c + 0;
			p->rule._freg = 17;
			_closure_freg(a, c + 0, p);
		}
		/* burm37: CVIF8(burm32) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm32_NT] + 0;
		if (c + 0 < p->cost[_burm37_NT]) {
			p->cost[_burm37_NT] = c + 0;
			p->rule._burm37 = 1;
		}
		/* burm38: CVIF8(burm40) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm40_NT] + 0;
		if (c + 0 < p->cost[_burm38_NT]) {
			p->cost[_burm38_NT] = c + 0;
			p->rule._burm38 = 1;
		}
		break;
	case 8325: /* CVII8 */
		break;
	case 8326: /* CVIU8 */
		break;
	case 8342: /* CVPU8 */
		break;
	case 8343: /* CVPP8 */
		break;
	case 8373: /* CVUI8 */
		break;
	case 8374: /* CVUU8 */
		break;
	case 8375: /* CVUP8 */
		break;
	case 8385: /* NEGF8 */
		/* freg: NEGF8(freg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_freg_NT] + 0;
		if (c + 0 < p->cost[_freg_NT]) {
			p->cost[_freg_NT] = c + 0;
			p->rule._freg = 4;
			_closure_freg(a, c + 0, p);
		}
		break;
	case 8389: /* NEGI8 */
		break;
	case 8401: /* CALLF8 */
		/* freg: CALLF8(addrj) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addrj_NT] + (hasargs(a));
		if (c + 0 < p->cost[_freg_NT]) {
			p->cost[_freg_NT] = c + 0;
			p->rule._freg = 39;
			_closure_freg(a, c + 0, p);
		}
		/* freg: CALLF8(addrj) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addrj_NT] + 1;
		if (c + 0 < p->cost[_freg_NT]) {
			p->cost[_freg_NT] = c + 0;
			p->rule._freg = 40;
			_closure_freg(a, c + 0, p);
		}
		/* stmt: CALLF8(addrj) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addrj_NT] + (hasargs(a));
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 102;
		}
		/* stmt: CALLF8(addrj) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_addrj_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 103;
		}
		break;
	case 8405: /* CALLI8 */
		break;
	case 8406: /* CALLU8 */
		break;
	case 8407: /* CALLP8 */
		break;
	case 8417: /* LOADF8 */
		/* freg: LOADF8(memf) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_memf_NT] + 0;
		if (c + 0 < p->cost[_freg_NT]) {
			p->cost[_freg_NT] = c + 0;
			p->rule._freg = 36;
			_closure_freg(a, c + 0, p);
		}
		break;
	case 8421: /* LOADI8 */
		break;
	case 8422: /* LOADU8 */
		break;
	case 8423: /* LOADP8 */
		break;
	case 8433: /* RETF8 */
		/* stmt: RETF8(freg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_freg_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 108;
		}
		break;
	case 8437: /* RETI8 */
		break;
	case 8438: /* RETU8 */
		break;
	case 8439: /* RETP8 */
		break;
	case 8455: /* ADDRGP8 */
		/* acon: ADDRGP8 */
		if (0 + 0 < p->cost[_acon_NT]) {
			p->cost[_acon_NT] = 0 + 0;
			p->rule._acon = 2;
		}
		/* mrca: ADDRGP8 */
		if (0 + 0 < p->cost[_mrca_NT]) {
			p->cost[_mrca_NT] = 0 + 0;
			p->rule._mrca = 4;
		}
		break;
	case 8471: /* ADDRFP8 */
		break;
	case 8487: /* ADDRLP8 */
		break;
	case 8497: /* ADDF8 */
		/* freg: ADDF8(freg,flt) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_freg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_flt_NT] + 0;
		if (c + 0 < p->cost[_freg_NT]) {
			p->cost[_freg_NT] = c + 0;
			p->rule._freg = 7;
			_closure_freg(a, c + 0, p);
		}
		/* freg: ADDF8(freg,burm37) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_freg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_burm37_NT] + 0;
		if (c + 0 < p->cost[_freg_NT]) {
			p->cost[_freg_NT] = c + 0;
			p->rule._freg = 30;
			_closure_freg(a, c + 0, p);
		}
		/* freg: ADDF8(freg,burm38) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_freg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_burm38_NT] + 0;
		if (c + 0 < p->cost[_freg_NT]) {
			p->cost[_freg_NT] = c + 0;
			p->rule._freg = 31;
			_closure_freg(a, c + 0, p);
		}
		/* freg: ADDF8(freg,burm39) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_freg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_burm39_NT] + 0;
		if (c + 0 < p->cost[_freg_NT]) {
			p->cost[_freg_NT] = c + 0;
			p->rule._freg = 32;
			_closure_freg(a, c + 0, p);
		}
		break;
	case 8501: /* ADDI8 */
		break;
	case 8502: /* ADDU8 */
		break;
	case 8503: /* ADDP8 */
		break;
	case 8513: /* SUBF8 */
		/* freg: SUBF8(freg,flt2) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_freg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_flt2_NT] + 0;
		if (c + 0 < p->cost[_freg_NT]) {
			p->cost[_freg_NT] = c + 0;
			p->rule._freg = 13;
			_closure_freg(a, c + 0, p);
		}
		/* freg: SUBF8(freg,burm37) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_freg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_burm37_NT] + 0;
		if (c + 0 < p->cost[_freg_NT]) {
			p->cost[_freg_NT] = c + 0;
			p->rule._freg = 26;
			_closure_freg(a, c + 0, p);
		}
		/* freg: SUBF8(burm37,freg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm37_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_freg_NT] + 0;
		if (c + 0 < p->cost[_freg_NT]) {
			p->cost[_freg_NT] = c + 0;
			p->rule._freg = 27;
			_closure_freg(a, c + 0, p);
		}
		/* freg: SUBF8(freg,burm38) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_freg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_burm38_NT] + 0;
		if (c + 0 < p->cost[_freg_NT]) {
			p->cost[_freg_NT] = c + 0;
			p->rule._freg = 28;
			_closure_freg(a, c + 0, p);
		}
		/* freg: SUBF8(burm38,freg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm38_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_freg_NT] + 0;
		if (c + 0 < p->cost[_freg_NT]) {
			p->cost[_freg_NT] = c + 0;
			p->rule._freg = 29;
			_closure_freg(a, c + 0, p);
		}
		/* freg: SUBF8(freg,burm39) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_freg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_burm39_NT] + 0;
		if (c + 0 < p->cost[_freg_NT]) {
			p->cost[_freg_NT] = c + 0;
			p->rule._freg = 33;
			_closure_freg(a, c + 0, p);
		}
		break;
	case 8517: /* SUBI8 */
		break;
	case 8518: /* SUBU8 */
		break;
	case 8519: /* SUBP8 */
		break;
	case 8533: /* LSHI8 */
		break;
	case 8534: /* LSHU8 */
		break;
	case 8549: /* MODI8 */
		break;
	case 8550: /* MODU8 */
		break;
	case 8565: /* RSHI8 */
		break;
	case 8566: /* RSHU8 */
		break;
	case 8581: /* BANDI8 */
		break;
	case 8582: /* BANDU8 */
		break;
	case 8597: /* BCOMI8 */
		break;
	case 8598: /* BCOMU8 */
		break;
	case 8613: /* BORI8 */
		break;
	case 8614: /* BORU8 */
		break;
	case 8629: /* BXORI8 */
		break;
	case 8630: /* BXORU8 */
		break;
	case 8641: /* DIVF8 */
		/* freg: DIVF8(freg,flt2) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_freg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_flt2_NT] + 0;
		if (c + 0 < p->cost[_freg_NT]) {
			p->cost[_freg_NT] = c + 0;
			p->rule._freg = 9;
			_closure_freg(a, c + 0, p);
		}
		/* freg: DIVF8(freg,burm37) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_freg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_burm37_NT] + 0;
		if (c + 0 < p->cost[_freg_NT]) {
			p->cost[_freg_NT] = c + 0;
			p->rule._freg = 20;
			_closure_freg(a, c + 0, p);
		}
		/* freg: DIVF8(burm37,freg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm37_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_freg_NT] + 0;
		if (c + 0 < p->cost[_freg_NT]) {
			p->cost[_freg_NT] = c + 0;
			p->rule._freg = 21;
			_closure_freg(a, c + 0, p);
		}
		/* freg: DIVF8(freg,burm38) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_freg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_burm38_NT] + 0;
		if (c + 0 < p->cost[_freg_NT]) {
			p->cost[_freg_NT] = c + 0;
			p->rule._freg = 22;
			_closure_freg(a, c + 0, p);
		}
		/* freg: DIVF8(burm38,freg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_burm38_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_freg_NT] + 0;
		if (c + 0 < p->cost[_freg_NT]) {
			p->cost[_freg_NT] = c + 0;
			p->rule._freg = 23;
			_closure_freg(a, c + 0, p);
		}
		/* freg: DIVF8(freg,burm39) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_freg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_burm39_NT] + 0;
		if (c + 0 < p->cost[_freg_NT]) {
			p->cost[_freg_NT] = c + 0;
			p->rule._freg = 35;
			_closure_freg(a, c + 0, p);
		}
		break;
	case 8645: /* DIVI8 */
		break;
	case 8646: /* DIVU8 */
		break;
	case 8657: /* MULF8 */
		/* freg: MULF8(freg,flt) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_freg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_flt_NT] + 0;
		if (c + 0 < p->cost[_freg_NT]) {
			p->cost[_freg_NT] = c + 0;
			p->rule._freg = 11;
			_closure_freg(a, c + 0, p);
		}
		/* freg: MULF8(freg,burm37) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_freg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_burm37_NT] + 0;
		if (c + 0 < p->cost[_freg_NT]) {
			p->cost[_freg_NT] = c + 0;
			p->rule._freg = 24;
			_closure_freg(a, c + 0, p);
		}
		/* freg: MULF8(freg,burm38) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_freg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_burm38_NT] + 0;
		if (c + 0 < p->cost[_freg_NT]) {
			p->cost[_freg_NT] = c + 0;
			p->rule._freg = 25;
			_closure_freg(a, c + 0, p);
		}
		/* freg: MULF8(freg,burm39) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_freg_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_burm39_NT] + 0;
		if (c + 0 < p->cost[_freg_NT]) {
			p->cost[_freg_NT] = c + 0;
			p->rule._freg = 34;
			_closure_freg(a, c + 0, p);
		}
		break;
	case 8661: /* MULI8 */
		break;
	case 8662: /* MULU8 */
		break;
	case 8673: /* EQF8 */
		/* stmt: EQF8(cmpf,freg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_cmpf_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_freg_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 86;
		}
		break;
	case 8677: /* EQI8 */
		break;
	case 8678: /* EQU8 */
		break;
	case 8689: /* GEF8 */
		/* stmt: GEF8(cmpf,freg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_cmpf_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_freg_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 87;
		}
		break;
	case 8693: /* GEI8 */
		break;
	case 8694: /* GEU8 */
		break;
	case 8705: /* GTF8 */
		/* stmt: GTF8(cmpf,freg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_cmpf_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_freg_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 88;
		}
		break;
	case 8709: /* GTI8 */
		break;
	case 8710: /* GTU8 */
		break;
	case 8721: /* LEF8 */
		/* stmt: LEF8(cmpf,freg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_cmpf_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_freg_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 89;
		}
		break;
	case 8725: /* LEI8 */
		break;
	case 8726: /* LEU8 */
		break;
	case 8737: /* LTF8 */
		/* stmt: LTF8(cmpf,freg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_cmpf_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_freg_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 90;
		}
		break;
	case 8741: /* LTI8 */
		break;
	case 8742: /* LTU8 */
		break;
	case 8753: /* NEF8 */
		/* stmt: NEF8(cmpf,freg) */
		c = ((struct _state *)(LEFT_CHILD(a)->x.state))->cost[_cmpf_NT] + ((struct _state *)(RIGHT_CHILD(a)->x.state))->cost[_freg_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 91;
		}
		break;
	case 8757: /* NEI8 */
		break;
	case 8758: /* NEU8 */
		break;
	case 16401: /* CNSTF16 */
		break;
	case 16417: /* ARGF16 */
		break;
	case 16433: /* ASGNF16 */
		break;
	case 16449: /* INDIRF16 */
		break;
	case 16497: /* CVFF16 */
		break;
	case 16513: /* CVIF16 */
		break;
	case 16535: /* CVPP16 */
		break;
	case 16567: /* CVUP16 */
		break;
	case 16577: /* NEGF16 */
		break;
	case 16593: /* CALLF16 */
		break;
	case 16609: /* LOADF16 */
		break;
	case 16625: /* RETF16 */
		break;
	case 16689: /* ADDF16 */
		break;
	case 16705: /* SUBF16 */
		break;
	case 16833: /* DIVF16 */
		break;
	case 16849: /* MULF16 */
		break;
	case 16865: /* EQF16 */
		break;
	case 16885: /* GEI16 */
		break;
	case 16897: /* GTF16 */
		break;
	case 16913: /* LEF16 */
		break;
	case 16929: /* LTF16 */
		break;
	case 16945: /* NEF16 */
		break;
	default:
		fatal("_label2", "Bad terminal %d\n", OP_LABEL(a));
	}
	return p;
}

static void _kids(NODEPTR_TYPE p, int eruleno, NODEPTR_TYPE kids[]) {
	if (!p)
		fatal("_kids", "Null tree\n", 0);
	if (!kids)
		fatal("_kids", "Null kids\n", 0);
	switch (eruleno) {
	case 348: /* burm42: CVII1(burm24) */
	case 347: /* burm41: CVIU2(burm25) */
	case 346: /* burm40: CVII2(burm25) */
	case 345: /* burm39: CVFF8(burm29) */
	case 344: /* burm38: CVIF8(burm40) */
	case 343: /* burm37: CVIF8(burm32) */
	case 338: /* burm32: INDIRI4(addr) */
	case 337: /* burm31: CVFF4(freg) */
	case 336: /* burm30: INDIRF8(addr) */
	case 335: /* burm29: INDIRF4(addr) */
	case 334: /* burm28: INDIRB(reg) */
	case 333: /* burm27: INDIRU2(addr) */
	case 332: /* burm26: INDIRU1(addr) */
	case 331: /* burm25: INDIRI2(addr) */
	case 330: /* burm24: INDIRI1(addr) */
	case 325: /* burm19: NEGI4(mem4) */
	case 324: /* burm18: BCOMU4(mem4) */
	case 323: /* burm17: BCOMI4(mem4) */
	case 305: /* stmt: RETF8(freg) */
	case 304: /* stmt: RETF4(freg) */
	case 303: /* stmt: RETP4(reg) */
	case 302: /* stmt: RETU4(reg) */
	case 301: /* stmt: RETI4(reg) */
	case 300: /* stmt: CALLF8(addrj) */
	case 299: /* stmt: CALLF8(addrj) */
	case 298: /* freg: CALLF8(addrj) */
	case 297: /* freg: CALLF8(addrj) */
	case 296: /* stmt: CALLF4(addrj) */
	case 295: /* stmt: CALLF4(addrj) */
	case 294: /* freg: CALLF4(addrj) */
	case 293: /* freg: CALLF4(addrj) */
	case 292: /* stmt: CALLV(addrj) */
	case 291: /* stmt: CALLV(addrj) */
	case 290: /* reg: CALLP4(addrj) */
	case 289: /* reg: CALLU4(addrj) */
	case 288: /* reg: CALLI4(addrj) */
	case 287: /* reg: CALLP4(addrj) */
	case 286: /* reg: CALLU4(addrj) */
	case 285: /* reg: CALLI4(addrj) */
	case 284: /* freg: LOADF8(memf) */
	case 254: /* cmpf: CVFF8(burm29) */
	case 253: /* cmpf: INDIRF4(addr) */
	case 252: /* cmpf: INDIRF8(addr) */
	case 222: /* stmt: JUMPV(addrj) */
	case 217: /* freg: CVIF4(reg) */
	case 216: /* freg: CVIF4(burm32) */
	case 215: /* freg: CVIF8(reg) */
	case 214: /* freg: CVIF8(burm32) */
	case 213: /* reg: CVFI4(freg) */
	case 212: /* freg: CVFF4(freg) */
	case 211: /* freg: CVFF8(freg) */
	case 198: /* freg: NEGF4(freg) */
	case 197: /* freg: NEGF8(freg) */
	case 196: /* stmt: ARGF4(freg) */
	case 195: /* stmt: ARGF8(freg) */
	case 190: /* memf: CVFF4(burm30) */
	case 189: /* memf: CVFF8(burm29) */
	case 188: /* memf: INDIRF4(addr) */
	case 187: /* memf: INDIRF8(addr) */
	case 186: /* stmt: ARGB(burm28) */
	case 184: /* stmt: ARGP4(mrca) */
	case 183: /* stmt: ARGU4(mrca) */
	case 182: /* stmt: ARGI4(mrca) */
	case 170: /* reg: CVUU2(reg) */
	case 169: /* reg: CVUU1(reg) */
	case 168: /* reg: CVII2(reg) */
	case 167: /* reg: CVII1(reg) */
	case 166: /* reg: CVUU4(reg) */
	case 165: /* reg: CVUI4(reg) */
	case 164: /* reg: CVIU4(reg) */
	case 163: /* reg: CVII4(reg) */
	case 162: /* reg: CVUU4(burm27) */
	case 161: /* reg: CVUU4(burm26) */
	case 160: /* reg: CVII4(burm25) */
	case 159: /* reg: CVII4(burm24) */
	case 158: /* reg: CVUP4(reg) */
	case 157: /* reg: CVPU4(reg) */
	case 136: /* reg: NEGI4(reg) */
	case 135: /* reg: BCOMU4(reg) */
	case 134: /* reg: BCOMI4(reg) */
	case 105: /* reg: LOADP4(reg) */
	case 104: /* reg: LOADU4(reg) */
	case 103: /* reg: LOADU2(reg) */
	case 102: /* reg: LOADU1(reg) */
	case 101: /* reg: LOADI4(reg) */
	case 100: /* reg: LOADI2(reg) */
	case 99: /* reg: LOADI1(reg) */
	case 81: /* mem4: INDIRP4(addr) */
	case 80: /* mem4: INDIRU4(addr) */
	case 79: /* mem4: INDIRI4(addr) */
	case 78: /* mem2: INDIRU2(addr) */
	case 77: /* mem2: INDIRI2(addr) */
	case 76: /* mem1: INDIRU1(addr) */
	case 75: /* mem1: INDIRI1(addr) */
	case 12: /* freg: INDIRF8(burm0) */
	case 11: /* freg: INDIRF4(burm0) */
	case 10: /* reg: INDIRU8(burm0) */
	case 9: /* reg: INDIRP8(burm0) */
	case 8: /* reg: INDIRI8(burm0) */
	case 7: /* reg: INDIRU4(burm0) */
	case 6: /* reg: INDIRP4(burm0) */
	case 5: /* reg: INDIRI4(burm0) */
	case 4: /* reg: INDIRU2(burm0) */
	case 3: /* reg: INDIRI2(burm0) */
	case 2: /* reg: INDIRU1(burm0) */
	case 1: /* reg: INDIRI1(burm0) */
		kids[0] = LEFT_CHILD(p);
		break;
	case 342: /* burm36: BANDU4(burm42,con) */
	case 341: /* burm35: BANDU4(burm41,con) */
	case 340: /* burm34: BANDU4(burm40,con) */
	case 339: /* burm33: BANDU4(mr,con) */
	case 329: /* burm23: RSHU4(mem4,rc5) */
	case 328: /* burm22: RSHI4(mem4,rc5) */
	case 327: /* burm21: LSHU4(mem4,rc5) */
	case 326: /* burm20: LSHI4(mem4,rc5) */
	case 322: /* burm16: BXORU4(mem4,rc) */
	case 321: /* burm15: BORU4(mem4,rc) */
	case 320: /* burm14: BANDU4(mem4,rc) */
	case 319: /* burm13: BXORI4(mem4,rc) */
	case 318: /* burm12: BORI4(mem4,rc) */
	case 317: /* burm11: BANDI4(mem4,rc) */
	case 316: /* burm10: SUBU4(mem4,rc) */
	case 315: /* burm9: ADDU4(mem4,rc) */
	case 314: /* burm8: SUBI4(mem4,rc) */
	case 313: /* burm7: ADDI4(mem4,rc) */
	case 312: /* burm6: SUBP4(mem4,con1) */
	case 311: /* burm5: SUBU4(mem4,con1) */
	case 310: /* burm4: SUBI4(mem4,con1) */
	case 309: /* burm3: ADDP4(mem4,con1) */
	case 308: /* burm2: ADDU4(mem4,con1) */
	case 307: /* burm1: ADDI4(mem4,con1) */
	case 283: /* freg: DIVF8(freg,burm39) */
	case 282: /* freg: MULF8(freg,burm39) */
	case 281: /* freg: SUBF8(freg,burm39) */
	case 280: /* freg: ADDF8(freg,burm39) */
	case 279: /* freg: ADDF8(freg,burm38) */
	case 278: /* freg: ADDF8(freg,burm37) */
	case 277: /* freg: SUBF8(burm38,freg) */
	case 276: /* freg: SUBF8(freg,burm38) */
	case 275: /* freg: SUBF8(burm37,freg) */
	case 274: /* freg: SUBF8(freg,burm37) */
	case 273: /* freg: MULF8(freg,burm38) */
	case 272: /* freg: MULF8(freg,burm37) */
	case 271: /* freg: DIVF8(burm38,freg) */
	case 270: /* freg: DIVF8(freg,burm38) */
	case 269: /* freg: DIVF8(burm37,freg) */
	case 268: /* freg: DIVF8(freg,burm37) */
	case 267: /* stmt: NEF4(cmpf,freg) */
	case 266: /* stmt: LTF4(cmpf,freg) */
	case 265: /* stmt: LEF4(cmpf,freg) */
	case 264: /* stmt: GTF4(cmpf,freg) */
	case 263: /* stmt: GEF4(cmpf,freg) */
	case 262: /* stmt: EQF4(cmpf,freg) */
	case 261: /* stmt: NEF8(cmpf,freg) */
	case 260: /* stmt: LTF8(cmpf,freg) */
	case 259: /* stmt: LEF8(cmpf,freg) */
	case 258: /* stmt: GTF8(cmpf,freg) */
	case 257: /* stmt: GEF8(cmpf,freg) */
	case 256: /* stmt: EQF8(cmpf,freg) */
	case 251: /* stmt: EQI4(burm36,con0) */
	case 250: /* stmt: NEI4(burm35,con0) */
	case 249: /* stmt: EQI4(burm35,con0) */
	case 248: /* stmt: NEI4(burm34,con0) */
	case 247: /* stmt: EQI4(burm34,con0) */
	case 246: /* stmt: NEI4(burm33,con0) */
	case 245: /* stmt: EQI4(burm33,con0) */
	case 244: /* stmt: NEU4(reg,mrc) */
	case 243: /* stmt: LTU4(reg,mrc) */
	case 242: /* stmt: LEU4(reg,mrc) */
	case 241: /* stmt: GTU4(reg,mrc) */
	case 240: /* stmt: GEU4(reg,mrc) */
	case 239: /* stmt: EQU4(reg,mrc) */
	case 238: /* stmt: NEI4(reg,mrc) */
	case 237: /* stmt: LTI4(reg,mrc) */
	case 236: /* stmt: LEI4(reg,mrc) */
	case 235: /* stmt: GTI4(reg,mrc) */
	case 234: /* stmt: GEI4(reg,mrc) */
	case 233: /* stmt: EQI4(reg,mrc) */
	case 232: /* stmt: LTU4(mem4,rc) */
	case 231: /* stmt: LEU4(mem4,rc) */
	case 230: /* stmt: GTU4(mem4,rc) */
	case 229: /* stmt: GEU4(mem4,rc) */
	case 228: /* stmt: NEI4(mem4,rc) */
	case 227: /* stmt: LTI4(mem4,rc) */
	case 226: /* stmt: LEI4(mem4,rc) */
	case 225: /* stmt: GTI4(mem4,rc) */
	case 224: /* stmt: GEI4(mem4,rc) */
	case 223: /* stmt: EQI4(mem4,rc) */
	case 210: /* freg: SUBF8(freg,flt2) */
	case 209: /* freg: SUBF4(freg,flt2) */
	case 208: /* freg: MULF8(freg,flt) */
	case 207: /* freg: MULF4(freg,flt) */
	case 206: /* freg: DIVF8(freg,flt2) */
	case 205: /* freg: DIVF4(freg,flt2) */
	case 204: /* freg: ADDF8(freg,flt) */
	case 203: /* freg: ADDF4(freg,flt) */
	case 194: /* stmt: ASGNF4(addr,burm31) */
	case 193: /* stmt: ASGNF4(addr,freg) */
	case 192: /* stmt: ASGNF8(addr,freg) */
	case 185: /* stmt: ASGNB(reg,burm28) */
	case 181: /* stmt: ASGNP4(addr,rc) */
	case 180: /* stmt: ASGNU4(addr,rc) */
	case 179: /* stmt: ASGNU2(addr,rc) */
	case 178: /* stmt: ASGNU1(addr,rc) */
	case 177: /* stmt: ASGNI4(addr,rc) */
	case 176: /* stmt: ASGNI2(addr,rc) */
	case 175: /* stmt: ASGNI1(addr,rc) */
	case 156: /* reg: MODI4(reg,reg) */
	case 155: /* reg: DIVI4(reg,reg) */
	case 154: /* reg: MODU4(reg,reg) */
	case 153: /* reg: DIVU4(reg,reg) */
	case 152: /* reg: MULU4(reg,mr) */
	case 151: /* reg: MULI4(con,mr) */
	case 150: /* reg: MULI4(reg,mrc) */
	case 147: /* stmt: ASGNI4(addr,burm23) */
	case 146: /* stmt: ASGNI4(addr,burm22) */
	case 145: /* stmt: ASGNI4(addr,burm21) */
	case 144: /* stmt: ASGNI4(addr,burm20) */
	case 143: /* reg: RSHU4(reg,rc5) */
	case 142: /* reg: RSHI4(reg,rc5) */
	case 141: /* reg: LSHU4(reg,rc5) */
	case 140: /* reg: LSHI4(reg,rc5) */
	case 139: /* stmt: ASGNI4(addr,burm19) */
	case 138: /* stmt: ASGNU4(addr,burm18) */
	case 137: /* stmt: ASGNI4(addr,burm17) */
	case 133: /* stmt: ASGNU4(addr,burm16) */
	case 132: /* stmt: ASGNU4(addr,burm15) */
	case 131: /* stmt: ASGNU4(addr,burm14) */
	case 130: /* stmt: ASGNI4(addr,burm13) */
	case 129: /* stmt: ASGNI4(addr,burm12) */
	case 128: /* stmt: ASGNI4(addr,burm11) */
	case 127: /* stmt: ASGNU4(addr,burm10) */
	case 126: /* stmt: ASGNU4(addr,burm9) */
	case 125: /* stmt: ASGNI4(addr,burm8) */
	case 124: /* stmt: ASGNI4(addr,burm7) */
	case 123: /* stmt: ASGNP4(addr,burm6) */
	case 122: /* stmt: ASGNI4(addr,burm5) */
	case 121: /* stmt: ASGNI4(addr,burm4) */
	case 120: /* stmt: ASGNP4(addr,burm3) */
	case 119: /* stmt: ASGNI4(addr,burm2) */
	case 118: /* stmt: ASGNI4(addr,burm1) */
	case 117: /* reg: BXORU4(reg,mrc) */
	case 116: /* reg: BORU4(reg,mrc) */
	case 115: /* reg: BANDU4(reg,mrc) */
	case 114: /* reg: BXORI4(reg,mrc) */
	case 113: /* reg: BORI4(reg,mrc) */
	case 112: /* reg: BANDI4(reg,mrc) */
	case 111: /* reg: SUBU4(reg,mrc) */
	case 110: /* reg: SUBP4(reg,mrc) */
	case 109: /* reg: SUBI4(reg,mrc) */
	case 108: /* reg: ADDU4(reg,mrc) */
	case 107: /* reg: ADDP4(reg,mrc) */
	case 106: /* reg: ADDI4(reg,mrc) */
	case 73: /* addr: ADDU4(index,reg) */
	case 72: /* addr: ADDP4(index,reg) */
	case 71: /* addr: ADDI4(index,reg) */
	case 70: /* addr: ADDU4(reg,baseaddr) */
	case 69: /* addr: ADDP4(reg,baseaddr) */
	case 68: /* addr: ADDI4(reg,baseaddr) */
	case 67: /* addr: ADDU4(index,baseaddr) */
	case 66: /* addr: ADDP4(index,baseaddr) */
	case 65: /* addr: ADDI4(index,baseaddr) */
	case 54: /* index: LSHU4(reg,con3) */
	case 53: /* index: LSHU4(reg,con2) */
	case 52: /* index: LSHU4(reg,con1) */
	case 51: /* index: LSHI4(reg,con3) */
	case 50: /* index: LSHI4(reg,con2) */
	case 49: /* index: LSHI4(reg,con1) */
	case 45: /* base: ADDU4(reg,acon) */
	case 44: /* base: ADDP4(reg,acon) */
	case 43: /* base: ADDI4(reg,acon) */
	case 24: /* stmt: ASGNU8(burm0,reg) */
	case 23: /* stmt: ASGNP8(burm0,reg) */
	case 22: /* stmt: ASGNI8(burm0,reg) */
	case 21: /* stmt: ASGNF8(burm0,reg) */
	case 20: /* stmt: ASGNU4(burm0,reg) */
	case 19: /* stmt: ASGNP4(burm0,reg) */
	case 18: /* stmt: ASGNI4(burm0,reg) */
	case 17: /* stmt: ASGNF4(burm0,reg) */
	case 16: /* stmt: ASGNU2(burm0,reg) */
	case 15: /* stmt: ASGNI2(burm0,reg) */
	case 14: /* stmt: ASGNU1(burm0,reg) */
	case 13: /* stmt: ASGNI1(burm0,reg) */
		kids[0] = LEFT_CHILD(p);
		kids[1] = RIGHT_CHILD(p);
		break;
	case 306: /* burm0: VREGP */
	case 221: /* stmt: LABELV */
	case 218: /* addrj: ADDRGP4 */
	case 174: /* mrca: ADDRGP8 */
	case 173: /* mrca: ADDRGP4 */
	case 148: /* rc5: CNSTI4 */
	case 62: /* con3: CNSTU4 */
	case 61: /* con3: CNSTI4 */
	case 60: /* con2: CNSTU4 */
	case 59: /* con2: CNSTI4 */
	case 58: /* con1: CNSTU4 */
	case 57: /* con1: CNSTI4 */
	case 56: /* con0: CNSTU4 */
	case 55: /* con0: CNSTI4 */
	case 47: /* base: ADDRLP4 */
	case 46: /* base: ADDRFP4 */
	case 41: /* baseaddr: ADDRGP4 */
	case 39: /* acon: ADDRGP8 */
	case 38: /* acon: ADDRGP4 */
	case 34: /* cnst: CNSTP8 */
	case 33: /* cnst: CNSTU8 */
	case 32: /* cnst: CNSTI8 */
	case 31: /* cnst: CNSTP4 */
	case 30: /* cnst: CNSTU4 */
	case 29: /* cnst: CNSTI4 */
	case 28: /* cnst: CNSTU2 */
	case 27: /* cnst: CNSTI2 */
	case 26: /* cnst: CNSTU1 */
	case 25: /* cnst: CNSTI1 */
		break;
	case 255: /* cmpf: freg */
	case 220: /* addrj: mem4 */
	case 219: /* addrj: reg */
	case 202: /* flt2: freg */
	case 201: /* flt2: memf */
	case 200: /* flt: freg */
	case 199: /* flt: memf */
	case 191: /* freg: memf */
	case 172: /* mrca: rc */
	case 171: /* mrca: mem4 */
	case 149: /* rc5: reg */
	case 98: /* reg: con */
	case 97: /* reg: mr2 */
	case 96: /* reg: mr1 */
	case 95: /* reg: mr */
	case 94: /* reg: addr */
	case 93: /* mrc: rc */
	case 92: /* mrc: mem2 */
	case 91: /* mrc: mem1 */
	case 90: /* mrc: mem4 */
	case 89: /* mr2: mem2 */
	case 88: /* mr2: reg */
	case 87: /* mr1: mem1 */
	case 86: /* mr1: reg */
	case 85: /* mr: mem4 */
	case 84: /* mr: reg */
	case 83: /* rc: con */
	case 82: /* rc: reg */
	case 74: /* addr: index */
	case 64: /* addr: baseaddr */
	case 63: /* addr: base */
	case 48: /* index: reg */
	case 42: /* base: reg */
	case 40: /* acon: cnst */
	case 37: /* stmt: freg */
	case 36: /* stmt: reg */
	case 35: /* con: cnst */
		kids[0] = p;
		break;
	default:
		fatal("_kids", "Bad rule number %d\n", eruleno);
	}
}

static int _is_tainted(int op) {
	switch(op) {
	case 41: return 0; /* ARGB */
	case 57: return 0; /* ASGNB */
	case 73: return 0; /* INDIRB */
	case 216: return 1; /* CALLV */
	case 217: return 0; /* CALLB */
	case 233: return 0; /* LOADB */
	case 248: return 0; /* RETV */
	case 584: return 0; /* JUMPV */
	case 600: return 0; /* LABELV */
	case 711: return 0; /* VREGP */
	case 1045: return 0; /* CNSTI1 */
	case 1046: return 0; /* CNSTU1 */
	case 1077: return 0; /* ASGNI1 */
	case 1078: return 0; /* ASGNU1 */
	case 1093: return 0; /* INDIRI1 */
	case 1094: return 0; /* INDIRU1 */
	case 1157: return 0; /* CVII1 */
	case 1158: return 0; /* CVIU1 */
	case 1205: return 0; /* CVUI1 */
	case 1206: return 0; /* CVUU1 */
	case 1253: return 0; /* LOADI1 */
	case 1254: return 0; /* LOADU1 */
	case 2069: return 0; /* CNSTI2 */
	case 2070: return 0; /* CNSTU2 */
	case 2101: return 0; /* ASGNI2 */
	case 2102: return 0; /* ASGNU2 */
	case 2117: return 0; /* INDIRI2 */
	case 2118: return 0; /* INDIRU2 */
	case 2181: return 0; /* CVII2 */
	case 2182: return 0; /* CVIU2 */
	case 2229: return 0; /* CVUI2 */
	case 2230: return 0; /* CVUU2 */
	case 2277: return 0; /* LOADI2 */
	case 2278: return 0; /* LOADU2 */
	case 4113: return 0; /* CNSTF4 */
	case 4117: return 1; /* CNSTI4 */
	case 4118: return 1; /* CNSTU4 */
	case 4119: return 0; /* CNSTP4 */
	case 4129: return 0; /* ARGF4 */
	case 4133: return 0; /* ARGI4 */
	case 4134: return 0; /* ARGU4 */
	case 4135: return 0; /* ARGP4 */
	case 4145: return 0; /* ASGNF4 */
	case 4149: return 1; /* ASGNI4 */
	case 4150: return 1; /* ASGNU4 */
	case 4151: return 1; /* ASGNP4 */
	case 4161: return 0; /* INDIRF4 */
	case 4165: return 0; /* INDIRI4 */
	case 4166: return 0; /* INDIRU4 */
	case 4167: return 0; /* INDIRP4 */
	case 4209: return 0; /* CVFF4 */
	case 4213: return 0; /* CVFI4 */
	case 4225: return 0; /* CVIF4 */
	case 4229: return 0; /* CVII4 */
	case 4230: return 0; /* CVIU4 */
	case 4246: return 1; /* CVPU4 */
	case 4247: return 0; /* CVPP4 */
	case 4277: return 0; /* CVUI4 */
	case 4278: return 0; /* CVUU4 */
	case 4279: return 1; /* CVUP4 */
	case 4289: return 0; /* NEGF4 */
	case 4293: return 0; /* NEGI4 */
	case 4305: return 1; /* CALLF4 */
	case 4309: return 1; /* CALLI4 */
	case 4310: return 1; /* CALLU4 */
	case 4311: return 1; /* CALLP4 */
	case 4321: return 0; /* LOADF4 */
	case 4325: return 1; /* LOADI4 */
	case 4326: return 1; /* LOADU4 */
	case 4327: return 1; /* LOADP4 */
	case 4337: return 0; /* RETF4 */
	case 4341: return 0; /* RETI4 */
	case 4342: return 0; /* RETU4 */
	case 4343: return 0; /* RETP4 */
	case 4359: return 0; /* ADDRGP4 */
	case 4375: return 0; /* ADDRFP4 */
	case 4391: return 0; /* ADDRLP4 */
	case 4401: return 0; /* ADDF4 */
	case 4405: return 0; /* ADDI4 */
	case 4406: return 0; /* ADDU4 */
	case 4407: return 0; /* ADDP4 */
	case 4417: return 0; /* SUBF4 */
	case 4421: return 0; /* SUBI4 */
	case 4422: return 0; /* SUBU4 */
	case 4423: return 0; /* SUBP4 */
	case 4437: return 0; /* LSHI4 */
	case 4438: return 0; /* LSHU4 */
	case 4453: return 0; /* MODI4 */
	case 4454: return 0; /* MODU4 */
	case 4469: return 0; /* RSHI4 */
	case 4470: return 0; /* RSHU4 */
	case 4485: return 0; /* BANDI4 */
	case 4486: return 0; /* BANDU4 */
	case 4501: return 0; /* BCOMI4 */
	case 4502: return 0; /* BCOMU4 */
	case 4517: return 0; /* BORI4 */
	case 4518: return 0; /* BORU4 */
	case 4533: return 0; /* BXORI4 */
	case 4534: return 0; /* BXORU4 */
	case 4545: return 0; /* DIVF4 */
	case 4549: return 0; /* DIVI4 */
	case 4550: return 0; /* DIVU4 */
	case 4561: return 0; /* MULF4 */
	case 4565: return 0; /* MULI4 */
	case 4566: return 0; /* MULU4 */
	case 4577: return 0; /* EQF4 */
	case 4581: return 0; /* EQI4 */
	case 4582: return 0; /* EQU4 */
	case 4593: return 0; /* GEF4 */
	case 4597: return 0; /* GEI4 */
	case 4598: return 0; /* GEU4 */
	case 4609: return 0; /* GTF4 */
	case 4613: return 0; /* GTI4 */
	case 4614: return 0; /* GTU4 */
	case 4625: return 0; /* LEF4 */
	case 4629: return 0; /* LEI4 */
	case 4630: return 0; /* LEU4 */
	case 4641: return 0; /* LTF4 */
	case 4645: return 0; /* LTI4 */
	case 4646: return 0; /* LTU4 */
	case 4657: return 0; /* NEF4 */
	case 4661: return 0; /* NEI4 */
	case 4662: return 0; /* NEU4 */
	case 8209: return 0; /* CNSTF8 */
	case 8213: return 0; /* CNSTI8 */
	case 8214: return 0; /* CNSTU8 */
	case 8215: return 0; /* CNSTP8 */
	case 8225: return 0; /* ARGF8 */
	case 8229: return 0; /* ARGI8 */
	case 8230: return 0; /* ARGU8 */
	case 8231: return 0; /* ARGP8 */
	case 8241: return 0; /* ASGNF8 */
	case 8245: return 0; /* ASGNI8 */
	case 8246: return 0; /* ASGNU8 */
	case 8247: return 0; /* ASGNP8 */
	case 8257: return 0; /* INDIRF8 */
	case 8261: return 0; /* INDIRI8 */
	case 8262: return 0; /* INDIRU8 */
	case 8263: return 0; /* INDIRP8 */
	case 8305: return 0; /* CVFF8 */
	case 8309: return 0; /* CVFI8 */
	case 8321: return 0; /* CVIF8 */
	case 8325: return 0; /* CVII8 */
	case 8326: return 0; /* CVIU8 */
	case 8342: return 0; /* CVPU8 */
	case 8343: return 0; /* CVPP8 */
	case 8373: return 0; /* CVUI8 */
	case 8374: return 0; /* CVUU8 */
	case 8375: return 0; /* CVUP8 */
	case 8385: return 0; /* NEGF8 */
	case 8389: return 0; /* NEGI8 */
	case 8401: return 1; /* CALLF8 */
	case 8405: return 0; /* CALLI8 */
	case 8406: return 0; /* CALLU8 */
	case 8407: return 0; /* CALLP8 */
	case 8417: return 0; /* LOADF8 */
	case 8421: return 0; /* LOADI8 */
	case 8422: return 0; /* LOADU8 */
	case 8423: return 0; /* LOADP8 */
	case 8433: return 0; /* RETF8 */
	case 8437: return 0; /* RETI8 */
	case 8438: return 0; /* RETU8 */
	case 8439: return 0; /* RETP8 */
	case 8455: return 0; /* ADDRGP8 */
	case 8471: return 0; /* ADDRFP8 */
	case 8487: return 0; /* ADDRLP8 */
	case 8497: return 0; /* ADDF8 */
	case 8501: return 0; /* ADDI8 */
	case 8502: return 0; /* ADDU8 */
	case 8503: return 0; /* ADDP8 */
	case 8513: return 0; /* SUBF8 */
	case 8517: return 0; /* SUBI8 */
	case 8518: return 0; /* SUBU8 */
	case 8519: return 0; /* SUBP8 */
	case 8533: return 0; /* LSHI8 */
	case 8534: return 0; /* LSHU8 */
	case 8549: return 0; /* MODI8 */
	case 8550: return 0; /* MODU8 */
	case 8565: return 0; /* RSHI8 */
	case 8566: return 0; /* RSHU8 */
	case 8581: return 0; /* BANDI8 */
	case 8582: return 0; /* BANDU8 */
	case 8597: return 0; /* BCOMI8 */
	case 8598: return 0; /* BCOMU8 */
	case 8613: return 0; /* BORI8 */
	case 8614: return 0; /* BORU8 */
	case 8629: return 0; /* BXORI8 */
	case 8630: return 0; /* BXORU8 */
	case 8641: return 0; /* DIVF8 */
	case 8645: return 0; /* DIVI8 */
	case 8646: return 0; /* DIVU8 */
	case 8657: return 0; /* MULF8 */
	case 8661: return 0; /* MULI8 */
	case 8662: return 0; /* MULU8 */
	case 8673: return 0; /* EQF8 */
	case 8677: return 0; /* EQI8 */
	case 8678: return 0; /* EQU8 */
	case 8689: return 0; /* GEF8 */
	case 8693: return 0; /* GEI8 */
	case 8694: return 0; /* GEU8 */
	case 8705: return 0; /* GTF8 */
	case 8709: return 0; /* GTI8 */
	case 8710: return 0; /* GTU8 */
	case 8721: return 0; /* LEF8 */
	case 8725: return 0; /* LEI8 */
	case 8726: return 0; /* LEU8 */
	case 8737: return 0; /* LTF8 */
	case 8741: return 0; /* LTI8 */
	case 8742: return 0; /* LTU8 */
	case 8753: return 0; /* NEF8 */
	case 8757: return 0; /* NEI8 */
	case 8758: return 0; /* NEU8 */
	case 16401: return 0; /* CNSTF16 */
	case 16417: return 0; /* ARGF16 */
	case 16433: return 0; /* ASGNF16 */
	case 16449: return 0; /* INDIRF16 */
	case 16497: return 0; /* CVFF16 */
	case 16513: return 0; /* CVIF16 */
	case 16535: return 0; /* CVPP16 */
	case 16567: return 0; /* CVUP16 */
	case 16577: return 0; /* NEGF16 */
	case 16593: return 0; /* CALLF16 */
	case 16609: return 0; /* LOADF16 */
	case 16625: return 0; /* RETF16 */
	case 16689: return 0; /* ADDF16 */
	case 16705: return 0; /* SUBF16 */
	case 16833: return 0; /* DIVF16 */
	case 16849: return 0; /* MULF16 */
	case 16865: return 0; /* EQF16 */
	case 16885: return 0; /* GEI16 */
	case 16897: return 0; /* GTF16 */
	case 16913: return 0; /* LEF16 */
	case 16929: return 0; /* LTF16 */
	case 16945: return 0; /* NEF16 */
	default: fatal("_is_tainted", "Bad terminal %d\n", op);
	}
}

#define _DRULES 45

static int (*_dyncost(int op, NODEPTR_TYPE a))[_DRULES] {
	int (*cost)[_DRULES] = allocate(_DRULES * sizeof(int), PERM);
	int i;
	for (i = 0; i < _DRULES; i++)
		(*cost)[i] = -1;
	switch(op) {
	case 41: /* ARGB */
		break;
	case 57: /* ASGNB */
		break;
	case 73: /* INDIRB */
		break;
	case 216: /* CALLV */
		(*cost)[0] = (hasargs(a));
		break;
	case 217: /* CALLB */
		break;
	case 233: /* LOADB */
		break;
	case 248: /* RETV */
		break;
	case 584: /* JUMPV */
		break;
	case 600: /* LABELV */
		break;
	case 711: /* VREGP */
		break;
	case 1045: /* CNSTI1 */
		break;
	case 1046: /* CNSTU1 */
		break;
	case 1077: /* ASGNI1 */
		break;
	case 1078: /* ASGNU1 */
		break;
	case 1093: /* INDIRI1 */
		break;
	case 1094: /* INDIRU1 */
		break;
	case 1157: /* CVII1 */
		break;
	case 1158: /* CVIU1 */
		break;
	case 1205: /* CVUI1 */
		break;
	case 1206: /* CVUU1 */
		break;
	case 1253: /* LOADI1 */
		break;
	case 1254: /* LOADU1 */
		break;
	case 2069: /* CNSTI2 */
		break;
	case 2070: /* CNSTU2 */
		break;
	case 2101: /* ASGNI2 */
		break;
	case 2102: /* ASGNU2 */
		break;
	case 2117: /* INDIRI2 */
		break;
	case 2118: /* INDIRU2 */
		break;
	case 2181: /* CVII2 */
		break;
	case 2182: /* CVIU2 */
		break;
	case 2229: /* CVUI2 */
		break;
	case 2230: /* CVUU2 */
		break;
	case 2277: /* LOADI2 */
		break;
	case 2278: /* LOADU2 */
		break;
	case 4113: /* CNSTF4 */
		break;
	case 4117: /* CNSTI4 */
		(*cost)[0] = (range(a, 0, 31));
		(*cost)[1] = (range(a, 3, 3));
		(*cost)[2] = (range(a, 2, 2));
		(*cost)[3] = (range(a, 1, 1));
		(*cost)[4] = (range(a, 0, 0));
		break;
	case 4118: /* CNSTU4 */
		(*cost)[0] = (range(a, 3, 3));
		(*cost)[1] = (range(a, 2, 2));
		(*cost)[2] = (range(a, 1, 1));
		(*cost)[3] = (range(a, 0, 0));
		break;
	case 4119: /* CNSTP4 */
		break;
	case 4129: /* ARGF4 */
		break;
	case 4133: /* ARGI4 */
		break;
	case 4134: /* ARGU4 */
		break;
	case 4135: /* ARGP4 */
		break;
	case 4145: /* ASGNF4 */
		break;
	case 4149: /* ASGNI4 */
		(*cost)[0] = (memop(a));
		(*cost)[1] = (memop(a));
		(*cost)[2] = (memop(a));
		(*cost)[3] = (memop(a));
		(*cost)[4] = (memop(a));
		(*cost)[5] = (memop(a));
		(*cost)[6] = (memop(a));
		(*cost)[7] = (memop(a));
		(*cost)[8] = (memop(a));
		(*cost)[9] = (memop(a));
		(*cost)[10] = (memop(a));
		(*cost)[11] = (memop(a));
		(*cost)[12] = (memop(a));
		(*cost)[13] = (memop(a));
		(*cost)[14] = (memop(a));
		break;
	case 4150: /* ASGNU4 */
		(*cost)[0] = (memop(a));
		(*cost)[1] = (memop(a));
		(*cost)[2] = (memop(a));
		(*cost)[3] = (memop(a));
		(*cost)[4] = (memop(a));
		(*cost)[5] = (memop(a));
		break;
	case 4151: /* ASGNP4 */
		(*cost)[0] = (memop(a));
		(*cost)[1] = (memop(a));
		break;
	case 4161: /* INDIRF4 */
		break;
	case 4165: /* INDIRI4 */
		break;
	case 4166: /* INDIRU4 */
		break;
	case 4167: /* INDIRP4 */
		break;
	case 4209: /* CVFF4 */
		break;
	case 4213: /* CVFI4 */
		break;
	case 4225: /* CVIF4 */
		break;
	case 4229: /* CVII4 */
		break;
	case 4230: /* CVIU4 */
		break;
	case 4246: /* CVPU4 */
		(*cost)[0] = (move(a));
		break;
	case 4247: /* CVPP4 */
		break;
	case 4277: /* CVUI4 */
		break;
	case 4278: /* CVUU4 */
		break;
	case 4279: /* CVUP4 */
		(*cost)[0] = (move(a));
		break;
	case 4289: /* NEGF4 */
		break;
	case 4293: /* NEGI4 */
		break;
	case 4305: /* CALLF4 */
		(*cost)[0] = (hasargs(a));
		(*cost)[1] = (hasargs(a));
		break;
	case 4309: /* CALLI4 */
		(*cost)[0] = (hasargs(a));
		break;
	case 4310: /* CALLU4 */
		(*cost)[0] = (hasargs(a));
		break;
	case 4311: /* CALLP4 */
		(*cost)[0] = (hasargs(a));
		break;
	case 4321: /* LOADF4 */
		break;
	case 4325: /* LOADI4 */
		(*cost)[0] = (move(a));
		break;
	case 4326: /* LOADU4 */
		(*cost)[0] = (move(a));
		break;
	case 4327: /* LOADP4 */
		(*cost)[0] = (move(a));
		break;
	case 4337: /* RETF4 */
		break;
	case 4341: /* RETI4 */
		break;
	case 4342: /* RETU4 */
		break;
	case 4343: /* RETP4 */
		break;
	case 4359: /* ADDRGP4 */
		break;
	case 4375: /* ADDRFP4 */
		break;
	case 4391: /* ADDRLP4 */
		break;
	case 4401: /* ADDF4 */
		break;
	case 4405: /* ADDI4 */
		break;
	case 4406: /* ADDU4 */
		break;
	case 4407: /* ADDP4 */
		break;
	case 4417: /* SUBF4 */
		break;
	case 4421: /* SUBI4 */
		break;
	case 4422: /* SUBU4 */
		break;
	case 4423: /* SUBP4 */
		break;
	case 4437: /* LSHI4 */
		break;
	case 4438: /* LSHU4 */
		break;
	case 4453: /* MODI4 */
		break;
	case 4454: /* MODU4 */
		break;
	case 4469: /* RSHI4 */
		break;
	case 4470: /* RSHU4 */
		break;
	case 4485: /* BANDI4 */
		break;
	case 4486: /* BANDU4 */
		break;
	case 4501: /* BCOMI4 */
		break;
	case 4502: /* BCOMU4 */
		break;
	case 4517: /* BORI4 */
		break;
	case 4518: /* BORU4 */
		break;
	case 4533: /* BXORI4 */
		break;
	case 4534: /* BXORU4 */
		break;
	case 4545: /* DIVF4 */
		break;
	case 4549: /* DIVI4 */
		break;
	case 4550: /* DIVU4 */
		break;
	case 4561: /* MULF4 */
		break;
	case 4565: /* MULI4 */
		break;
	case 4566: /* MULU4 */
		break;
	case 4577: /* EQF4 */
		break;
	case 4581: /* EQI4 */
		break;
	case 4582: /* EQU4 */
		break;
	case 4593: /* GEF4 */
		break;
	case 4597: /* GEI4 */
		break;
	case 4598: /* GEU4 */
		break;
	case 4609: /* GTF4 */
		break;
	case 4613: /* GTI4 */
		break;
	case 4614: /* GTU4 */
		break;
	case 4625: /* LEF4 */
		break;
	case 4629: /* LEI4 */
		break;
	case 4630: /* LEU4 */
		break;
	case 4641: /* LTF4 */
		break;
	case 4645: /* LTI4 */
		break;
	case 4646: /* LTU4 */
		break;
	case 4657: /* NEF4 */
		break;
	case 4661: /* NEI4 */
		break;
	case 4662: /* NEU4 */
		break;
	case 8209: /* CNSTF8 */
		break;
	case 8213: /* CNSTI8 */
		break;
	case 8214: /* CNSTU8 */
		break;
	case 8215: /* CNSTP8 */
		break;
	case 8225: /* ARGF8 */
		break;
	case 8229: /* ARGI8 */
		break;
	case 8230: /* ARGU8 */
		break;
	case 8231: /* ARGP8 */
		break;
	case 8241: /* ASGNF8 */
		break;
	case 8245: /* ASGNI8 */
		break;
	case 8246: /* ASGNU8 */
		break;
	case 8247: /* ASGNP8 */
		break;
	case 8257: /* INDIRF8 */
		break;
	case 8261: /* INDIRI8 */
		break;
	case 8262: /* INDIRU8 */
		break;
	case 8263: /* INDIRP8 */
		break;
	case 8305: /* CVFF8 */
		break;
	case 8309: /* CVFI8 */
		break;
	case 8321: /* CVIF8 */
		break;
	case 8325: /* CVII8 */
		break;
	case 8326: /* CVIU8 */
		break;
	case 8342: /* CVPU8 */
		break;
	case 8343: /* CVPP8 */
		break;
	case 8373: /* CVUI8 */
		break;
	case 8374: /* CVUU8 */
		break;
	case 8375: /* CVUP8 */
		break;
	case 8385: /* NEGF8 */
		break;
	case 8389: /* NEGI8 */
		break;
	case 8401: /* CALLF8 */
		(*cost)[0] = (hasargs(a));
		(*cost)[1] = (hasargs(a));
		break;
	case 8405: /* CALLI8 */
		break;
	case 8406: /* CALLU8 */
		break;
	case 8407: /* CALLP8 */
		break;
	case 8417: /* LOADF8 */
		break;
	case 8421: /* LOADI8 */
		break;
	case 8422: /* LOADU8 */
		break;
	case 8423: /* LOADP8 */
		break;
	case 8433: /* RETF8 */
		break;
	case 8437: /* RETI8 */
		break;
	case 8438: /* RETU8 */
		break;
	case 8439: /* RETP8 */
		break;
	case 8455: /* ADDRGP8 */
		break;
	case 8471: /* ADDRFP8 */
		break;
	case 8487: /* ADDRLP8 */
		break;
	case 8497: /* ADDF8 */
		break;
	case 8501: /* ADDI8 */
		break;
	case 8502: /* ADDU8 */
		break;
	case 8503: /* ADDP8 */
		break;
	case 8513: /* SUBF8 */
		break;
	case 8517: /* SUBI8 */
		break;
	case 8518: /* SUBU8 */
		break;
	case 8519: /* SUBP8 */
		break;
	case 8533: /* LSHI8 */
		break;
	case 8534: /* LSHU8 */
		break;
	case 8549: /* MODI8 */
		break;
	case 8550: /* MODU8 */
		break;
	case 8565: /* RSHI8 */
		break;
	case 8566: /* RSHU8 */
		break;
	case 8581: /* BANDI8 */
		break;
	case 8582: /* BANDU8 */
		break;
	case 8597: /* BCOMI8 */
		break;
	case 8598: /* BCOMU8 */
		break;
	case 8613: /* BORI8 */
		break;
	case 8614: /* BORU8 */
		break;
	case 8629: /* BXORI8 */
		break;
	case 8630: /* BXORU8 */
		break;
	case 8641: /* DIVF8 */
		break;
	case 8645: /* DIVI8 */
		break;
	case 8646: /* DIVU8 */
		break;
	case 8657: /* MULF8 */
		break;
	case 8661: /* MULI8 */
		break;
	case 8662: /* MULU8 */
		break;
	case 8673: /* EQF8 */
		break;
	case 8677: /* EQI8 */
		break;
	case 8678: /* EQU8 */
		break;
	case 8689: /* GEF8 */
		break;
	case 8693: /* GEI8 */
		break;
	case 8694: /* GEU8 */
		break;
	case 8705: /* GTF8 */
		break;
	case 8709: /* GTI8 */
		break;
	case 8710: /* GTU8 */
		break;
	case 8721: /* LEF8 */
		break;
	case 8725: /* LEI8 */
		break;
	case 8726: /* LEU8 */
		break;
	case 8737: /* LTF8 */
		break;
	case 8741: /* LTI8 */
		break;
	case 8742: /* LTU8 */
		break;
	case 8753: /* NEF8 */
		break;
	case 8757: /* NEI8 */
		break;
	case 8758: /* NEU8 */
		break;
	case 16401: /* CNSTF16 */
		break;
	case 16417: /* ARGF16 */
		break;
	case 16433: /* ASGNF16 */
		break;
	case 16449: /* INDIRF16 */
		break;
	case 16497: /* CVFF16 */
		break;
	case 16513: /* CVIF16 */
		break;
	case 16535: /* CVPP16 */
		break;
	case 16567: /* CVUP16 */
		break;
	case 16577: /* NEGF16 */
		break;
	case 16593: /* CALLF16 */
		break;
	case 16609: /* LOADF16 */
		break;
	case 16625: /* RETF16 */
		break;
	case 16689: /* ADDF16 */
		break;
	case 16705: /* SUBF16 */
		break;
	case 16833: /* DIVF16 */
		break;
	case 16849: /* MULF16 */
		break;
	case 16865: /* EQF16 */
		break;
	case 16885: /* GEI16 */
		break;
	case 16897: /* GTF16 */
		break;
	case 16913: /* LEF16 */
		break;
	case 16929: /* LTF16 */
		break;
	case 16945: /* NEF16 */
		break;
	default: fatal("_dyncost", "Bad terminal %d\n", op);
	}
	return cost;
}

#include <stdbool.h>

static bool _ruleeq(const struct _state *s1, const struct _state *s2) {
	if (
	s1->rule._stmt != s2->rule._stmt ||
	s1->rule._reg != s2->rule._reg ||
	s1->rule._freg != s2->rule._freg ||
	s1->rule._cnst != s2->rule._cnst ||
	s1->rule._con != s2->rule._con ||
	s1->rule._acon != s2->rule._acon ||
	s1->rule._baseaddr != s2->rule._baseaddr ||
	s1->rule._base != s2->rule._base ||
	s1->rule._index != s2->rule._index ||
	s1->rule._con1 != s2->rule._con1 ||
	s1->rule._con2 != s2->rule._con2 ||
	s1->rule._con3 != s2->rule._con3 ||
	s1->rule._con0 != s2->rule._con0 ||
	s1->rule._addr != s2->rule._addr ||
	s1->rule._mem1 != s2->rule._mem1 ||
	s1->rule._mem2 != s2->rule._mem2 ||
	s1->rule._mem4 != s2->rule._mem4 ||
	s1->rule._rc != s2->rule._rc ||
	s1->rule._mr != s2->rule._mr ||
	s1->rule._mr1 != s2->rule._mr1 ||
	s1->rule._mr2 != s2->rule._mr2 ||
	s1->rule._mrc != s2->rule._mrc ||
	s1->rule._rc5 != s2->rule._rc5 ||
	s1->rule._mrca != s2->rule._mrca ||
	s1->rule._memf != s2->rule._memf ||
	s1->rule._flt != s2->rule._flt ||
	s1->rule._flt2 != s2->rule._flt2 ||
	s1->rule._addrj != s2->rule._addrj ||
	s1->rule._cmpf != s2->rule._cmpf ||
	s1->rule._burm0 != s2->rule._burm0 ||
	s1->rule._burm1 != s2->rule._burm1 ||
	s1->rule._burm2 != s2->rule._burm2 ||
	s1->rule._burm3 != s2->rule._burm3 ||
	s1->rule._burm4 != s2->rule._burm4 ||
	s1->rule._burm5 != s2->rule._burm5 ||
	s1->rule._burm6 != s2->rule._burm6 ||
	s1->rule._burm7 != s2->rule._burm7 ||
	s1->rule._burm8 != s2->rule._burm8 ||
	s1->rule._burm9 != s2->rule._burm9 ||
	s1->rule._burm10 != s2->rule._burm10 ||
	s1->rule._burm11 != s2->rule._burm11 ||
	s1->rule._burm12 != s2->rule._burm12 ||
	s1->rule._burm13 != s2->rule._burm13 ||
	s1->rule._burm14 != s2->rule._burm14 ||
	s1->rule._burm15 != s2->rule._burm15 ||
	s1->rule._burm16 != s2->rule._burm16 ||
	s1->rule._burm17 != s2->rule._burm17 ||
	s1->rule._burm18 != s2->rule._burm18 ||
	s1->rule._burm19 != s2->rule._burm19 ||
	s1->rule._burm20 != s2->rule._burm20 ||
	s1->rule._burm21 != s2->rule._burm21 ||
	s1->rule._burm22 != s2->rule._burm22 ||
	s1->rule._burm23 != s2->rule._burm23 ||
	s1->rule._burm24 != s2->rule._burm24 ||
	s1->rule._burm25 != s2->rule._burm25 ||
	s1->rule._burm26 != s2->rule._burm26 ||
	s1->rule._burm27 != s2->rule._burm27 ||
	s1->rule._burm28 != s2->rule._burm28 ||
	s1->rule._burm29 != s2->rule._burm29 ||
	s1->rule._burm30 != s2->rule._burm30 ||
	s1->rule._burm31 != s2->rule._burm31 ||
	s1->rule._burm32 != s2->rule._burm32 ||
	s1->rule._burm33 != s2->rule._burm33 ||
	s1->rule._burm34 != s2->rule._burm34 ||
	s1->rule._burm35 != s2->rule._burm35 ||
	s1->rule._burm36 != s2->rule._burm36 ||
	s1->rule._burm37 != s2->rule._burm37 ||
	s1->rule._burm38 != s2->rule._burm38 ||
	s1->rule._burm39 != s2->rule._burm39 ||
	s1->rule._burm40 != s2->rule._burm40 ||
	s1->rule._burm41 != s2->rule._burm41 ||
	s1->rule._burm42 != s2->rule._burm42)
		return false;
	else
		return true;
}

static int _arity(int op) {
	switch(op) {
	case 41: return 1; /* ARGB */
	case 57: return 2; /* ASGNB */
	case 73: return 1; /* INDIRB */
	case 216: return 1; /* CALLV */
	case 217: return -1; /* CALLB */
	case 233: return -1; /* LOADB */
	case 248: return -1; /* RETV */
	case 584: return 1; /* JUMPV */
	case 600: return 0; /* LABELV */
	case 711: return 0; /* VREGP */
	case 1045: return 0; /* CNSTI1 */
	case 1046: return 0; /* CNSTU1 */
	case 1077: return 2; /* ASGNI1 */
	case 1078: return 2; /* ASGNU1 */
	case 1093: return 1; /* INDIRI1 */
	case 1094: return 1; /* INDIRU1 */
	case 1157: return 1; /* CVII1 */
	case 1158: return -1; /* CVIU1 */
	case 1205: return -1; /* CVUI1 */
	case 1206: return 1; /* CVUU1 */
	case 1253: return 1; /* LOADI1 */
	case 1254: return 1; /* LOADU1 */
	case 2069: return 0; /* CNSTI2 */
	case 2070: return 0; /* CNSTU2 */
	case 2101: return 2; /* ASGNI2 */
	case 2102: return 2; /* ASGNU2 */
	case 2117: return 1; /* INDIRI2 */
	case 2118: return 1; /* INDIRU2 */
	case 2181: return 1; /* CVII2 */
	case 2182: return 1; /* CVIU2 */
	case 2229: return -1; /* CVUI2 */
	case 2230: return 1; /* CVUU2 */
	case 2277: return 1; /* LOADI2 */
	case 2278: return 1; /* LOADU2 */
	case 4113: return -1; /* CNSTF4 */
	case 4117: return 0; /* CNSTI4 */
	case 4118: return 0; /* CNSTU4 */
	case 4119: return 0; /* CNSTP4 */
	case 4129: return 1; /* ARGF4 */
	case 4133: return 1; /* ARGI4 */
	case 4134: return 1; /* ARGU4 */
	case 4135: return 1; /* ARGP4 */
	case 4145: return 2; /* ASGNF4 */
	case 4149: return 2; /* ASGNI4 */
	case 4150: return 2; /* ASGNU4 */
	case 4151: return 2; /* ASGNP4 */
	case 4161: return 1; /* INDIRF4 */
	case 4165: return 1; /* INDIRI4 */
	case 4166: return 1; /* INDIRU4 */
	case 4167: return 1; /* INDIRP4 */
	case 4209: return 1; /* CVFF4 */
	case 4213: return 1; /* CVFI4 */
	case 4225: return 1; /* CVIF4 */
	case 4229: return 1; /* CVII4 */
	case 4230: return 1; /* CVIU4 */
	case 4246: return 1; /* CVPU4 */
	case 4247: return -1; /* CVPP4 */
	case 4277: return 1; /* CVUI4 */
	case 4278: return 1; /* CVUU4 */
	case 4279: return 1; /* CVUP4 */
	case 4289: return 1; /* NEGF4 */
	case 4293: return 1; /* NEGI4 */
	case 4305: return 1; /* CALLF4 */
	case 4309: return 1; /* CALLI4 */
	case 4310: return 1; /* CALLU4 */
	case 4311: return 1; /* CALLP4 */
	case 4321: return -1; /* LOADF4 */
	case 4325: return 1; /* LOADI4 */
	case 4326: return 1; /* LOADU4 */
	case 4327: return 1; /* LOADP4 */
	case 4337: return 1; /* RETF4 */
	case 4341: return 1; /* RETI4 */
	case 4342: return 1; /* RETU4 */
	case 4343: return 1; /* RETP4 */
	case 4359: return 0; /* ADDRGP4 */
	case 4375: return 0; /* ADDRFP4 */
	case 4391: return 0; /* ADDRLP4 */
	case 4401: return 2; /* ADDF4 */
	case 4405: return 2; /* ADDI4 */
	case 4406: return 2; /* ADDU4 */
	case 4407: return 2; /* ADDP4 */
	case 4417: return 2; /* SUBF4 */
	case 4421: return 2; /* SUBI4 */
	case 4422: return 2; /* SUBU4 */
	case 4423: return 2; /* SUBP4 */
	case 4437: return 2; /* LSHI4 */
	case 4438: return 2; /* LSHU4 */
	case 4453: return 2; /* MODI4 */
	case 4454: return 2; /* MODU4 */
	case 4469: return 2; /* RSHI4 */
	case 4470: return 2; /* RSHU4 */
	case 4485: return 2; /* BANDI4 */
	case 4486: return 2; /* BANDU4 */
	case 4501: return 1; /* BCOMI4 */
	case 4502: return 1; /* BCOMU4 */
	case 4517: return 2; /* BORI4 */
	case 4518: return 2; /* BORU4 */
	case 4533: return 2; /* BXORI4 */
	case 4534: return 2; /* BXORU4 */
	case 4545: return 2; /* DIVF4 */
	case 4549: return 2; /* DIVI4 */
	case 4550: return 2; /* DIVU4 */
	case 4561: return 2; /* MULF4 */
	case 4565: return 2; /* MULI4 */
	case 4566: return 2; /* MULU4 */
	case 4577: return 2; /* EQF4 */
	case 4581: return 2; /* EQI4 */
	case 4582: return 2; /* EQU4 */
	case 4593: return 2; /* GEF4 */
	case 4597: return 2; /* GEI4 */
	case 4598: return 2; /* GEU4 */
	case 4609: return 2; /* GTF4 */
	case 4613: return 2; /* GTI4 */
	case 4614: return 2; /* GTU4 */
	case 4625: return 2; /* LEF4 */
	case 4629: return 2; /* LEI4 */
	case 4630: return 2; /* LEU4 */
	case 4641: return 2; /* LTF4 */
	case 4645: return 2; /* LTI4 */
	case 4646: return 2; /* LTU4 */
	case 4657: return 2; /* NEF4 */
	case 4661: return 2; /* NEI4 */
	case 4662: return 2; /* NEU4 */
	case 8209: return -1; /* CNSTF8 */
	case 8213: return 0; /* CNSTI8 */
	case 8214: return 0; /* CNSTU8 */
	case 8215: return 0; /* CNSTP8 */
	case 8225: return 1; /* ARGF8 */
	case 8229: return -1; /* ARGI8 */
	case 8230: return -1; /* ARGU8 */
	case 8231: return -1; /* ARGP8 */
	case 8241: return 2; /* ASGNF8 */
	case 8245: return 2; /* ASGNI8 */
	case 8246: return 2; /* ASGNU8 */
	case 8247: return 2; /* ASGNP8 */
	case 8257: return 1; /* INDIRF8 */
	case 8261: return 1; /* INDIRI8 */
	case 8262: return 1; /* INDIRU8 */
	case 8263: return 1; /* INDIRP8 */
	case 8305: return 1; /* CVFF8 */
	case 8309: return -1; /* CVFI8 */
	case 8321: return 1; /* CVIF8 */
	case 8325: return -1; /* CVII8 */
	case 8326: return -1; /* CVIU8 */
	case 8342: return -1; /* CVPU8 */
	case 8343: return -1; /* CVPP8 */
	case 8373: return -1; /* CVUI8 */
	case 8374: return -1; /* CVUU8 */
	case 8375: return -1; /* CVUP8 */
	case 8385: return 1; /* NEGF8 */
	case 8389: return -1; /* NEGI8 */
	case 8401: return 1; /* CALLF8 */
	case 8405: return -1; /* CALLI8 */
	case 8406: return -1; /* CALLU8 */
	case 8407: return -1; /* CALLP8 */
	case 8417: return 1; /* LOADF8 */
	case 8421: return -1; /* LOADI8 */
	case 8422: return -1; /* LOADU8 */
	case 8423: return -1; /* LOADP8 */
	case 8433: return 1; /* RETF8 */
	case 8437: return -1; /* RETI8 */
	case 8438: return -1; /* RETU8 */
	case 8439: return -1; /* RETP8 */
	case 8455: return 0; /* ADDRGP8 */
	case 8471: return -1; /* ADDRFP8 */
	case 8487: return -1; /* ADDRLP8 */
	case 8497: return 2; /* ADDF8 */
	case 8501: return -1; /* ADDI8 */
	case 8502: return -1; /* ADDU8 */
	case 8503: return -1; /* ADDP8 */
	case 8513: return 2; /* SUBF8 */
	case 8517: return -1; /* SUBI8 */
	case 8518: return -1; /* SUBU8 */
	case 8519: return -1; /* SUBP8 */
	case 8533: return -1; /* LSHI8 */
	case 8534: return -1; /* LSHU8 */
	case 8549: return -1; /* MODI8 */
	case 8550: return -1; /* MODU8 */
	case 8565: return -1; /* RSHI8 */
	case 8566: return -1; /* RSHU8 */
	case 8581: return -1; /* BANDI8 */
	case 8582: return -1; /* BANDU8 */
	case 8597: return -1; /* BCOMI8 */
	case 8598: return -1; /* BCOMU8 */
	case 8613: return -1; /* BORI8 */
	case 8614: return -1; /* BORU8 */
	case 8629: return -1; /* BXORI8 */
	case 8630: return -1; /* BXORU8 */
	case 8641: return 2; /* DIVF8 */
	case 8645: return -1; /* DIVI8 */
	case 8646: return -1; /* DIVU8 */
	case 8657: return 2; /* MULF8 */
	case 8661: return -1; /* MULI8 */
	case 8662: return -1; /* MULU8 */
	case 8673: return 2; /* EQF8 */
	case 8677: return -1; /* EQI8 */
	case 8678: return -1; /* EQU8 */
	case 8689: return 2; /* GEF8 */
	case 8693: return -1; /* GEI8 */
	case 8694: return -1; /* GEU8 */
	case 8705: return 2; /* GTF8 */
	case 8709: return -1; /* GTI8 */
	case 8710: return -1; /* GTU8 */
	case 8721: return 2; /* LEF8 */
	case 8725: return -1; /* LEI8 */
	case 8726: return -1; /* LEU8 */
	case 8737: return 2; /* LTF8 */
	case 8741: return -1; /* LTI8 */
	case 8742: return -1; /* LTU8 */
	case 8753: return 2; /* NEF8 */
	case 8757: return -1; /* NEI8 */
	case 8758: return -1; /* NEU8 */
	case 16401: return -1; /* CNSTF16 */
	case 16417: return -1; /* ARGF16 */
	case 16433: return -1; /* ASGNF16 */
	case 16449: return -1; /* INDIRF16 */
	case 16497: return -1; /* CVFF16 */
	case 16513: return -1; /* CVIF16 */
	case 16535: return -1; /* CVPP16 */
	case 16567: return -1; /* CVUP16 */
	case 16577: return -1; /* NEGF16 */
	case 16593: return -1; /* CALLF16 */
	case 16609: return -1; /* LOADF16 */
	case 16625: return -1; /* RETF16 */
	case 16689: return -1; /* ADDF16 */
	case 16705: return -1; /* SUBF16 */
	case 16833: return -1; /* DIVF16 */
	case 16849: return -1; /* MULF16 */
	case 16865: return -1; /* EQF16 */
	case 16885: return -1; /* GEI16 */
	case 16897: return -1; /* GTF16 */
	case 16913: return -1; /* LEF16 */
	case 16929: return -1; /* LTF16 */
	case 16945: return -1; /* NEF16 */
	default: fatal("_arity", "Bad terminal %d\n", op);
	}
}

#define _SIZE 251
#define _NTS 72
#define STATE_ID(p) (((State) STATE_LABEL(p))->id)

#include <math.h>

/*
 * Utilities
 */

static unsigned int
_mkid()
{
        static unsigned int id = 2;
        return id++;
}

static short
_min(short cost[])
{
        int i;
        short min = cost[1];
        for (i = 2; i <= _NTS; i++)
                if (cost[i] < min)
                        min = cost[i];
        return min;
}

/*
** Tables
*/

typedef struct _state *State;

typedef struct _state_key {
        int op;
        unsigned int id1;
        unsigned int id2;
} *StateKey;

typedef struct _swdc_key {
        int op;
        unsigned int id1;
        unsigned int id2;
        int (*dyncost)[_DRULES];
} *SwdcKey;

typedef union {
        StateKey state;
        SwdcKey  swdc;
        State    full;
} *Key;

typedef union {
        State state;
        int   id;
} *Val;

typedef struct _bucket {
        Key             key;
        Val             val;
        struct _bucket *next;
} *Bucket;

typedef struct _table {
        Bucket          t[_SIZE];
        unsigned int  (*hash)(const Key);
        bool          (*eq)(const Key, const Key);
} *BurmTable;

/*
** Hashing
*/

static unsigned int
hash_state(const Key key)
{
        StateKey k = key->state;
        unsigned int hashval = k->op * k->id1 * k->id2;
        return hashval % _SIZE;
}

static bool
eq_state(const Key key1, const Key key2)
{
        StateKey k1 = key1->state;
        StateKey k2 = key2->state;
        return (k1->op  == k2->op  &&
                k1->id1 == k2->id1 &&
                k1->id2 == k2->id2);
}

static unsigned int
hash_swdc(const Key key)
{
        SwdcKey k = key->swdc;
        int i;
        unsigned int hashval = k->op * k->id1 * k->id2;
        for (i = 0; i < _DRULES && (*(k->dyncost))[i] != -1; i++)
                hashval *= (*(k->dyncost))[i];
        return hashval % _SIZE;
}

static bool
eq_swdc(const Key key1, const Key key2)
{
        SwdcKey k1 = key1->swdc;
        SwdcKey k2 = key2->swdc;
        int i;
        if (k1->op  != k2->op ||
            k1->id1 != k2->id1 ||
            k1->id2 != k2->id2)
                return false;
        for (i = 0; i < _DRULES; i++)
                if ((*(k1->dyncost))[i] != (*(k2->dyncost))[i])
                        return false;
                else if ((*(k1->dyncost))[i] == -1)
                        break;
        return true;
}

static unsigned int
hash_full(const Key key)
{
        State s = key->full;
        int i;
        unsigned int hashval = 1;
        for (i = 1; i <= _NTS; i++) {
                hashval *= s->cost[i];
                hashval *= _rule(s, i);
        }
        return hashval % _SIZE;
}

static bool
eq_full(const Key key1, const Key key2)
{
        State s1 = key1->full;
        State s2 = key2->full;
        int i;
        if (!_ruleeq(s1, s2))
                return false;
        for (i = 1; i <= _NTS; i++)
                if (s1->cost[i] != s2->cost[i])
                        return false;
        return true;
}

/*
** Initialization
*/

static BurmTable state_cache; /* state_cache :: StateKey -> State */
static BurmTable swdc_cache;  /* swdc_cache  :: SwdcKey -> State  */
static BurmTable id_cache;    /* id_cache    :: State -> int      */

static void
_burminit()
{
        static bool flag = false;
        if (!flag) {
                flag              = true;
                state_cache       = (BurmTable) malloc(sizeof(*state_cache));
                swdc_cache        = (BurmTable) malloc(sizeof(*swdc_cache));
                id_cache          = (BurmTable) malloc(sizeof(*id_cache));
                state_cache->hash = hash_state;
                state_cache->eq   = eq_state;
                swdc_cache->hash  = hash_swdc;
                swdc_cache->eq    = eq_swdc;
                id_cache->hash    = hash_full;
                id_cache->eq      = eq_full;
        }
}

/*
** lookup/install
*/

static Val
_lookup(const BurmTable tab, const Key k)
{
        Bucket b;
        for (b = tab->t[tab->hash(k)]; b != NULL; b = b->next)
                if (tab->eq(k, b->key) == true)
                        return b->val;
        return NULL;
}

static void
_install(BurmTable tab, Key k, Val v)
{
        Bucket b;
        unsigned int hashval;
        if (_lookup(tab, k) == NULL) {
                b               = malloc(sizeof(*b));
                hashval         = tab->hash(k);
                b->key          = k;
                b->val          = v;
                b->next         = tab->t[hashval];
                tab->t[hashval] = b;
        } else
                fatal("_install", "OOPS\n", 0);
}

/*
** _label()
*/

// Stats
unsigned int _states_labeled = 0;
unsigned int _states_found   = 0;
unsigned int _swdcs_labeled  = 0;
unsigned int _swdcs_found    = 0;
unsigned int _unique_states  = 0;
unsigned int _ident_states   = 0;
unsigned int _indirs         = 0;
unsigned int _indir_reused   = 0;

static State _calc_label(NODEPTR_TYPE);

static void
_label(NODEPTR_TYPE a)
{
	if (!a)
		fatal("_label", "Null tree\n", 0);

        State p;
        int id1, id2, op = OP_LABEL(a);

        switch (_arity(op)) {
        case 0:
                id1 = id2 = 1;
                break;
        case 1:
                _label(LEFT_CHILD(a));
                id1 = STATE_ID(LEFT_CHILD(a));
                id2 = 1;
                break;
        case 2:
                _label(LEFT_CHILD(a));
                _label(RIGHT_CHILD(a));
                id1 = ((State) STATE_LABEL(LEFT_CHILD(a)))->id; // XXX
                id2 = ((State) STATE_LABEL(RIGHT_CHILD(a)))->id;
                break;
        default:
                fatal("_install", "OOPS2\n", 0);
        }

        _burminit();

        Key k = allocate(sizeof(*k), PERM);
        Val v;

	if (generic(op) == INDIR) {
                p = _calc_label(a);
                _indirs++;
        } else if (_is_tainted(op)) {
                k->swdc          = allocate(sizeof(*k->swdc), PERM);
                k->swdc->op      = op;
                k->swdc->id1     = id1;
                k->swdc->id2     = id2;
                k->swdc->dyncost = _dyncost(op, a);
                if ((v = _lookup(swdc_cache, k)) == NULL) {
                        p        = _calc_label(a);
                        v        = allocate(sizeof(*v), PERM);
                        v->state = p;
                        _install(swdc_cache, k, v);
                        _swdcs_labeled++;
                } else {
                        p = v->state;
                        _swdcs_found++;
                }
        } else {
                k->state      = allocate(sizeof(*k->state), PERM);
                k->state->op  = op;
                k->state->id1 = id1;
                k->state->id2 = id2;
                if ((v = _lookup(state_cache, k)) == NULL) {
                        p        = _calc_label(a);
                        v        = allocate(sizeof(*v), PERM);
                        v->state = p;
                        _install(state_cache, k, v);
                        _states_labeled++;
                } else {
                        p = v->state;
                        _states_found++;
                }
        }

        STATE_LABEL(a) = p;
}

static State
_calc_label(NODEPTR_TYPE a)
{
        // Former _label()
        State p = _label2(a);

        // Normalize
        int i, delta = _min(p->cost);
        for (i = 1; i <= _NTS; i++)
                if (!(p->cost[i] == 0x7fff))
                        p->cost[i] -= delta;

        // Set state number
        Key k   = allocate(sizeof(*k), PERM);
        k->full = p;
        Val v;

        if ((v = _lookup(id_cache, k)) == NULL) {
                int id = _mkid();
                v      = allocate(sizeof(*v), PERM);
                v->id  = id;
                p->id  = id;
                _install(id_cache, k, v);
                _unique_states++;
        } else {
                p->id = v->id;
                if (generic(a->op) == INDIR)
                        _indir_reused++;
                _ident_states++;
        }

        return p;
}

// eof
static void progbeg(int argc, char *argv[]) {
        int i;
        extern Interface x86IR, x86linuxIR;

#define xx(f) assert(!x86linuxIR.f); x86linuxIR.f = x86IR.f
        xx(address);
        xx(local);
        xx(x.blkfetch);
        xx(x.blkstore);
        xx(x.blkloop);
        xx(x.doarg);
#undef xx
        {
                union {
                        char c;
                        int i;
                } u;
                u.i = 0;
                u.c = 1;
                swap = ((int)(u.i == 1)) != IR->little_endian;
        }
        parseflags(argc, argv);
        for (i = 0; i < argc; i++)
                if (strcmp(argv[i], "-p") == 0 || strcmp(argv[i], "-pg") == 0)
                        pflag = 1;      
        intreg[EAX]   = mkreg("%%eax", EAX, 1, IREG);
        intreg[EDX]   = mkreg("%%edx", EDX, 1, IREG);
        intreg[ECX]   = mkreg("%%ecx", ECX, 1, IREG);
        intreg[EBX]   = mkreg("%%ebx", EBX, 1, IREG);
        intreg[ESI]   = mkreg("%%esi", ESI, 1, IREG);
        intreg[EDI]   = mkreg("%%edi", EDI, 1, IREG);
        shortreg[EAX] = mkreg("%%ax", EAX, 1, IREG);
        shortreg[ECX] = mkreg("%%cx", ECX, 1, IREG);
        shortreg[EDX] = mkreg("%%dx", EDX, 1, IREG);
        shortreg[EBX] = mkreg("%%bx", EBX, 1, IREG);
        shortreg[ESI] = mkreg("%%si", ESI, 1, IREG);
        shortreg[EDI] = mkreg("%%di", EDI, 1, IREG);
        charreg[EAX]  = mkreg("%%al", EAX, 1, IREG);
        charreg[ECX]  = mkreg("%%cl", ECX, 1, IREG);
        charreg[EDX]  = mkreg("%%dl", EDX, 1, IREG);
        charreg[EBX]  = mkreg("%%bl", EBX, 1, IREG);
        for (i = 0; i < 8; i++)
                fltreg[i] = mkreg("%d", i, 0, FREG);
        charregw = mkwildcard(charreg);
        shortregw = mkwildcard(shortreg);
        intregw = mkwildcard(intreg);
        fltregw = mkwildcard(fltreg);

        tmask[IREG] = (1<<EDI) | (1<<ESI) | (1<<EBX)
                    | (1<<EDX) | (1<<ECX) | (1<<EAX);
        vmask[IREG] = 0;
        tmask[FREG] = 0xff;
        vmask[FREG] = 0;

        cseg = 0;
        quo = mkreg("%%eax", EAX, 1, IREG);
        quo->x.regnode->mask |= 1<<EDX;
        rem = mkreg("%%edx", EDX, 1, IREG);
        rem->x.regnode->mask |= 1<<EAX;

        stabprefix = ".LL";
}

static Symbol rmap(int opk) {
        switch (optype(opk)) {
        case B: case P:
                return intregw;
        case I: case U:
                if (opsize(opk) == 1)
                        return charregw;
                else if (opsize(opk) == 2)
                        return shortregw;
                else
                        return intregw;
        case F:
                return fltregw;
        default:
                return 0;
        }
}

static Symbol prevg;

static void globalend(void) {
        if (prevg && prevg->type->size > 0)
                print(".size %s,%d\n", prevg->x.name, prevg->type->size);
        prevg = NULL;
}

static void progend(void) {
        globalend();
        (*IR->segment)(CODE);
        print(".ident \"LCC: 4.1\"\n");
}

static void target(Node p) {
        assert(p);
        switch (specific(p->op)) {
        case RSH+I: case RSH+U: case LSH+I: case LSH+U:
                if (generic(p->kids[1]->op) != CNST
                && !(   generic(p->kids[1]->op) == INDIR
                     && specific(p->kids[1]->kids[0]->op) == VREG+P
                     && p->kids[1]->syms[RX]->u.t.cse
                     && generic(p->kids[1]->syms[RX]->u.t.cse->op) == CNST)) {
                        rtarget(p, 1, intreg[ECX]);
                        setreg(p, intreg[EAX]);
                }
                break;
        case MUL+U:
                setreg(p, quo);
                rtarget(p, 0, intreg[EAX]);
                break;
        case DIV+I: case DIV+U:
                setreg(p, quo);
                rtarget(p, 0, intreg[EAX]);
                rtarget(p, 1, intreg[ECX]);
                break;
        case MOD+I: case MOD+U:
                setreg(p, rem);
                rtarget(p, 0, intreg[EAX]);
                rtarget(p, 1, intreg[ECX]);
                break;
        case ASGN+B:
                rtarget(p, 0, intreg[EDI]);
                rtarget(p->kids[1], 0, intreg[ESI]);
                break;
        case ARG+B:
                rtarget(p->kids[0], 0, intreg[ESI]);
                break;
        case CVF+I:
                setreg(p, intreg[EAX]);
                break;
        case CALL+I: case CALL+U: case CALL+P: case CALL+V:
                setreg(p, intreg[EAX]);
                break;
        case RET+I: case RET+U: case RET+P:
                rtarget(p, 0, intreg[EAX]);
                break;
        }
}

static void clobber(Node p) {
        static int nstack = 0;

        assert(p);
        nstack = ckstack(p, nstack);
        switch (specific(p->op)) {
        case ASGN+B: case ARG+B:
                spill(1<<ECX | 1<<ESI | 1<<EDI, IREG, p);
                break;
        case EQ+F: case LE+F: case GE+F: case LT+F: case GT+F: case NE+F:
                spill(1<<EAX, IREG, p);
                break;
        case CVF+I:
                spill(1<<EDX, IREG, p);
                break;
        case CALL+F:
                spill(1<<EDX | 1<<EAX | 1<<ECX, IREG, p);
                break;
        case CALL+I: case CALL+U: case CALL+P: case CALL+V:
                spill(1<<EDX | 1<<ECX, IREG, p);
                break;
        }
}

static void emit2(Node p) {
        int op = specific(p->op);
#define preg(f) ((f)[getregnum(p->x.kids[0])]->x.name)

        if (op == CVI+I && opsize(p->op) == 4 && opsize(p->x.kids[0]->op) == 1)
                print("movsbl %s,%s\n", preg(charreg), p->syms[RX]->x.name);
        else if (op == CVI+U && opsize(p->op) == 4 && opsize(p->x.kids[0]->op) == 1)
                print("movsbl %s,%s\n", preg(charreg), p->syms[RX]->x.name);
        else if (op == CVI+I && opsize(p->op) == 4 && opsize(p->x.kids[0]->op) == 2)
                print("movswl %s,%s\n", preg(shortreg), p->syms[RX]->x.name);
        else if (op == CVI+U && opsize(p->op) == 4 && opsize(p->x.kids[0]->op) == 2)
                print("movswl %s,%s\n", preg(shortreg), p->syms[RX]->x.name);
        else if (op == CVU+I && opsize(p->op) == 4 && opsize(p->x.kids[0]->op) == 1)
                print("movzbl %s,%s\n", preg(charreg), p->syms[RX]->x.name);
        else if (op == CVU+U && opsize(p->op) == 4 && opsize(p->x.kids[0]->op) == 1)
                print("movzbl %s,%s\n", preg(charreg), p->syms[RX]->x.name);
        else if (op == CVU+I && opsize(p->op) == 4 && opsize(p->x.kids[0]->op) == 2)
                print("movzwl %s,%s\n", preg(shortreg), p->syms[RX]->x.name);
        else if (op == CVU+U && opsize(p->op) == 4 && opsize(p->x.kids[0]->op) == 2)
                print("movzwl %s,%s\n", preg(shortreg), p->syms[RX]->x.name);
        else if (generic(op) == CVI || generic(op) == CVU || generic(op) == LOAD) {
                char *dst = intreg[getregnum(p)]->x.name;
                char *src = preg(intreg);
                assert(opsize(p->op) <= opsize(p->x.kids[0]->op));
                if (dst != src)
                        print("movl %s,%s\n", src, dst);
        } else if (op == ARG+B)
                print("subl $%d,%%esp\nmovl %%esp,%%edi\nmovl $%d,%%ecx\nrep\nmovsb\n",
                        roundup(p->syms[0]->u.c.v.i, 4), p->syms[0]->u.c.v.i);
}

static void function(Symbol f, Symbol caller[], Symbol callee[], int n) {
        int i;

        globalend();
        print(".align 16\n");
        print(".type %s,@function\n", f->x.name);
        print("%s:\n", f->x.name);
        print("pushl %%ebp\n");
        if (pflag) {
                static int plab;
                print("movl %%esp,%%ebp\n");
                (*IR->segment)(DATA);
                print(".align 4\n.LP%d:\n.long 0\n", plab);
                (*IR->segment)(CODE);
                print("movl $.LP%d,%%edx\ncall mcount\n", plab);
                plab++;
        }
        print("pushl %%ebx\n");
        print("pushl %%esi\n");
        print("pushl %%edi\n");
        print("movl %%esp,%%ebp\n");

        usedmask[0] = usedmask[1] = 0;
        freemask[0] = freemask[1] = ~0U;
        offset = 16 + 4;
        for (i = 0; callee[i]; i++) {
                Symbol p = callee[i];
                Symbol q = caller[i];
                assert(q);
                offset = roundup(offset, q->type->align);
                p->x.offset = q->x.offset = offset;
                p->x.name = q->x.name = stringf("%d", p->x.offset);
                p->sclass = q->sclass = AUTO;
                offset += roundup(q->type->size, 4);
        }
        assert(caller[i] == 0);
        offset = maxoffset = 0;
        gencode(caller, callee);
        framesize = roundup(maxoffset, 4);
        if (framesize > 0)
                print("subl $%d,%%esp\n", framesize);
        emitcode();
        print("movl %%ebp,%%esp\n");
        print("popl %%edi\n");
        print("popl %%esi\n");
        print("popl %%ebx\n");
        print("popl %%ebp\n");
        print("ret\n");
        { int l = genlabel(1);
          print(".Lf%d:\n", l);
          print(".size %s,.Lf%d-%s\n", f->x.name, l, f->x.name);
        }
}

static void defsymbol(Symbol p) {
        if (p->scope >= LOCAL && p->sclass == STATIC)
                p->x.name = stringf("%s.%d", p->name, genlabel(1));
        else if (p->generated)
                p->x.name = stringf(".LC%s", p->name);
        else if (p->scope == GLOBAL || p->sclass == EXTERN)
                p->x.name = stringf("%s", p->name);
        else
                p->x.name = p->name;
}

static void segment(int n) {
        if (n == cseg)
                return;
        cseg = n;
        if (cseg == CODE)
                print(".text\n");
        else if (cseg == BSS)
                print(".bss\n");
        else if (cseg == DATA || cseg == LIT)
                print(".data\n");
}

static void defconst(int suffix, int size, Value v) {
        if (suffix == I && size == 1)
                print(".byte %d\n", (int)v.u);
        else if (suffix == I && size == 2)
                print(".word %d\n", (int)v.i);
        else if (suffix == I && size == 4)
                print(".long %d\n", (int)v.i);
        else if (suffix == U && size == 1)
                print(".byte %d\n", (int)((char)v.u));
        else if (suffix == U && size == 2)
                print(".word %d\n", (int)v.u);
        else if (suffix == U && size == 4)
                print(".long %d\n", (int)v.u);
        else if (suffix == P && size == 4)
                print(".long %d\n", (int)v.p);
        else if (suffix == F && size == 4) {
                float f = v.d;
                print(".long %d\n", (int)(*(unsigned *)&f));
        } else if (suffix == F && size == 8) {
                double d = v.d;
                unsigned *p = (unsigned *)&d;
                print(".long %d\n.long %d\n", (int)p[swap], (int)p[!swap]);
        }
        else assert(0);
}

static void defaddress(Symbol p) {
        print(".long %s\n", p->x.name);
}

static void defstring(int n, char *str) {
        char *s;

        for (s = str; s < str + n; s++)
                print(".byte %d\n", (*s)&0377);
}

static void export(Symbol p) {
        globalend();
        print(".globl %s\n", p->x.name);
}

static void import(Symbol p) {}

static void global(Symbol p) {
        globalend();
        print(".align %d\n", p->type->align > 4 ? 4 : p->type->align);
        if (!p->generated) {
                print(".type %s,@%s\n", p->x.name,
                        isfunc(p->type) ? "function" : "object");
                if (p->type->size > 0)
                        print(".size %s,%d\n", p->x.name, p->type->size);
                else
                        prevg = p;
        }
        if (p->u.seg == BSS) {
                if (p->sclass == STATIC)
                        print(".lcomm %s,%d\n", p->x.name, p->type->size);
                else
                        print(".comm %s,%d\n", p->x.name, p->type->size);
        } else {
                print("%s:\n", p->x.name);
        }
}

static void space(int n) {
        if (cseg != BSS)
                print(".space %d\n", n);
}

Interface x86linuxIR = {
        1, 1, 0,  /* char */
        2, 2, 0,  /* short */
        4, 4, 0,  /* int */
        4, 4, 0,  /* long */
        4, 4, 0,  /* long long */
        4, 4, 1,  /* float */
        8, 4, 1,  /* double */
        8, 4, 1,  /* long double */
        4, 4, 0,  /* T * */
        0, 1, 0,  /* struct */
        1,        /* little_endian */
        0,        /* mulops_calls */
        0,        /* wants_callb */
        1,        /* wants_argb */
        0,        /* left_to_right */
        0,        /* wants_dag */
        0,        /* unsigned_char */
        0, /* address */
        blockbeg,
        blockend,
        defaddress,
        defconst,
        defstring,
        defsymbol,
        emit,
        export,
        function,
        gen,
        global,
        import,
        0, /* local */
        progbeg,
        progend,
        segment,
        space,
        stabblock, stabend, 0, stabinit, stabline, stabsym, stabtype,
        {1, rmap,
            0, 0, 0,    /* blkfetch, blkstore, blkloop */
            _label,
            _rule,
            _nts,
            _kids,
            _string,
            _templates,
            _isinstruction,
            _ntname,
            emit2,
            0, /* doarg */
            target,
            clobber,
        }
};
